/*********************************************************************************************************************************
 * Copyright (c) Erik Kunze 1995 - 2007
 *
 * This file is a part of the Spectrum emulator package 'XZX-Pro', and may not be distributed.  The copyright holder makes no
 * representations about the suitability of this software for any purpose.  It is provided "as is" without express or implied
 * warranty. THE CODE MAY NOT BE MODIFIED OR REUSED WITHOUT PERMISSION!
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Erik Kunze
 *
 * $Id: config2.h,v 4.44 2006/12/22 14:29:59 erik Rel $
 ********************************************************************************************************************************/

#ifndef _XZX_CONFIG2_H
#define _XZX_CONFIG2_H

/*********************************************************************************************************************************
 * Do not change anything below this line
 ********************************************************************************************************************************/

#define USED(x)							(void)(x)

#if SIZEOF_CHAR != 1
#error "sizeof(char) is not equal to 8 bit"
#endif

#if SIZEOF_SHORT != 2
#error "sizeof(short) is not equal to 16 bit"
#endif

#if SIZEOF_INT != 4
#error "sizeof(int) is not equal to 32 bit"
#endif

#define EXTERN_Z80_TYPEDEFS
typedef unsigned char					uns8;
typedef unsigned short					uns16;
typedef unsigned int					uns32;
typedef signed char						sgn8;
typedef signed short					sgn16;
typedef signed int						sgn32;

#undef DEBUG_HALT
#undef DEBUG_R_REGISTER
#undef DEBUG_EVENTS
#undef BROKEN_VISUAL_SUPPORT
#define SPEEDUP_TRDOS
#define VIRTUAL_DISK_IMAGES


#if defined(XZX_PENTAGON) && defined(XZX_SCORPION)
#define PENTAGON_OR_SCORPION 			(CFGGET(machine) == SP_PENTAGON || CFGGET(machine) == SP_SCORPION)
#elif defined(XZX_PENTAGON)
#define PENTAGON_OR_SCORPION 			(CFGGET(machine) == SP_PENTAGON)
#elif defined(XZX_SCORPION)
#define PENTAGON_OR_SCORPION 			(CFGGET(machine) == SP_SCORPION)
#else
#define PENTAGON_OR_SCORPION 			0
#endif

#if defined(XZX_PENTAGON) || defined(XZX_SCORPION)
#ifndef XZX_TRDOS
#define XZX_TRDOS
#endif
#else
#undef XZX_KMOUSE
#endif

#ifdef XZX_TRDOS
#define XZX_DISK_DRIVES					4
#else
#define XZX_DISK_DRIVES					2
#undef VIRTUAL_DISK_IMAGES
#endif

#ifdef XZX_IF1
#define XZX_IF1_DRIVES					4
#undef XZX_IF1_NETWORK
#define XZX_IF1_RS232
#endif

#ifdef EVALUATION
#undef REAL_DISKS
#undef XZX_DIDAKTIK
#undef XZX_FULLER
#undef XZX_IF1_NETWORK
#undef XZX_IF1_PRINTER
#undef XZX_IF1_RS232
#undef XZX_LIGHTGUN
#undef XZX_PLUS3_PRINTER
#undef XZX_PLUSD
#undef XZX_PLUSD_PRINTER
#undef XZX_SCORPION_PRINTER
#undef XZX_SP128_PRINTER
#undef XZX_TRDOS
#undef XZX_ZX_PRINTER
#endif
#undef XZX_LIGHTGUN
#undef XZX_KMOUSE

#if defined(XZX_PLUS3_PRINTER) || defined(XZX_SCORPION_PRINTER) || defined(XZX_PLUSD_PRINTER)
#define XZX_CENTRONICS_PRINTER
#endif

#if defined(XZX_ZX_PRINTER) || defined(XZX_IF1_PRINTER) || defined(XZX_SP128_PRINTER) || defined(XZX_CENTRONICS_PRINTER)
#define XZX_PRINTER
#endif

#if defined(XZX_IF1_NETWORK) || defined(HAVE_VNCSERVER)
#undef XZX_NETWORK
#endif

#if defined(XZX_LIGHTGUN) || defined(XZX_KMOUSE)
#define XZX_XMOUSE
#endif

#endif /* ! _XZX_CONFIG2_H */

/* EOF **************************************************************************************************************************/
