/*********************************************************************************************************************************
 * Copyright (c) Erik Kunze 1995 - 2007
 *
 * This file is a part of the Spectrum emulator package 'XZX-Pro', and may not be distributed.  The copyright holder makes no
 * representations about the suitability of this software for any purpose.  It is provided "as is" without express or implied
 * warranty. THE CODE MAY NOT BE MODIFIED OR REUSED WITHOUT PERMISSION!
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Erik Kunze
 ********************************************************************************************************************************/
#ifndef _XZX_DDRIVE_H
#define _XZX_DDRIVE_H
typedef enum{DDRIVE_STATUS_OK=0,DDRIVE_STATUS_FAILED=-1,DDRIVE_STATUS_SEEKFAIL=-2,DDRIVE_STATUS_NOADDR=-3,DDRIVE_STATUS_NODATA=-4,DDRIVE_STATUS_DATAERR=-5,DDRIVE_STATUS_NOSECTOR=-6,DDRIVE_STATUS_NOTREADY=-7,DDRIVE_STATUS_WRITEPROT=-8,DDRIVE_STATUS_ECHECK=-9,DDRIVE_STATUS_OVERRUN=-10}DdriveStatus;typedef enum{DDRIVE_TYPE_3,DDRIVE_TYPE_35,DDRIVE_TYPE_525}DdriveType;typedef struct _ddrive Ddrive;typedef struct _sectorInfo{uns8 track;uns8 head;uns8 sector;uns8 bps;uns8 crc1;uns8 crc2;}DiskSectorInfo;typedef struct _diskVtable{void(*close)(Ddrive*);DdriveStatus(*seek)(Ddrive*,int);DdriveStatus(*readId)(Ddrive*,int,int,int,DiskSectorInfo*);uns8*(*readSector)(Ddrive*,int,int,int);uns8*(*writeSector)(Ddrive*,int,int,int);int(*isReady)(Ddrive*);}DiskVtable;typedef struct _diskFileDsk{uns8*mmp;size_t mmsize;int extended;uns8*trackInfo;}DiskFileDsk;typedef struct _diskFileTrd{uns8*mmp;size_t mmsize;int sides;int tracks;uns8*trackp;}DiskFileTrd;typedef struct _diskFileFdi{uns8*mmp;size_t mmsize;int sides;int tracks;uns8*trackInfoStart;uns8*trackInfo;uns8*trackDataStart;uns8*trackData;}DiskFileFdi;typedef struct _diskFileScl{uns8*mmp;size_t mmsize;}DiskFileScl;typedef struct _diskFileHob{uns8*mmp;size_t mmsize;}DiskFileHob;typedef struct _diskFileMgt{uns8*mmp;size_t mmsize;int sides;int tracks;uns8*trackp;}DiskFileMgt;typedef struct _diskFileImg{uns8*mmp;size_t mmsize;int sides;int tracks;uns8*trackp;}DiskFileImg;typedef struct _diskFileD80{uns8*mmp;size_t mmsize;int sides;int tracks;uns8*trackp;}DiskFileD80;typedef struct _diskFileFloppy{int fd;}DiskFileFloppy;typedef struct _disk{const char*filename;int readonly;union{DiskFileDsk dsk;DiskFileTrd trd;DiskFileFdi fdi;DiskFileScl scl;DiskFileHob hob;DiskFileMgt mgt;DiskFileImg img;DiskFileD80 d80;DiskFileFloppy floppy;}File;}Disk;struct _ddrive{DdriveType type;int id;int heads;int tracks;int head;int track;int sector;unsigned int motor:1;Disk disk;DiskVtable*vtable;int(*insert)(int);};
#define DdriveIsDS(ddp)	((ddp)->heads == 2)
#define DdriveIsAtTrack0(ddp)	((ddp)->track == 0)
#define DdriveIsLoaded(ddp)	((ddp)->disk.filename != (const char *)0)
#define DdriveIsWriteProtected(ddp)	((ddp)->disk.readonly != 0)
#define DdriveIsIndexHole(ddp)	((ddp)->sector == 0)
#define DdriveGetTrack(ddp)	((ddp)->track)
#define DdriveGetSide(ddp)	((ddp)->head)
#define DdriveSetSide(ddp,h)	(ddp)->head = (h)
#define DdriveSetInsert(ddp,f)	(ddp)->insert = (f)
extern Ddrive*DdriveNew(DdriveType,int,int);extern int DdriveInsertDisk(Ddrive*,const char*);extern void DdriveEjectDisk(Ddrive*);extern void DdriveMotor(Ddrive*,unsigned int);extern DdriveStatus DdriveSeek(Ddrive*,int);extern DdriveStatus DdriveReadId(Ddrive*,DiskSectorInfo*);extern uns8*DdriveReadSector(Ddrive*,int);extern uns8*DdriveWriteSector(Ddrive*,int);extern int DdriveIsReady(Ddrive*);
#endif 

