/*********************************************************************************************************************************
 * Copyright (c) Erik Kunze 1995 - 2007
 *
 * This file is a part of the Spectrum emulator package 'XZX-Pro', and may not be distributed.  The copyright holder makes no
 * representations about the suitability of this software for any purpose.  It is provided "as is" without express or implied
 * warranty. THE CODE MAY NOT BE MODIFIED OR REUSED WITHOUT PERMISSION!
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Erik Kunze
 ********************************************************************************************************************************/
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
#ifndef lint
static char rcsid[]="$Id: event.c,v 4.11 2006/12/22 14:28:54 erik Rel $";
#endif
#include <assert.h>
#include "z80/z80.h"
#include "util.h"
#include "event.h"
typedef struct _eventEntry{struct _eventEntry*next;EventFunc func;void*arg;unsigned int tstates;}eventEntry;
#define MAX_EVENTS	10
#define NO_EVENT	-1U
#ifdef DEBUG_EVENTS
#define DEB(x)	{ x }
#else
#define DEB(x)
#endif
#ifdef DEBUG_EVENTS
static void eventDump(void);
#endif
unsigned int EventNextTstates=NO_EVENT;static eventEntry eventTable[MAX_EVENTS]={{&eventTable[1],(EventFunc)0,(void*)0,0},{&eventTable[2],(EventFunc)0,(void*)0,0},{&eventTable[3],(EventFunc)0,(void*)0,0},{&eventTable[4],(EventFunc)0,(void*)0,0},{&eventTable[5],(EventFunc)0,(void*)0,0},{&eventTable[6],(EventFunc)0,(void*)0,0},{&eventTable[7],(EventFunc)0,(void*)0,0},{&eventTable[8],(EventFunc)0,(void*)0,0},{&eventTable[9],(EventFunc)0,(void*)0,0},{(eventEntry*)0,(EventFunc)0,(void*)0,0}};static eventEntry*eventFree=&eventTable[0],*eventUsed;EventId EventAdd(EventFunc func,void*arg,unsigned int tstates){eventEntry*ep,*new;DEB(Msg(M_DEBUG,"event: add%12u (%6u), %x",tstates,TSTATES,func););if(eventFree==(eventEntry*)0){Msg(M_FATAL,"event table overflow");}new=eventFree;eventFree=new->next;new->func=func;new->arg=arg;new->tstates=tstates;ep=eventUsed;if(ep==(eventEntry*)0||ep->tstates>tstates){new->next=ep;eventUsed=new;EventNextTstates=tstates;}else{while(ep->next!=(eventEntry*)0&&ep->next->tstates<=tstates){ep=ep->next;}new->next=ep->next;ep->next=new;assert(tstates>=EventNextTstates);}DEB(eventDump(););return(EventId)(new-eventTable);}void EventRemove(EventId slot,int call){eventEntry*ep,*entry=&eventTable[slot];ep=eventUsed;if(ep==entry){eventUsed=entry->next;}else{while(ep->next!=entry&&ep->next!=(eventEntry*)0){ep=ep->next;}assert(ep->next!=(eventEntry*)0);ep->next=entry->next;}DEB(Msg(M_DEBUG,"event: remove%9u (%6u), %x",ep->tstates,TSTATES,entry->func););if(call!=0){entry->func(entry->arg);}if(entry->tstates==EventNextTstates){EventNextTstates=NO_EVENT;for(ep=eventUsed;ep!=(eventEntry*)0;ep=ep->next){if(ep->tstates<EventNextTstates){EventNextTstates=ep->tstates;}}}entry->next=eventFree;eventFree=entry;DEB(eventDump(););}void EventRemoveAll(void){eventEntry*ep;for(ep=eventFree;ep->next!=(eventEntry*)0;ep=ep->next);ep->next=eventUsed;eventUsed=(eventEntry*)0;EventNextTstates=NO_EVENT;}void EventSchedule(void){eventEntry*ep;DEB(Msg(M_DEBUG,"event: schedule start%9u",EventNextTstates););for(ep=eventUsed;ep!=(eventEntry*)0&&ep->tstates<=TSTATES;ep=eventUsed){DEB(Msg(M_DEBUG,"event: schedule%7u (%6u), %x",ep->tstates,TSTATES,ep->func););eventUsed=ep->next;ep->func(ep->arg);ep->next=eventFree;eventFree=ep;}EventNextTstates=eventUsed==(eventEntry*)0?NO_EVENT:eventUsed->tstates;DEB(Msg(M_DEBUG,"event: schedule end%11u",EventNextTstates););}void EventAdjust(unsigned int adjust){eventEntry*ep;DEB(Msg(M_DEBUG,"event: adjust%7u",adjust););EventNextTstates=NO_EVENT;for(ep=eventUsed;ep!=(eventEntry*)0;ep=ep->next){assert(ep->tstates>=adjust);if((ep->tstates-=adjust)<EventNextTstates){EventNextTstates=ep->tstates;}}DEB(eventDump(););}
#ifdef DEBUG_EVENTS
static void eventDump(void){eventEntry*ep;Msg(M_DEBUG,"event: dump start");for(ep=eventUsed;ep!=(eventEntry*)0;ep=ep->next){Msg(M_DEBUG,"event: slot%3u, tstates%7u,  %x",(ep-eventTable),ep->tstates,ep->func);}Msg(M_DEBUG,"event: dump end");}
#endif

