/*********************************************************************************************************************************
 * Copyright (c) Erik Kunze 1995 - 2007
 *
 * This file is a part of the Spectrum emulator package 'XZX-Pro', and may not be distributed.  The copyright holder makes no
 * representations about the suitability of this software for any purpose.  It is provided "as is" without express or implied
 * warranty. THE CODE MAY NOT BE MODIFIED OR REUSED WITHOUT PERMISSION!
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Erik Kunze
 ********************************************************************************************************************************/
#ifndef _XZX_FILEIO_RZX_H
#define _XZX_FILEIO_RZX_H
#define RZX_LIBRARY_VERSION 0x000C
#define RZX_LIBRARY_BUILD 31
#define RZX_OK 0
#define RZX_NOTFOUND -1
#define RZX_INVALID -2
#define RZX_FINISHED -3
#define RZX_UNSUPPORTED -4
#define RZX_NOMEMORY -5
#define RZX_SYNCLOST -6
#define RZX_IDLE 0
#define RZX_PLAYBACK 1
#define RZX_RECORD 2
#define RZXMSG_CREATOR 1
#define RZXMSG_LOADSNAP 2
#define RZXMSG_IRBNOTIFY 3
#define RZX_PROTECTED 0x0001
#define RZX_SEALED 0x0002
#define RZX_REMOVE 0x0004
#define RZX_EXTERNAL 0x0008
#define RZX_COMPRESSED 0x0010
typedef uns32(*RZX_CALLBACK)(int msg,void*param);typedef struct{int mode;char filename[260];uns8 ver_major;uns8 ver_minor;uns32 options;}RZX_INFO;typedef struct{char name[20];uns16 ver_major;uns16 ver_minor;uns8*data;uns32 length;uns32 options;}RZX_EMULINFO;typedef struct{char filename[260];uns32 length;uns32 options;}RZX_SNAPINFO;typedef struct{uns32 framecount;uns32 tstates;uns32 options;}RZX_IRBINFO;int rzx_init(const RZX_EMULINFO*emul,const RZX_CALLBACK callback);int rzx_record(const char*filename);int rzx_playback(const char*filename);void rzx_close(void);int rzx_update(uns16*icount);void rzx_store_input(uns8 value);uns8 rzx_get_input(void);int rzx_add_snapshot(const char*filename,const uns32 flags);int rzx_add_comment(const char*text,const uns32 flags);extern RZX_INFO rzx;extern uns16 INcount;extern uns16 INmax;extern uns8*inputbuffer;
#endif 

