/*********************************************************************************************************************************
 * Copyright (c) Erik Kunze 1995 - 2007
 *
 * This file is a part of the Spectrum emulator package 'XZX-Pro', and may not be distributed.  The copyright holder makes no
 * representations about the suitability of this software for any purpose.  It is provided "as is" without express or implied
 * warranty. THE CODE MAY NOT BE MODIFIED OR REUSED WITHOUT PERMISSION!
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Erik Kunze
 ********************************************************************************************************************************/
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
#ifndef lint
static char rcsid[]="$Id: tap.c,v 4.45 2006/12/22 14:28:58 erik Rel $";
#endif
#include <sys/types.h>
#include <stdlib.h>
#include <assert.h>
#include "monitor/debug.h"
#include "ui/resource.h"
#include "util.h"
#include "tape.h"
#include "fileio/tap.h"
#ifdef DEBUG
#define DEB(x)	{ if (CFGGET(debug) & D_TAPE) { x } }
#else
#define DEB(x)
#endif
static void tapReadBlockEot(TapeRecord*,uns8**);static void tapReadBlockRom(TapeRecord*,uns8**);static int tapWriteBlockRom(TapeRecord*,FILE*);int TapRead(const char*filename){int readonly;size_t size;void*mmp;int ret=-1;readonly=1;if((mmp=Mmap(filename,1,&readonly,&size))!=(void*)-1){uns8*scanBegin,*scanEnd,*scanPtr;unsigned int bnr;TRY();scanBegin=(uns8*)mmp;scanEnd=(uns8*)mmp+size;scanPtr=scanBegin;bnr=0;for(;;){TapeRecord*tr=Malloc(sizeof(TapeRecord),"TapRead");(void)TapeInSetRecord(tr);tr->bnr=bnr++;if(scanPtr>=scanEnd){tapReadBlockEot(tr,&scanPtr);break;}DEB(Msg(M_DEBUG,"TAP: scaning, id = %02x, pos = %6d",scanPtr[2],scanPtr-scanBegin););tapReadBlockRom(tr,&scanPtr);}ret=0;CATCH(Msg(M_ERR,"corrupted input file"););Munmap(mmp,size);}return ret;}static void tapReadBlockEot(TapeRecord*tr,uns8**scanPtr){USED(scanPtr);tr->type=TAPE_BLOCK_EOT;tr->shortDesc="***      End Of Tape      ***";tr->longDesc="End of Tape";}static void tapReadBlockRom(TapeRecord*tr,uns8**scanPtr){TapeBlockRom*block=&tr->block.rom;char buf[512];int pos;tr->type=TAPE_BLOCK_ROM;block->length=Le2Cpu(*scanPtr,2);block->data=Malloc(sizeof(uns8)*(size_t)block->length,"tapReadBlockRom");(void)memcpy(block->data,*scanPtr+0x02,(size_t)block->length);block->pause=*block->data==0x00 ?100:1000;tr->shortDesc=TapeIdentifyBlock(block->length,block->data,1);pos=sprintf(buf,"Standard\n""Length           : %6u bytes\n",block->length>=2?block->length-2:0);if(block->length!=0){pos+=sprintf(&buf[pos],"Flag             :   0x%02X\n""CheckSum         :   0x%02X\n",(unsigned int)block->data[0],(unsigned int)block->data[block->length-1]);}(void)sprintf(&buf[pos],"Pause after block: %6u ms",block->pause);tr->longDesc=Strdup(buf,"tapReadBlockRom");*scanPtr+=0x02 +block->length;}int TapWrite(const char*filename){FILE*fp;int ret=-1;if((fp=Fopen(filename,"wb"))!=(FILE*)0){unsigned int bnr,blocks;blocks=TapeOutGetBlocks();for(bnr=0;bnr<blocks;bnr++){TapeRecord*tr=TapeOutGetRecord(bnr);assert(tr!=(TapeRecord*)0);switch(tr->type){case TAPE_BLOCK_ROM:ret=tapWriteBlockRom(tr,fp);break;case TAPE_BLOCK_COMMENT:ret=0;break;default:assert(0);break;}if(ret!=0){break;}}if(ret!=0){Msg(M_PERR,"couldn't write file <%s>",filename);}(void)fclose(fp);}return ret;}static int tapWriteBlockRom(TapeRecord*tr,FILE*fp){TapeBlockRom*block=&tr->block.rom;size_t length;length=(size_t)block->length;(void)fputc((int)(length&0x00ff),fp);(void)fputc((int)((length&0xff00)>>8),fp);return(fwrite(block->data,length,1,fp)==1?0:-1);}
