/*********************************************************************************************************************************
 * Copyright (c) Erik Kunze 1995 - 2007
 *
 * This file is a part of the Spectrum emulator package 'XZX-Pro', and may not be distributed.  The copyright holder makes no
 * representations about the suitability of this software for any purpose.  It is provided "as is" without express or implied
 * warranty. THE CODE MAY NOT BE MODIFIED OR REUSED WITHOUT PERMISSION!
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Erik Kunze
 ********************************************************************************************************************************/
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
#ifndef lint
static char rcsid[]="$Id: ay.c,v 4.4 2006/12/22 14:29:00 erik Rel $";
#endif
#include <assert.h>
#include "monitor/debug.h"
#include "ui/resource.h"
#include "machine/machine.h"
#include "util.h"
#ifdef XZX_LIGHTGUN
#include "machine/lightgun.h"
#endif
#ifdef XZX_PRINTER
#include "printer/printer.h"
#endif
#include "sound/sound.h"
#include "machine/ay.h"
#define B_TXD	0x08
#define B_DTR	0x40
#ifdef DEBUG
#define DEB(x)	{ if ((CFGGET(debug) & D_IO) != 0) { x } }
#else
#define DEB(x)
#endif
static uns8 ayMask[16]={0xff,0x0f,0xff,0x0f,0xff,0x0f,0x1f,0xff,0x1f,0x1f,0x1f,0xff,0xff,0x0f,0xff,0xff };void AyReset(void){int i;for(i=NELEM(Machine->ay.registers)-1;i>=0;i--){AyRegisterOutByte(i);AyDataOutByte(0);}}void AyRegisterOutByte(uns8 val){Machine->ay.current=val;}void AyDataOutByte(uns8 val){int current=Machine->ay.current;if(current<NELEM(Machine->ay.registers)){Machine->ay.registers[current]=val;if(current==14){DEB(Msg(M_DEBUG,"writing AY register 14"););
#ifdef XZX_SP128_PRINTER
if(CFGGET(machine)==SP_128||CFGGET(machine)==SP_3){Sp128SerialOutByte(val&B_TXD);}
#endif
}else if(current<14){Ay8912OutByte(current,val);}}else{DEB(Msg(M_DEBUG,"writing AY register %d",current););}}uns8 AyRegisterInByte(void){int current=Machine->ay.current;uns8 res;if(current==14){DEB(Msg(M_DEBUG,"reading AY register 14"););res=0xbf;
#ifdef XZX_LIGHTGUN
if(CFGGET(machine)==SP_128||CFGGET(machine)==SP_3){res=LightgunStatus();}
#endif
#ifdef XZX_SP128_PRINTER
if(CFGGET(machine)==SP_128||CFGGET(machine)==SP_3){res|=Sp128SerialStatus()!=0?B_DTR:0x00;}
#endif
res&=Machine->ay.registers[7]&0x40 ?Machine->ay.registers[14]:0xff;}else if(current<14){res=Machine->ay.registers[current]&ayMask[current];}else if(current==15){res=Machine->ay.registers[7]&0x80 ?Machine->ay.registers[15]:0xff;}else{assert(Machine->ay.type!=AY_TYPE_NONE);res=Machine->ay.type==AY_TYPE_AY8912?0x00 :0xff;}return res;}uns8 AyDataInByte(void){return 0xff;}
