/*********************************************************************************************************************************
 * Copyright (c) Erik Kunze 1995 - 2007
 *
 * This file is a part of the Spectrum emulator package 'XZX-Pro', and may not be distributed.  The copyright holder makes no
 * representations about the suitability of this software for any purpose.  It is provided "as is" without express or implied
 * warranty. THE CODE MAY NOT BE MODIFIED OR REUSED WITHOUT PERMISSION!
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Erik Kunze
 ********************************************************************************************************************************/
#ifndef _XZX_MACHINE_IF1_H
#define _XZX_MACHINE_IF1_H
#include <sys/types.h>
#include "ui/resource.h"
#include "machine/machine.h"
#define RS232_IP_BPT	0xfe
#define RS232_OP_BPT	0xff
#define IF1_CHECK_AND_PAGEIN(pc) {	if (CFGGET(if1) > 0 && ((pc) == 0x0008 || (pc) == 0x1708) && RPAGE(0) == Machine->basicRom)	{	Machine->pageIn(0, IF1ROM);	}	}
#define IF1_CHECK_AND_PAGEOUT(pc) {	if (CFGGET(if1) > 0 && (pc) == 0x0700 && RPAGE(0) == IF1ROM)	{	Machine->pageIn(0, Machine->basicRom);	}	}
#define IF1_OUTBYTE(port,val) {	if (CFGGET(if1) > 0)	{	if (((port) & B_IF1_MDDATA) == (P_IF1_MDDATA & B_IF1_MDDATA))	{	If1DataOutByte(val);	}	else if (((port) & B_IF1_MDCONTROL) == (P_IF1_MDCONTROL & B_IF1_MDCONTROL))	{	If1ControlOutByte(val);	}	else if (((port) & B_IF1_NETWORK) == (P_IF1_NETWORK & B_IF1_NETWORK))	{	If1NetworkOutByte(val);	}	}	}
#define IF1_INBYTE(port,res,attached) {	if (CFGGET(if1) > 0)	{	if (((port) & B_IF1_MDDATA) == (P_IF1_MDDATA & B_IF1_MDDATA))	{	(res) &= If1DataInByte();	attached++;	}	else if (((port) & B_IF1_MDCONTROL) == (P_IF1_MDCONTROL & B_IF1_MDCONTROL))	{	(res) &= If1ControlInByte();	attached++;	}	else if (((port) & B_IF1_NETWORK) == (P_IF1_NETWORK & B_IF1_NETWORK))	{	(res) &= If1NetworkInByte();	attached++;	}	}	}
#define CARTRIDGE_SIZE	137923
#define CARTRIDGE_SECSIZE	543
#define CARTRIDGE_SECNUM	254
typedef struct _Cartridge{const char*filename;int readonly;uns8*mmp;size_t mmsize;}Cartridge;typedef struct _Mdrive{int id;unsigned int motor:1;unsigned int pos;Cartridge cartridge;}Mdrive;extern void If1Init(void);extern int If1InsertCart(int);extern void If1EjectCart(int);extern void If1ControlOutByte(uns8);extern void If1DataOutByte(uns8);extern void If1NetworkOutByte(uns8);extern uns8 If1ControlInByte(void);extern uns8 If1DataInByte(void);extern uns8 If1NetworkInByte(void);extern void If1Rs232Set(int);extern void If1Rs232InByte(void);extern void If1Rs232OutByte(void);
#endif 

