/*********************************************************************************************************************************
 * Copyright (c) Erik Kunze 1995 - 2007
 *
 * This file is a part of the Spectrum emulator package 'XZX-Pro', and may not be distributed.  The copyright holder makes no
 * representations about the suitability of this software for any purpose.  It is provided "as is" without express or implied
 * warranty. THE CODE MAY NOT BE MODIFIED OR REUSED WITHOUT PERMISSION!
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Erik Kunze
 ********************************************************************************************************************************/
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
#ifdef XZX_KMOUSE
#ifndef lint
static char rcsid[]="$Id: kmouse.c,v 4.27 2006/12/22 14:29:01 erik Rel $";
#endif
#include "monitor/debug.h"
#include "ui/resource.h"
#include "util.h"
#include "ui/xmouse.h"
#include "machine/kmouse.h"
#define L_BUTTON	0x02
#define M_BUTTON	0x04
#define R_BUTTON	0x01
#ifdef DEBUG
#define DEB(x)	{ { x } }
#else
#define DEB(x)
#endif
static void kmouseEventHandler(XmouseEvent*);uns8 KmouseX,KmouseY,KmouseButtons;static XmouseId id;void KmouseInit(void){if(CFGGET(kmouse)>0){CFGSET(kmouse,0);KmouseOn();}}void KmouseOn(void){if(CFGGET(kmouse)==0){CFGSET(kmouse,1);KmouseX=0;KmouseY=0;KmouseButtons=0xff;id=XmouseAdd(kmouseEventHandler,"KmouseOn");}}void KmouseOff(void){if(CFGGET(kmouse)!=0){CFGSET(kmouse,0);XmouseRemove(id);}}static void kmouseEventHandler(XmouseEvent*ev){uns8 mask;switch(ev->type){case XMOUSE_BUTTON:switch(ev->button.button){case XMOUSE_BUTTON_L:mask=L_BUTTON;break;case XMOUSE_BUTTON_M:mask=M_BUTTON;break;case XMOUSE_BUTTON_R:mask=R_BUTTON;break;default:mask=0xff;break;}if(ev->button.state==XMOUSE_BUTTON_PRESS){KmouseButtons&=~mask;}else{KmouseButtons|=mask;}break;case XMOUSE_MOTION:
#if 0
KmouseX-=(x-xev->xmotion.x)/CFGGET(scale);KmouseY+=(y-xev->xmotion.y)/CFGGET(scale);if((x<ZONE_OFFSET||y<ZONE_OFFSET||x>((int)(XwinDataP->hsize)-ZONE_OFFSET)||y>((int)(XwinDataP->vsize)-ZONE_OFFSET))){x=XwinDataP->hsize>>1;y=XwinDataP->vsize>>1;(void)XWarpPointer(XtDisplay(w),XtWindow(w),XtWindow(w),0,0,0U,0U,x,y);}else{x=xev->xmotion.x;y=xev->xmotion.y;}
#endif
break;}}
#endif 

