/*********************************************************************************************************************************
 * Copyright (c) Erik Kunze 1995 - 2007
 *
 * This file is a part of the Spectrum emulator package 'XZX-Pro', and may not be distributed.  The copyright holder makes no
 * representations about the suitability of this software for any purpose.  It is provided "as is" without express or implied
 * warranty. THE CODE MAY NOT BE MODIFIED OR REUSED WITHOUT PERMISSION!
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Erik Kunze
 ********************************************************************************************************************************/
#ifndef _XZX_MACHINE_MULTIFACE_H
#define _XZX_MACHINE_MULTIFACE_H
#include "z80/z80.h"
#include "ui/resource.h"
#include "machine/machine.h"
#define MF1_INBYTE(port,res,attached) {	if (CFGGET(mf1) > 0)	{	uns8 lowbyte = LOWBYTE((port));	if (lowbyte == P_MF1_OUT)	{ if (RPAGE(0) == MF1ROM)	{	Machine->pageIn(0, SP48ROM);	}	(attached)++;	}	else if (lowbyte == P_MF1_IN)	{	Machine->pageIn(0, MF1ROM);	(attached)++;	}	}	}
#define MF128_INBYTE(port,res,label) {	if (CFGGET(mf128) > 0)	{	uns8 lowbyte = LOWBYTE((port));	if (lowbyte == P_MF128_OUT)	{	if (RPAGE(0) == MF128ROM)	{	Machine->pageIn(0, SP128ROM0 + ((Machine->lastMem128 & B_SP128_SELROM) >> 4));	}	(attached)++;	}	else if (lowbyte == P_MF128_IN)	{	Machine->pageIn(0, MF128ROM);	(res) &= Machine->lastMem128 & B_SP128_SELSCREEN ? 0xff : 0x7f;	(attached)++;	}	}	}
#define MF3_INBYTE(port,res,attached) {	if (CFGGET(mf3) > 0)	{	uns8 lowbyte = LOWBYTE((port));	if (lowbyte == P_MF3_OUT)	{	if (Multiface3Paged != 0)	{	if (!EXTENDED_RAM(Machine->lastMem3))	{	Machine->pageIn(0, SP3ROM0 +	(((Machine->lastMem128 & B_SELROM) >> 4) | ((Machine->lastMem3 & B_SELROMX) >> 1)));	}	Multiface3Paged = 0;	}	(attached)++;	}	else if (lowbyte == P_MF3_IN)	{	if (Multiface3Paged == 0)	{	if (!EXTENDED_RAM(Machine->lastMem3))	{	Machine->pageIn(0, MF3ROM);	}	Multiface3Paged = 1;	}	if ((port) == P_MF3_P7FFD)	{	(res) &= Machine->lastMem128;	}	else if ((port) == P_MF3_P1FFD)	{	(res) &= Machine->lastMem3;	}	(attached)++;	}	}	}
extern void MultifaceInit(void);extern int Multiface3Paged;
#endif 

