/*********************************************************************************************************************************
 * Copyright (c) Erik Kunze 1995 - 2007
 *
 * This file is a part of the Spectrum emulator package 'XZX-Pro', and may not be distributed.  The copyright holder makes no
 * representations about the suitability of this software for any purpose.  It is provided "as is" without express or implied
 * warranty. THE CODE MAY NOT BE MODIFIED OR REUSED WITHOUT PERMISSION!
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Erik Kunze
 ********************************************************************************************************************************/
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
#ifndef lint
static char rcsid[]="$Id: sjoy.c,v 4.6 2006/12/22 14:29:01 erik Rel $";
#endif
#include "monitor/debug.h"
#include "ui/resource.h"
#include "machine/machine.h"
#include "util.h"
#include "joystick.h"
#include "machine/sjoy.h"
#define B_RIGHT1	0x08
#define B_LEFT1	0x10
#define B_DOWN1	0x04
#define B_UP1	0x02
#define B_FIRE1	0x01
#define B_RIGHT2	0x02
#define B_LEFT2	0x01
#define B_DOWN2	0x04
#define B_UP2	0x08
#define B_FIRE2	0x10
#ifdef DEBUG
#define DEB(x)	{ if ((CFGGET(debug) & D_JOYSTICK) != 0) { x } }
#else
#define DEB(x)
#endif
uns8 SjoyInByte(uns16 port){uns8 res=0xff;
#ifdef HAVE_JOYSTICK
if(CFGGET(joy)>0){JoyRead();}
#endif
if((port&B_SINCLAIR1)==0){res&=~((JOY_PRESSED(left)?B_LEFT1:0)|(JOY_PRESSED(right)?B_RIGHT1:0)|(JOY_PRESSED(up)?B_UP1:0)|(JOY_PRESSED(down)?B_DOWN1:0)|(JOY_PRESSED(fire)?B_FIRE1:0));}if((port&B_SINCLAIR2)==0){res&=~((JOY_PRESSED(left)?B_LEFT2:0)|(JOY_PRESSED(right)?B_RIGHT2:0)|(JOY_PRESSED(up)?B_UP2:0)|(JOY_PRESSED(down)?B_DOWN2:0)|(JOY_PRESSED(fire)?B_FIRE2:0));}DEB(Msg(M_DEBUG,"reading <%02x> from Sinclair joystick",res););return res;}
