/*********************************************************************************************************************************
 * Copyright (c) Erik Kunze 1995 - 2007
 *
 * This file is a part of the Spectrum emulator package 'XZX-Pro', and may not be distributed.  The copyright holder makes no
 * representations about the suitability of this software for any purpose.  It is provided "as is" without express or implied
 * warranty. THE CODE MAY NOT BE MODIFIED OR REUSED WITHOUT PERMISSION!
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Erik Kunze
 ********************************************************************************************************************************/
#ifndef _XZX_MACHINE_TRDOS_H
#define _XZX_MACHINE_TRDOS_H
#include "ui/resource.h"
#include "machine/machine.h"
#define TRDOS_CHECK(rom,pc) {	if (CFGGET(trdos) > 0)	{	TRDOS_CHECK2((rom), (pc))	}	}
#define TRDOS_CHECK2(rom,pc) {	if (pc >= 0x4000)	{	if (RPAGE(0) == (rom))	{	Machine->pageIn(0, Machine->basicRom);	}	}	else if ((pc & 0xff00) == 0x3d00)	{	if (RPAGE(0) == Machine->basicRom)	{	Machine->pageIn(0, (rom));	}	}	}
#define TRDOS_OUTBYTE(rom,port,val) {	if (RPAGE(0) == (rom))	{	TRDOS_OUTBYTE2(port,val)	}	}
#define TRDOS_OUTBYTE2(port,val) {	uns8 lowport = LOWBYTE((port));	if (lowport == P_TRDOS_CMD)	{	TrdosCmdOutByte((val));	}	else if (lowport == P_TRDOS_TRACK)	{	TrdosTrackOutByte((val));	}	else if (lowport == P_TRDOS_SECTOR)	{	TrdosSectorOutByte((val));	}	else if (lowport == P_TRDOS_DATA)	{	TrdosDataOutByte((val));	}	else if (lowport == P_TRDOS_SYSTEM)	{	TrdosSystemOutByte((val));	}	}
#define TRDOS_INBYTE(rom,port,res,attached) {	if (RPAGE(0) == (rom))	{	TRDOS_INBYTE2(port,res,attached)	}	}
#define TRDOS_INBYTE2(port,res,attached) {	uns8 lowport = LOWBYTE(port);	if (lowport == P_TRDOS_STATE)	{	(res) &= TrdosStateInByte();	(attached)++;	}	else if (lowport == P_TRDOS_TRACK)	{	(res) &= TrdosTrackInByte();	(attached)++;	}	else if (lowport == P_TRDOS_SECTOR)	{	(res) &= TrdosSectorInByte();	(attached)++;	}	else if (lowport == P_TRDOS_DATA)	{	(res) &= TrdosDataInByte();	(attached)++;	}	else if (lowport == P_TRDOS_SYSTEM)	{	(res) &= TrdosSystemInByte();	(attached)++;	}	}
extern void TrdosInit(void);extern void TrdosReset(void);extern void TrdosCmdOutByte(uns8);extern void TrdosTrackOutByte(uns8);extern void TrdosSectorOutByte(uns8);extern void TrdosDataOutByte(uns8);extern void TrdosSystemOutByte(uns8);extern uns8 TrdosStateInByte(void);extern uns8 TrdosTrackInByte(void);extern uns8 TrdosSectorInByte(void);extern uns8 TrdosDataInByte(void);extern uns8 TrdosSystemInByte(void);extern int TrdosInsertDisk(int);extern void TrdosEjectDisk(int);
#endif 

