/*********************************************************************************************************************************
 * Copyright (c) Erik Kunze 1995 - 2007
 *
 * This file is a part of the Spectrum emulator package 'XZX-Pro', and may not be distributed.  The copyright holder makes no
 * representations about the suitability of this software for any purpose.  It is provided "as is" without express or implied
 * warranty. THE CODE MAY NOT BE MODIFIED OR REUSED WITHOUT PERMISSION!
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Erik Kunze
 ********************************************************************************************************************************/
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
#ifndef lint
static char rcsid[]="$Id: main.c,v 4.56 2006/12/22 14:28:54 erik Rel $";
#endif
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <signal.h>
#include <string.h>
#include "ui/resource.h"
#include "machine/machine.h"
#include "util.h"
#include "emul.h"
#include "joystick.h"
#ifdef XZX_PRINTER
#include "printer/printer.h"
#endif
#include "ui/screen.h"
#include "snapshot.h"
#include "sound/sound.h"
#include "tape.h"
#include "ui/ui.h"
#ifdef HAVE_VNCSERVER
#include "netplay/vncserver.h"
#endif
#ifndef DEBUG
#include "ui/xcons.h"
#endif
#include "ui/xwin.h"
#include "main.h"
static void initEmulator(int,const char**);static void catchSignals(int);const char*ProgName;const char*Version;int main(int argc,const char**argv){const char*s;if((s=strrchr(argv[0],'/'))!=(char*)0){ProgName=++s;}else{ProgName=argv[0];}
#ifdef EVALUATION
Version="XZX-Pro "VERSION" (Eval)";
#else
Version="XZX-Pro "VERSION;
#endif
initEmulator(argc,argv);EmulLoop();return 0;}static void initEmulator(int ac,const char**av){struct sigaction sigact;unsigned int i;sigact.sa_handler=SIG_IGN;(void)sigemptyset(&sigact.sa_mask);
#ifdef SA_RESTART
sigact.sa_flags=SA_RESTART;
#else
sigact.sa_flags=0;
#endif
(void)sigaction(SIGINT,&sigact,(struct sigaction*)0);(void)sigaction(SIGHUP,&sigact,(struct sigaction*)0);(void)sigaction(SIGTERM,&sigact,(struct sigaction*)0);(void)sigaction(SIGQUIT,&sigact,(struct sigaction*)0);
#ifdef SIG_XCPU
(void)sigaction(SIG_XCPU,&sigact,(struct sigaction*)0);
#endif
(void)sigaction(SIGPIPE,&sigact,(struct sigaction*)0);sigact.sa_handler=catchSignals;(void)sigaction(SIGSEGV,&sigact,(struct sigaction*)0);XwinInit(&ac,av);
#ifndef DEBUG
XconsInit();
#endif
UiInit(av[1]==(const char*)0?1:0);
#ifdef HAVE_VNCSERVER
VncServerInit();
#endif
MachineInit();SoundInit();TapeInit();JoyInit();
#ifdef XZX_PRINTER
PrinterInit();
#endif
MachineSelect(CFGGET(machine),1);if(av[1]==(const char*)0||SnapshotRead(av[1])<0){srand((unsigned int)getpid());for(i=DFILE;i<(DFILE+PIXEL_LENGTH+ATTR_LENGTH);i++){MEM(i)=(uns8)rand();}}ScreenRefresh();(void)sigaction(SIGINT,&sigact,(struct sigaction*)0);(void)sigaction(SIGHUP,&sigact,(struct sigaction*)0);(void)sigaction(SIGTERM,&sigact,(struct sigaction*)0);(void)sigaction(SIGQUIT,&sigact,(struct sigaction*)0);(void)sigaction(SIGSEGV,&sigact,(struct sigaction*)0);}static void catchSignals(int signo){static int core=0;if(signo==SIGSEGV){if(++core>1){exit(3);}Msg(M_ERR,"signal handler caught signal SIGSEGV");Msg(M_ERR,"send a bug report to xzx-bug@zx-spectrum.net");if(CFGGET(core)!=0){abort();}}exit(2);}
