/*********************************************************************************************************************************
 * Copyright (c) Erik Kunze 1995 - 2007
 *
 * This file is a part of the Spectrum emulator package 'XZX-Pro', and may not be distributed.  The copyright holder makes no
 * representations about the suitability of this software for any purpose.  It is provided "as is" without express or implied
 * warranty. THE CODE MAY NOT BE MODIFIED OR REUSED WITHOUT PERMISSION!
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Erik Kunze
 ********************************************************************************************************************************/
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
#ifdef DEBUG
#ifndef lint
static char rcsid[]="$Id: debug.c,v 4.19 2006/12/22 14:29:04 erik Rel $";
#endif
#include <stdio.h>
#include "z80/z80.h"
#include "ui/resource.h"
#include "machine/machine.h"
#include "monitor/dis.h"
#include "monitor/debug.h"
void DebugZ80(void){char buf[80];uns16 addr;int i;if((CFGGET(debug)&D_CPU)!=0){(void)fprintf(stderr,"Z80 CPU State\n-------------\n");(void)fprintf(stderr,"  AF  = %04X\t\tAF' = %04X\n",AF,AF1);(void)fprintf(stderr,"  BC  = %04X\t\tBC' = %04X\n",BC,BC1);(void)fprintf(stderr,"  DE  = %04X\t\tDE' = %04X\n",DE,DE1);(void)fprintf(stderr,"  HL  = %04X\t\tHL' = %04X\n",HL,HL1);(void)fprintf(stderr,"  IX  = %04X\t\tIY  = %04X\n\n",IX,IY);(void)fprintf(stderr,"  PC  = %04X\t\tSP  = %04X\n",PC,SP);(void)fprintf(stderr,"   R  = %02X\t\t I  = %02X\n\n",R,I);(void)fprintf(stderr,"  interrupts %sabled, IM%d\n",IFF1==0?"dis":"en",IM);(void)fprintf(stderr,"  FLAGS: C=%d N=%d P/V=%d H=%d Z=%d S=%d\n\n",TST(FLAG_C),TST(FLAG_N),TST(FLAG_P),TST(FLAG_H),TST(FLAG_Z),TST(FLAG_S));}if((CFGGET(debug)&D_SYSVAR)!=0){for(addr=0x5c00;addr<0x5d00;){(void)fprintf(stderr,"%04x ",addr);for(i=0;i<16;i++,addr++){(void)fprintf(stderr," %02x",MEM(addr));}(void)putc('\n',stderr);}(void)putc('\n',stderr);}if((CFGGET(debug)&D_MNEMO)!=0){(void)Disassemble(buf,PC);(void)fprintf(stderr,"%04X\t%s\n",PC,buf);if((CFGGET(debug)&(D_CPU|D_SYSVAR))!=0){(void)putc('\n',stderr);}}}
#endif 

