/*********************************************************************************************************************************
 * Copyright (c) Erik Kunze 1995 - 2007
 *
 * This file is a part of the Spectrum emulator package 'XZX-Pro', and may not be distributed.  The copyright holder makes no
 * representations about the suitability of this software for any purpose.  It is provided "as is" without express or implied
 * warranty. THE CODE MAY NOT BE MODIFIED OR REUSED WITHOUT PERMISSION!
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Erik Kunze
 ********************************************************************************************************************************/
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
#ifndef lint
static char rcsid[]="$Id: snapshot.c,v 4.57 2006/12/22 14:28:54 erik Rel $";
#endif
#include <stdlib.h>
#include <string.h>
#include <assert.h>
#include "z80/z80.h"
#include "monitor/debug.h"
#include "ui/resource.h"
#include "machine/machine.h"
#include "util.h"
#include "fileio/dat.h"
#include "ui/screen.h"
#include "fileio/slt.h"
#include "fileio/sna.h"
#include "fileio/z80.h"
#include "snapshot.h"
#ifdef DEBUG
#define DEB(x)	{ if ((CFGGET(debug) & D_SNAP) != 0) { x } }
#else
#define DEB(x)
#endif
static const char*snapshotLastFname=(const char*)0;int SnapshotRead(const char*filename){int ret=-1;DEB(Msg(M_DEBUG,"last snaphot was <%s>",GetBaseName(snapshotLastFname));Msg(M_DEBUG,"now loading <%s>",GetBaseName(filename)););Machine->reset();switch(GetFileType(filename)){case FILE_TYPE_UNKNOWN:case FILE_TYPE_SNA:ret=SnaRead(filename);break;case FILE_TYPE_Z80:ret=Z80Read(filename);break;case FILE_TYPE_SLT:ret=SltRead(filename);break;default:assert(0);break;}ScreenMarkDirtyAll();if(snapshotLastFname!=(const char*)0){free((void*)snapshotLastFname);}snapshotLastFname=ret==0?Strdup(filename,"SnapshotRead"):(const char*)0;return ret;}int SnapshotReadLevel(unsigned int level,unsigned int addr){int(*func)(const char*,unsigned int,unsigned int);int ret=0;if(snapshotLastFname!=(const char*)0){if(!READ_ONLY(addr)){func=GetFileType(snapshotLastFname)==FILE_TYPE_SLT?SltReadLevel:DatReadLevel;if(func(snapshotLastFname,level,addr)<0){CCF();}ret=0;}else{Msg(M_WARN,"attempt to read level into ROM - ignored");}}else{Msg(M_WARN,"no previous snapshot name - multiload ignored");}return ret;}int SnapshotWrite(const char*filename){FileType type;int ret=-1;type=GetFileType(filename);if(CFGGET(machine)>SP_48_3&&type!=FILE_TYPE_SLT){type=FILE_TYPE_Z80;}switch(type){case FILE_TYPE_SNA:ret=SnaWrite(filename);break;case FILE_TYPE_UNKNOWN:case FILE_TYPE_Z80:ret=Z80Write(filename);break;case FILE_TYPE_SLT:if(snapshotLastFname==(const char*)0||GetFileType(snapshotLastFname)!=FILE_TYPE_SLT){Msg(M_WARN,"attempt to write SLT snapshots in non-SLT mode - ignored");}else if(strcmp(snapshotLastFname,filename)==0){Msg(M_WARN,"attempt to overwrite current SLT - ignored");}else{ret=SltWrite(filename,snapshotLastFname);}break;default:assert(0);break;}return ret;}
