/*********************************************************************************************************************************
 * Copyright (c) Erik Kunze 1995 - 2007
 *
 * This file is a part of the Spectrum emulator package 'XZX-Pro', and may not be distributed.  The copyright holder makes no
 * representations about the suitability of this software for any purpose.  It is provided "as is" without express or implied
 * warranty. THE CODE MAY NOT BE MODIFIED OR REUSED WITHOUT PERMISSION!
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Erik Kunze
 ********************************************************************************************************************************/
#ifndef _XZX_SOUND_SOUND_H
#define _XZX_SOUND_SOUND_H
#include "sound/speaker.h"
#include "sound/ay8912.h"
typedef enum{SOUND_ACTION_INIT,SOUND_ACTION_ON,SOUND_ACTION_OFF,SOUND_ACTION_SUSPEND,SOUND_ACTION_RESUME}SoundAction;typedef enum{SOUND_STATE_NONEXIST,SOUND_STATE_OPENED,SOUND_STATE_CLOSED,SOUND_STATE_AUTOCLOSED}SoundState;typedef struct _SoundData{SoundState state;unsigned int spVol;unsigned char*spBuf;unsigned int ayVol;unsigned char*ayBuf;unsigned int sampleRate;unsigned int sampleBits;unsigned int stereo:1;unsigned int nonblocking:1;unsigned int tstatesPerSample;unsigned int samplesPerFrame;}SoundData;
#define SoundIsStereo()	(SoundDataP->stereo != 0)
#define SoundGetSpeaker()	SoundDataP->spVol
#define SoundGetAY()	SoundDataP->ayVol
extern void SoundInit(void);extern void SoundControl(SoundAction);extern void SoundSetSpeaker(unsigned int);extern void SoundSetAy(unsigned int);extern void SoundPlayBuffer(void);extern void(*SpeakerOutByte)(uns8);extern void(*Ay8912OutByte)(uns8,uns8);extern SoundData*SoundDataP;extern int OsdOpenAudioDevice(const char*,int*,int*,int*,int*);extern void OsdCloseAudioDevice(void);extern int OsdDrainAudioDevice(void);extern int OsdGetAudioFreespace(void);extern int OsdPlayAudioBuffer(unsigned char*,int);
#endif 

