/*********************************************************************************************************************************
 * Copyright (c) Erik Kunze 1995 - 2007
 *
 * This file is a part of the Spectrum emulator package 'XZX-Pro', and may not be distributed.  The copyright holder makes no
 * representations about the suitability of this software for any purpose.  It is provided "as is" without express or implied
 * warranty. THE CODE MAY NOT BE MODIFIED OR REUSED WITHOUT PERMISSION!
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Erik Kunze
 ********************************************************************************************************************************/
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
#ifndef lint
static char rcsid[]="$Id: sound_aix.c,v 4.8 2006/12/22 14:29:13 erik Rel $";
#endif
#include <sys/types.h>
#include <signal.h>
#include <assert.h>
#include <UMS/UMSAudioDevice.h>
#include <UMS/UMSBAUDDevice.h>
#include "monitor/debug.h"
#include "ui/resource.h"
#include "util.h"
#include "sound/sound.h"
#ifdef DEBUG
#define DEB(x)	{ if ((CFGGET(debug) & D_SOUND) != 0) { x } }
#else
#define DEB(x)
#endif
static Environment*ev;static UMSBAUDDevice audioDevice=(UMSBAUDDevice)0;static UMSAudioTypes_Buffer audioBuffer;static int audioShift;static sigset_t blockingSet;int OsdOpenAudioDevice(const char*device,int*nonblocking,int*sample,int*bits,int*stereo){UMSAudioDevice_ReturnCode rc;long i;Msg(M_INFO,"*******************************************************");Msg(M_INFO,"This audio driver is experimental, because I don't have");Msg(M_INFO,"access to any system running AIX. Please get in contact");Msg(M_INFO,"with me so I can improve the driver.");Msg(M_INFO,"*******************************************************");ev=somGetGlobalEnvironment();audioDevice=UMSBAUDDeviceNew();(void)UMSAudioDevice_open(audioDevice,ev,device,"PLAY",UMSAudioDevice_BlockingIO);if(audioDevice==(UMSBAUDDevice)0){Msg(M_ERR,"couldn't create audio device object");return-2;}if(UMSAudioDevice_set_volume(audioDevice,ev,100L)<0||UMSAudioDevice_set_balance(audioDevice,ev,0L)<0||UMSAudioDevice_set_time_format(audioDevice,ev,UMSAudioTypes_Msecs)<0||UMSAudioDevice_set_byte_order(audioDevice,ev,"LSB")<0){Msg(M_ERR,"couldn't set audio-device parameters");goto error;}i=(long)*sample;if(UMSAudioDevice_set_sample_rate(audioDevice,ev,i,&i)<0){Msg(M_ERR,"couldn't set sample rate to %ld Hz",i);goto error;}if((int)i!=*sample){Msg(M_WARN,"using different sample rate (requested %d Hz, got %ld Hz)",*sample,i);}*sample=(int)i;i=(long)*bits;if((rc=UMSAudioDevice_set_bits_per_sample(audioDevice,ev,i))<0){if(i==16L){Msg(M_WARN,"couldn't set sample resolution to 16 Bit, trying 8 Bit");i=8L;rc=UMSAudioDevice_set_bits_per_sample(audioDevice,ev,i);}}if(rc<0||UMSAudioDevice_set_audio_format_type(audioDevice,ev,"PCM")<0||UMSAudioDevice_set_number_format(audioDevice,ev,"TWOS_COMPLEMENT")<0){Msg(M_ERR,"couldn't set sample resolution to %ld Bit",i);goto error;}*bits=(int)i;audioShift=*bits>>4;i=2L;if(UMSAudioDevice_set_number_of_channels(audioDevice,ev,i)<0){Msg(M_WARN,"couldn't set stereo output, forcing mono");i=1L;if(UMSAudioDevice_set_number_of_channels(audioDevice,ev,i)<0){Msg(M_ERR,"couldn't set mono output");goto error;}}*stereo=i==2L;audioShift+=*stereo;*nonblocking=0;audioBuffer._maximum=(long)OsdGetAudioFreespace();audioBuffer._buffer=(char*)0;audioBuffer._length=0;i=100L;if(UMSAudioDevice_enable_output(audioDevice,ev,"LINE_OUT",&i,&i)<0||UMSAudioDevice_initialize(audioDevice,ev)<0||UMSAudioDevice_start(audioDevice,ev)<0){Msg(M_ERR,"couldn't start audio device");goto error;}sigemptyset(&blockingSet);sigaddset(&blockingSet,SIGALRM);return 0;error:UMSAudioDevice_stop(audioDevice,ev);UMSAudioDevice_close(audioDevice,ev);_somFree(audioDevice);audioDevice=(UMSBAUDDevice)0;return-1;}void OsdCloseAudioDevice(void){assert(audioDevice!=(UMSBAUDDevice)0);(void)UMSAudioDevice_play_remaining_data(audioDevice,ev,TRUE);(void)UMSAudioDevice_stop(audioDevice,ev);(void)UMSAudioDevice_close(audioDevice,ev);_somFree(audioDevice);audioDevice=(UMSBAUDDevice)0;}int OsdDrainAudioDevice(void){return((int)UMSAudioDevice_play_remaining_data(audioDevice,ev,TRUE));}int OsdGetAudioFreespace(void){long i=-1;return(UMSAudioDevice_write_buff_remain(audioDevice,ev,&i)<0?-1:(int)(i>>audioShift));}int OsdPlayAudioBuffer(unsigned char*buf,int len){sigset_t oldSet;long written;audioBuffer._buffer=buf;audioBuffer._length=(long)(len<<audioShift);(void)sigprocmask(SIG_BLOCK,&blockingSet,&oldSet);if(UMSAudioDevice_write(audioDevice,ev,&audioBuffer,audioBuffer._length,&written)<0){Msg(M_PERR,"couldn't write to audio device");}if(!sigismember(&oldSet,SIGALRM)){(void)sigprocmask(SIG_UNBLOCK,&blockingSet,(sigset_t*)0);}return(int)(written>>audioShift);}
