/*********************************************************************************************************************************
 * Copyright (c) Erik Kunze 1995 - 2007
 *
 * This file is a part of the Spectrum emulator package 'XZX-Pro', and may not be distributed.  The copyright holder makes no
 * representations about the suitability of this software for any purpose.  It is provided "as is" without express or implied
 * warranty. THE CODE MAY NOT BE MODIFIED OR REUSED WITHOUT PERMISSION!
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Erik Kunze
 ********************************************************************************************************************************/
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
#ifndef lint
static char rcsid[]="$Id: sound_ao.c,v 4.4 2006/12/22 14:29:14 erik Rel $";
#endif
#include <stdio.h>
#include <assert.h>
#include <ao/ao.h>
#include "monitor/debug.h"
#include "ui/resource.h"
#include "util.h"
#include "sound/sound.h"
#ifdef DEBUG
#define DEB(x)	{ if ((CFGGET(debug) & D_SOUND) != 0) { x } }
#else
#define DEB(x)
#endif
static ao_device*audioDevice;static int audioShift,audioQueueSize;int OsdOpenAudioDevice(const char*device,int*nonblocking,int*sample,int*bits,int*stereo){ao_sample_format format;int driver;USED(device);ao_initialize();driver=ao_default_driver_id();format.rate=*sample;format.bits=*bits;format.channels=2;format.byte_format=AO_FMT_LITTLE;if((audioDevice=ao_open_live(driver,&format,(ao_option*)0))==(ao_device*)0){Msg(M_ERR,"couldn't open audio device driver");return(errno==AO_EOPENDEVICE?-2:-1);}audioShift=*bits>>4;*stereo=1;audioShift+=*stereo;audioQueueSize=*sample;*nonblocking=0;return 0;}void OsdCloseAudioDevice(void){assert(audioDevice!=(ao_device*)0);(void)ao_close(audioDevice);audioDevice=(ao_device*)0;ao_shutdown();}int OsdDrainAudioDevice(void){return 0;}int OsdGetAudioFreespace(void){return audioQueueSize;}int OsdPlayAudioBuffer(unsigned char*buf,int len){if(ao_play(audioDevice,(void*)buf,(uint_32)(len<<audioShift))==0){Msg(M_PERR,"couldn't write to audio device");return-1;}return len;}
