/*********************************************************************************************************************************
 * Copyright (c) Erik Kunze 1995 - 2007
 *
 * This file is a part of the Spectrum emulator package 'XZX-Pro', and may not be distributed.  The copyright holder makes no
 * representations about the suitability of this software for any purpose.  It is provided "as is" without express or implied
 * warranty. THE CODE MAY NOT BE MODIFIED OR REUSED WITHOUT PERMISSION!
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Erik Kunze
 ********************************************************************************************************************************/
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
#ifndef lint
static char rcsid[]="$Id: sound_arts.c,v 4.14 2006/12/22 14:29:14 erik Rel $";
#endif
#include <sys/types.h>
#include <errno.h>
#include <assert.h>
#include <artsc.h>
#include "monitor/debug.h"
#include "ui/resource.h"
#include "util.h"
#include "main.h"
#include "sound/sound.h"
#define CALCULATE_FRAGMENTS
#ifdef DEBUG
#define DEB(x)	{ if ((CFGGET(debug) & D_SOUND) != 0) { x } }
#else
#define DEB(x)
#endif
static arts_stream_t audioStream=(arts_stream_t)0;static int audioShift;int OsdOpenAudioDevice(const char*device,int*nonblocking,int*sample,int*bits,int*stereo){
#ifdef CALCULATE_FRAGMENTS
int fragSize,fragCount;
#endif
int i;USED(device);if((i=arts_init())<0){Msg(M_ERR,"couldn't connect to audio server\n  -> reason: %s",arts_error_text(i));return(i==ARTS_E_NOSERVER?-2:-1);}if((audioStream=arts_play_stream(*sample,*bits,2,Version))==(arts_stream_t)0){Msg(M_ERR,"couldn't open stream\n  -> reason: %s",arts_error_text(i));goto error;}audioShift=*bits>>4;*stereo=1;audioShift+=*stereo;
#ifdef CALCULATE_FRAGMENTS
fragSize=256<<audioShift;fragCount=((((*sample<<audioShift)+fragSize-1)/fragSize)+1)&~1;for(i=1;1<<i<fragSize;i++);i|=fragCount<<16;DEB(Msg(M_DEBUG,"SND: new frags size   %d",fragSize);Msg(M_DEBUG,"SND: new frags count  %d",fragCount););if((i=arts_stream_set(audioStream,ARTS_P_PACKET_SETTINGS,i))<0){Msg(M_PERR,"couldn't set fragment size\n  -> reason: %s",arts_error_text(i));goto error;}
#endif
i=1-*nonblocking;if((i=arts_stream_set(audioStream,ARTS_P_BLOCKING,i))<0){Msg(M_ERR,"couldn't configure stream\n  -> reason: %s",arts_error_text(i));goto error;}*nonblocking=1-i;return 0;error:if(audioStream!=(arts_stream_t)0){arts_close_stream(audioStream);audioStream=(arts_stream_t)0;}arts_free();return-1;}void OsdCloseAudioDevice(void){assert(audioStream!=(arts_stream_t)0);arts_close_stream(audioStream);audioStream=(arts_stream_t)0;arts_free();}int OsdDrainAudioDevice(void){return 0;}int OsdGetAudioFreespace(void){int i;return((i=arts_stream_get(audioStream,ARTS_P_BUFFER_SPACE))<0?i:i>>audioShift);}int OsdPlayAudioBuffer(unsigned char*buf,int len){int written;if((written=arts_write(audioStream,buf,len<<audioShift))<0){Msg(M_ERR,"couldn't write to audio device\n  -> reason: %s",arts_error_text(written));}else{written>>=audioShift;}return written;}
