/*********************************************************************************************************************************
 * Copyright (c) Erik Kunze 1995 - 2007
 *
 * This file is a part of the Spectrum emulator package 'XZX-Pro', and may not be distributed.  The copyright holder makes no
 * representations about the suitability of this software for any purpose.  It is provided "as is" without express or implied
 * warranty. THE CODE MAY NOT BE MODIFIED OR REUSED WITHOUT PERMISSION!
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Erik Kunze
 ********************************************************************************************************************************/
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
#ifndef lint
static char rcsid[]="$Id: sound_darwin.c,v 4.7 2006/12/22 14:29:14 erik Rel $";
#endif
#include <sys/types.h>
#include <string.h>
#include <stdlib.h>
#include <assert.h>
#include <CoreAudio/CoreAudio.h>
#include "monitor/debug.h"
#include "util.h"
#include "sound/sound.h"
typedef struct _audioBlock{struct _audioBlock*next;float*blockBase;float*currentBase;unsigned int samplesLeft;}audioBlock;
#ifdef DEBUG
#define DEB(x)	{ x }
#else
#define DEB(x)
#endif
static OSStatus coreaudioPlay(AudioDeviceID,const AudioTimeStamp*,const AudioBufferList*,const AudioTimeStamp*,AudioBufferList*,const AudioTimeStamp*,void*);static int coreaudioQueueBlock(float*,unsigned int);static void coreaudioDequeueBlock(float*,unsigned int);static AudioDeviceID audioDev;static int audioShift,audioQueueSize;static audioBlock*queueHead=(audioBlock*)0;static audioBlock*queueTail=(audioBlock*)0;int OsdOpenAudioDevice(const char*device,int*nonblocking,int*sample,int*bits,int*stereo){char name[256];AudioStreamBasicDescription params;UInt32 len;OSStatus err;USED(device);audioDev=kAudioDeviceUnknown;len=sizeof(AudioDeviceID);err=AudioHardwareGetProperty(kAudioHardwarePropertyDefaultOutputDevice,&len,&audioDev);if(err!=noErr){Msg(M_ERR,"couldn't get default audio device");return-2;}len=sizeof(name);err=AudioDeviceGetProperty(audioDev,0,false,kAudioDevicePropertyDeviceName,&len,name);if(err!=noErr){Msg(M_ERR,"couldn't get device name");goto error;}DEB(Msg(M_DEBUG,"SND: device           %s",name););len=sizeof(params);err=AudioDeviceGetProperty(audioDev,0,false,kAudioDevicePropertyStreamFormat,&len,&params);if(err!=noErr){Msg(M_ERR,"couldn't get device parameters");goto error;}DEB(Msg(M_DEBUG,"SND: sample rate      %u",(unsigned int)params.mSampleRate);Msg(M_DEBUG,"SND: sample bits      %u",params.mBitsPerChannel);Msg(M_DEBUG,"SND: channels         %u",params.mChannelsPerFrame););if(params.mFormatID!=kAudioFormatLinearPCM){Msg(M_ERR,"device doesn't support linear PCM");return-2;}*sample=(int)params.mSampleRate;*bits=(int)params.mBitsPerChannel;audioShift=*bits>>4;*stereo=params.mChannelsPerFrame==2U;audioShift+=*stereo;audioQueueSize=*sample;*nonblocking=0;err=AudioDeviceAddIOProc(audioDev,coreaudioPlay,0);if(err!=noErr){Msg(M_ERR,"couldn't add callback function");goto error;}err=AudioDeviceStart(audioDev,coreaudioPlay);if(err!=noErr){Msg(M_ERR,"couldn't start playback");goto error;}return 0;error:audioDev=kAudioDeviceUnknown;return-1;}void OsdCloseAudioDevice(void){OSStatus err;assert(audioDev!=kAudioDeviceUnknown);err=AudioDeviceStop(audioDev,coreaudioPlay);if(err!=noErr){Msg(M_ERR,"couldn't stop playback");}err=AudioDeviceRemoveIOProc(audioDev,coreaudioPlay);if(err!=noErr){Msg(M_ERR,"couldn't remove callback function");}audioDev=kAudioDeviceUnknown;}int OsdDrainAudioDevice(void){return 0;}int OsdGetAudioFreespace(void){return audioQueueSize;}int OsdPlayAudioBuffer(unsigned char*buf,int len){float*block;int written,i;if((block=malloc(sizeof(float)*len))!=(float*)0){for(i=0;i<len;){block[i++]=(float)*buf++/128.0;block[i++]=(float)*buf++/128.0;}written=coreaudioQueueBlock(block,(unsigned int)len);}else{Msg(M_ERR,"malloc failed in OsdPlayAudioBuffer()");written=-1;}return written;}static OSStatus coreaudioPlay(AudioDeviceID inDevice,const AudioTimeStamp*inNow,const AudioBufferList*inInputData,const AudioTimeStamp*inInputTime,AudioBufferList*outOutputData,const AudioTimeStamp*inOutputTime,void*inClientData){unsigned int i;USED(inDevice);USED(inNow);USED(inInputData);USED(inInputTime);USED(inOutputTime);USED(inClientData);for(i=0;i<outOutputData->mNumberBuffers;i++){coreaudioDequeueBlock(outOutputData->mBuffers[i].mData,outOutputData->mBuffers[i].mDataByteSize/sizeof(float));}return noErr;}static int coreaudioQueueBlock(float*buf,unsigned int len){int queued=len;audioBlock*new;if((new=malloc(sizeof(audioBlock)))!=(audioBlock*)0){new->blockBase=buf;new->currentBase=buf;new->samplesLeft=len;new->next=(audioBlock*)0;if(queueHead==(audioBlock*)0){queueHead=new;queueTail=new;}else{queueTail->next=new;queueTail=new;}}else{Msg(M_ERR,"malloc failed in OsdPlayAudioBuffer()");queued=-1;}return queued;}static void coreaudioDequeueBlock(float*buf,unsigned int len){audioBlock*head=queueHead;if(len>0){if(head==(audioBlock*)0){while(len-->0){*buf++=0.0;}}else if(len<head->samplesLeft){memcpy(buf,head->currentBase,len*sizeof(float));head->samplesLeft-=len;head->currentBase+=len;}else{memcpy(buf,head->currentBase,head->samplesLeft*sizeof(float));len-=head->samplesLeft;buf+=head->samplesLeft;if((queueHead=head->next)==(audioBlock*)0){queueTail=(audioBlock*)0;}free(head->blockBase);free(head);coreaudioDequeueBlock(buf,len);}}}
