/*********************************************************************************************************************************
 * Copyright (c) Erik Kunze 1995 - 2007
 *
 * This file is a part of the Spectrum emulator package 'XZX-Pro', and may not be distributed.  The copyright holder makes no
 * representations about the suitability of this software for any purpose.  It is provided "as is" without express or implied
 * warranty. THE CODE MAY NOT BE MODIFIED OR REUSED WITHOUT PERMISSION!
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Erik Kunze
 ********************************************************************************************************************************/
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
#ifndef lint
static char rcsid[]="$Id: sound_esound.c,v 4.13 2006/12/22 14:29:14 erik Rel $";
#endif
#include <sys/types.h>
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>
#include <assert.h>
#include <esd.h>
#include "monitor/debug.h"
#include "ui/resource.h"
#include "util.h"
#include "main.h"
#include "sound/sound.h"
#ifdef DEBUG
#define DEB(x)	{ if ((CFGGET(debug) & D_SOUND) != 0) { x } }
#else
#define DEB(x)
#endif
static int audioFd=-1;static int audioShift,audioQueueSize;int OsdOpenAudioDevice(const char*device,int*nonblocking,int*sample,int*bits,int*stereo){esd_server_info_t*info=(esd_server_info_t*)0;esd_format_t esd_format;int fd;do{fd=esd_open_sound(device);}while(fd<0&&errno==EINTR);if(fd<0){Msg(M_PERR,"couldn't connect to audio server");return-2;}if((info=esd_get_server_info(fd))==(esd_server_info_t*)0){Msg(M_PERR,"couldn't get server info");(void)esd_close(fd);return-1;}DEB(Msg(M_DEBUG,"SND: server           %s",device!=(char*)0?device:"/tmp/.esd");Msg(M_DEBUG,"SND: sample rate      %d",info->rate);if(info->format&ESD_BITS16){Msg(M_DEBUG,"SND: sample bits      16");}if(info->format&ESD_BITS8){Msg(M_DEBUG,"SND: sample bits      8");}Msg(M_DEBUG,"SND: channels         %d",info->format&ESD_STEREO?2:1););*sample=info->rate;audioShift=*bits>>4;*stereo=(info->format&ESD_STEREO)!=0;audioShift+=*stereo;audioQueueSize=*sample;esd_free_server_info(info);(void)esd_close(fd);esd_format=ESD_STREAM|ESD_PLAY|(*bits==16?ESD_BITS16:ESD_BITS8)|(info->format&ESD_MASK_CHAN);do{audioFd=esd_play_stream(esd_format,*sample,device,Version);}while(audioFd<0&&errno==EINTR);if(audioFd<0){Msg(M_PERR,"couldn't connect to audio server");return-2;}if(*nonblocking!=0){int flags=fcntl(audioFd,F_GETFL);if(flags<0||fcntl(audioFd,F_SETFL,flags|O_NONBLOCK)<0){Msg(M_PERR,"couldn't set nonblocking mode");(void)close(audioFd);audioFd=-1;return-1;}}return 0;}void OsdCloseAudioDevice(void){assert(audioFd!=-1);(void)close(audioFd);audioFd=-1;}int OsdDrainAudioDevice(void){return 0;}int OsdGetAudioFreespace(void){return audioQueueSize;}int OsdPlayAudioBuffer(unsigned char*buf,int len){int written,remain;for(written=0,remain=len<<audioShift;remain>0;buf+=written,remain-=written){do{written=(int)write(audioFd,buf,(size_t)remain);}while(written<0&&errno==EINTR);if(written<0){break;}}if(written<0&&errno!=EAGAIN){Msg(M_PERR,"couldn't write to audio device");return written;}return len-(remain>>audioShift);}
