/*********************************************************************************************************************************
 * Copyright (c) Erik Kunze 1995 - 2007
 *
 * This file is a part of the Spectrum emulator package 'XZX-Pro', and may not be distributed.  The copyright holder makes no
 * representations about the suitability of this software for any purpose.  It is provided "as is" without express or implied
 * warranty. THE CODE MAY NOT BE MODIFIED OR REUSED WITHOUT PERMISSION!
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Erik Kunze
 ********************************************************************************************************************************/
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
#ifndef lint
static char rcsid[]="$Id: sound_hpux.c,v 4.8 2006/12/22 14:29:14 erik Rel $";
#endif
#include <sys/types.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include <signal.h>
#include <errno.h>
#include <assert.h>
#include <sys/audio.h>
#include "monitor/debug.h"
#include "ui/resource.h"
#include "util.h"
#include "sound/sound.h"
#ifdef DEBUG
#define DEB(x)	{ if ((CFGGET(debug) & D_SOUND) != 0) { x } }
#else
#define DEB(x)
#endif
static int audioFd=-1;static int audioShift;static sigset_t blockingSet;int OsdOpenAudioDevice(const char*device,int*nonblocking,int*sample,int*bits,int*stereo){int i;Msg(M_INFO,"*********************************************************");Msg(M_INFO,"This audio driver is experimental, because I don't have");Msg(M_INFO,"access to any system running HP-UX. Please get in contact");Msg(M_INFO,"with me so I can improve the driver.");Msg(M_INFO,"*********************************************************");if((audioFd=open(device,O_WRONLY|O_NONBLOCK))<0){Msg(M_PERR,"couldn't open audio device <%s> for writing",device);return(errno==EBUSY||errno==EAGAIN?-1:-2);}if(ioctl(audioFd,AUDIO_SET_SAMPLE_RATE,*sample)<0){Msg(M_PERR,"couldn't set sample rate to %d Hz",*sample);goto error;}if((i=ioctl(audioFd,AUDIO_SET_DATA_FORMAT,*bits==16?AUDIO_FORMAT_LINEAR16BIT:AUDIO_FORMAT_LINEAR8BIT))<0){if(*bits==16){Msg(M_WARN,"couldn't set sample resolution to 16 Bit, trying 8 Bit");*bits=8;i=ioctl(audioFd,AUDIO_SET_DATA_FORMAT,AUDIO_FORMAT_LINEAR8BIT);}}if(i<0){Msg(M_PERR,"couldn't set sample resolution to %d Bit",*bits);goto error;}audioShift=*bits>>4;i=2;if(ioctl(audioFd,AUDIO_SET_CHANNELS,i)<0){Msg(M_WARN,"couldn't set stereo output, forcing mono");i=1;if(ioctl(audioFd,AUDIO_SET_CHANNELS,i)<0){Msg(M_PERR,"couldn't set mono output");goto error;}}*stereo=i==2;audioShift+=*stereo;i=(*sample*(*bits/sizeof(unsigned char)))<<*stereo;if(ioctl(audioFd,AUDIO_SET_TXBUFSIZE,&i)<0){Msg(M_PERR,"couldn't setbuffer size to %d bytes",i);goto error;}if(*nonblocking!=0){int flags=fcntl(audioFd,F_GETFL);if(flags<0||fcntl(audioFd,F_SETFL,flags|O_NONBLOCK)<0){Msg(M_PERR,"couldn't set nonblocking mode");goto error;}}sigemptyset(&blockingSet);sigaddset(&blockingSet,SIGALRM);return 0;error:(void)close(audioFd);audioFd=-1;return-1;}void OsdCloseAudioDevice(void){assert(audioFd>=0);(void)close(audioFd);audioFd=-1;}int OsdDrainAudioDevice(void){return 0;}int OsdGetAudioFreespace(void){struct audio_status status;return(ioctl(audioFd,AUDIO_GET_STATUS,&status)<0?-1:status.transmit_buffer_count>>audioShift);}int OsdPlayAudioBuffer(unsigned char*buf,int len){sigset_t oldSet;int written,remain;(void)sigprocmask(SIG_BLOCK,&blockingSet,&oldSet);for(written=0,remain=len<<audioShift;remain>0;buf+=written,remain-=written){do{written=(int)write(audioFd,buf,(size_t)remain);}while(written<0&&errno==EINTR);if(written<0){break;}}if(written<0&&errno!=EAGAIN){Msg(M_PERR,"couldn't write to audio device");return written;}if(!sigismember(&oldSet,SIGALRM)){(void)sigprocmask(SIG_UNBLOCK,&blockingSet,(sigset_t*)0);}return len-(remain>>audioShift);}
