/*********************************************************************************************************************************
 * Copyright (c) Erik Kunze 1995 - 2007
 *
 * This file is a part of the Spectrum emulator package 'XZX-Pro', and may not be distributed.  The copyright holder makes no
 * representations about the suitability of this software for any purpose.  It is provided "as is" without express or implied
 * warranty. THE CODE MAY NOT BE MODIFIED OR REUSED WITHOUT PERMISSION!
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Erik Kunze
 ********************************************************************************************************************************/
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
#ifndef lint
static char rcsid[]="$Id: sound_irix.c,v 4.7 2006/12/22 14:29:14 erik Rel $";
#endif
#include <sys/types.h>
#include <assert.h>
#include <dmedia/audio.h>
#include "monitor/debug.h"
#include "ui/resource.h"
#include "util.h"
#include "main.h"
#include "sound/sound.h"
#ifdef HAVE_al_FUNCS
#define ALopenport	alOpenPort
#define ALcloseport	alClosePort
#define ALfreeconfig	alFreeConfig
#define ALgetfillable	alGetFillable
#define ALwritesamps	alWriteFrames
#define ALreason	"\n  -> reason: %s", alGetErrorString(oserror())
#define ALreason1(x)	"\n  -> reason: %s", (x), alGetErrorString(oserror())
#else
#define ALreason
#define ALreason1(x)	, x
#endif
static ALport audioPort=(ALport)0;static int audioBits,audioShift;int OsdOpenAudioDevice(const char*device,int*nonblocking,int*sample,int*bits,int*stereo){ALconfig audioConfig;int err;
#if HAVE_al_FUNCS
ALpv pvs[4];int alIsBusy=0;pvs[0].param=AL_MAX_PORTS;pvs[1].param=AL_UNUSED_PORTS;if(alGetParams(AL_SYSTEM,pvs,2)<0){return-1;}if(pvs[1].value.i<1){Msg(M_WARN,"audio device in use");return-1;}if(pvs[1].value.i<pvs[0].value.i){pvs[0].param=AL_RATE;if(alGetParams(AL_DEFAULT_OUTPUT,pvs,1)<0){return-1;}*sample=pvs[0].value.i;alIsBusy=1;}if((audioConfig=alNewConfig())==(ALconfig)0){return-1;}if((err=alSetWidth(audioConfig,*bits==16?AL_SAMPLE_16:AL_SAMPLE_8))<0){if(*bits==16){Msg(M_WARN,"couldn't set sample resolution to 16 Bit, trying 8 Bit");*bits=8;err=alSetWidth(audioConfig,AL_SAMPLE_8);}}if(err<0){Msg(M_ERR,"couldn't set sample resolution to %d Bit"ALreason1(*bits));goto error;}*stereo=1;if(alSetChannels(audioConfig,AL_STEREO)<0){Msg(M_WARN,"couldn't set stereo output, forcing mono");*stereo=0;if(alSetChannels(audioConfig,AL_MONO)<0){Msg(M_ERR,"couldn't set mono output"ALreason);goto error;}}if(alSetQueueSize(audioConfig,(long)*sample)<0||alSetSampFmt(audioConfig,AL_SAMPFMT_TWOSCOMP)<0){Msg(M_ERR,"couldn't set channel-specific parameters"ALreason);goto error;}*nonblocking=0;pvs[0].param=AL_MASTER_CLOCK;pvs[0].value.i=AL_CRYSTAL_MCLK_TYPE;pvs[1].param=AL_RATE;pvs[1].value.i=*sample;if(alIsBusy==0){if(alSetParams(AL_DEFAULT_OUTPUT,pvs,2)<0){Msg(M_ERR,"couldn't set audio-device parameters"ALreason);goto error;}}
#else
long param[4];param[0]=AL_INPUT_COUNT;param[2]=AL_OUTPUT_COUNT;(void)ALgetparams(AL_DEFAULT_DEVICE,param,4);if(param[1]||param[3]){Msg(M_WARN,"audio device in use");return-1;}if((audioConfig=ALnewconfig())==(ALconfig)0){return-1;}if((err=ALsetwidth(audioConfig,*bits==16?AL_SAMPLE_16:AL_SAMPLE_8))<0){if(*bits==16){Msg(M_WARN,"couldn't set sample resolution to 16 Bit, trying 8 Bit");*bits=8;err=ALsetwidth(audioConfig,AL_SAMPLE_8);}}if(err<0){Msg(M_ERR,"couldn't set sample resolution to %d Bit"ALreason1(*bits));goto error;}*stereo=1;if(ALsetchannels(audioConfig,AL_STEREO)<0){Msg(M_WARN,"couldn't set stereo output, forcing mono");*stereo=0;if(alSetChannels(audioConfig,AL_MONO)<0){Msg(M_ERR,"couldn't set mono output"ALreason);goto error;}}if(ALsetqueuesize(audioConfig,(long)*sample)<0||ALsetsampfmt(audioConfig,AL_SAMPFMT_TWOSCOMP)<0){Msg(M_ERR,"couldn't set channel-specific parameters"ALreason);goto error;}*nonblocking=0;param[0]=AL_OUTPUT_RATE;param[1]=(long)*sample;param[2]=AL_INPUT_RATE;param[3]=(long)*sample;if(ALsetparams(AL_DEFAULT_DEVICE,param,4)<0){Msg(M_ERR,"couldn't set audio-device parameters"ALreason);goto error;}
#endif 
if((audioPort=ALopenport(Version,"w",audioConfig))==(ALport)0){Msg(M_ERR,"couldn't open audio device for writing"ALreason);goto error;}(void)ALfreeconfig(audioConfig);audioBits=*bits;audioShift=*stereo;return 0;error:if(audioPort!=(ALport)0){(void)ALcloseport(audioPort);audioPort=(ALport)0;}(void)ALfreeconfig(audioConfig);return-1;}void OsdCloseAudioDevice(void){assert(audioPort!=(ALport)0);(void)ALcloseport(audioPort);audioPort=(ALport)0;}int OsdDrainAudioDevice(void){return 0;}int OsdGetAudioFreespace(void){return(ALgetfillable(audioPort));}int OsdPlayAudioBuffer(unsigned char*buf,int len){int written,remain=len<<audioShift,i;if(audioBits==8){for(i=0;i<remain;i++){buf[i]^=0x80;}}else{unsigned short*buf16=(unsigned short*)buf;for(i=0;i<remain;i++){buf16[i]^=0x8000;}}if((written=ALwritesamps(audioPort,buf,(long)remain))<0){Msg(M_ERR,"couldn't write to audio device"ALreason);return written;}return len;}
