/*********************************************************************************************************************************
 * Copyright (c) Erik Kunze 1995 - 2007
 *
 * This file is a part of the Spectrum emulator package 'XZX-Pro', and may not be distributed.  The copyright holder makes no
 * representations about the suitability of this software for any purpose.  It is provided "as is" without express or implied
 * warranty. THE CODE MAY NOT BE MODIFIED OR REUSED WITHOUT PERMISSION!
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Erik Kunze
 ********************************************************************************************************************************/
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
#ifndef lint
static char speaker_c[]="$Id: speaker.c,v 4.28 2006/12/22 14:29:14 erik Rel $";
#endif
#include <stdlib.h>
#include <assert.h>
#include "z80/z80.h"
#include "monitor/debug.h"
#include "ui/resource.h"
#include "machine/machine.h"
#include "util.h"
#include "sound/sound.h"
#ifdef DEBUG
#define DEB(x)	{ if ((CFGGET(debug) & D_SOUND) != 0) { x } }
#else
#define DEB(x)
#endif
static void speakerUpdate(unsigned int);static unsigned int lastPos,lastRem,accum;static unsigned char lastVal;static unsigned char*buf;void SpeakerInit(void){lastPos=0;lastRem=0;accum=0;if(buf!=(unsigned char*)0){free(buf);}buf=Malloc(sizeof(unsigned char)*(size_t)(SoundDataP->samplesPerFrame*2),"SpeakerInit");SoundDataP->spBuf=buf;}void SpeakerOut(uns8 newval){unsigned int pos,rem;unsigned char val=((newval&(B_SPEAKER|B_MIC))<<3)-96;if(val!=lastVal){rem=TSTATES%SoundDataP->tstatesPerSample;if((pos=TSTATES/SoundDataP->tstatesPerSample)!=lastPos){if(pos>SoundDataP->samplesPerFrame){pos=SoundDataP->samplesPerFrame;}speakerUpdate(pos);accum=lastVal*rem;}else{accum+=lastVal*(rem-lastRem);}lastRem=rem;lastVal=val;}}void SpeakerFillBuffer(void){if(lastPos<SoundDataP->samplesPerFrame){speakerUpdate(SoundDataP->samplesPerFrame);}lastPos=0;lastRem=0;accum=0;}static void speakerUpdate(unsigned int pos){assert(pos<=SoundDataP->samplesPerFrame);buf[lastPos++]=(accum+lastVal*(SoundDataP->tstatesPerSample-lastRem))/SoundDataP->tstatesPerSample;for(;lastPos<pos;lastPos++){buf[lastPos]=lastVal;}}
