/*********************************************************************************************************************************
 * Copyright (c) Erik Kunze 1995 - 2007
 *
 * This file is a part of the Spectrum emulator package 'XZX-Pro', and may not be distributed.  The copyright holder makes no
 * representations about the suitability of this software for any purpose.  It is provided "as is" without express or implied
 * warranty. THE CODE MAY NOT BE MODIFIED OR REUSED WITHOUT PERMISSION!
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Erik Kunze
 ********************************************************************************************************************************/
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
#ifdef HAVE_XPM
#ifndef lint
static char rcsid[]="$Id: kbd.c,v 4.27 2006/12/22 14:29:16 erik Rel $";
#endif
#include <Xm/Xm.h>
#include <X11/xpm.h>
#include <Xm/Form.h>
#include <Xm/DrawnB.h>
#include <Xm/ToggleBG.h>
#include <assert.h>
#include "monitor/debug.h"
#include "ui/resource.h"
#include "util.h"
#include "keyboard.h"
#include "ui/toolhelp.h"
#include "ui/xwin.h"
#include "ui/kbd.h"
#include "ui/kbd.xpm"
#define	KBD_ROWS	4
#define KBD_COLS	10
typedef struct _kbdData{Widget shell;Pixmap pic;int rowStart[KBD_ROWS];int rowEnd[KBD_ROWS];int colStart[KBD_ROWS][KBD_COLS];int colEnd[KBD_ROWS][KBD_COLS];struct{int pressed;int rowPixmap;int colPixmap;int rowMatrix;int colMatrix;}buttonState[3];}kbdData;
#ifdef DEBUG
#define DEB(x)	{ if ((CFGGET(debug) & D_X11) != 0) { x } }
#else
#define DEB(x)
#endif
static void kbdCallback(Widget,XtPointer,XtPointer);static void kbdEventhandler(Widget,XtPointer,XEvent*,Boolean*);static kbdData*kbdDataP;void KbdShow(Widget w){if(kbdDataP==(kbdData*)0){Widget button;XmString title;Arg arg[7];Cardinal i;XpmAttributes attr;int error;int start,j,k;kbdDataP=Malloc(sizeof(kbdData),"KbdShow");attr.valuemask=XpmVisual|XpmColormap|XpmDepth|XpmSize;XtVaGetValues(XwinDataP->topLevel,XtNdepth,&attr.depth,XtNvisual,&attr.visual,XtNcolormap,&attr.colormap,XtNull);error=XpmCreatePixmapFromData(XtDisplay(XwinDataP->topLevel),XtWindow(XwinDataP->topLevel),(char**)kbd_xpm,&(kbdDataP->pic),(Pixmap*)0,&attr);XpmFreeAttributes(&attr);if(error!=XpmSuccess){Msg(M_ERR,XpmGetErrorString(error));XmToggleButtonGadgetSetState(w,False,False);return;}title=XmStringCreateLtoR((char*)"Keyboard",XmFONTLIST_DEFAULT_TAG);i=0;XtSetArg(arg[i],XmNmarginWidth,0);i++;XtSetArg(arg[i],XmNmarginHeight,0);i++;XtSetArg(arg[i],XmNshadowThickness,0);i++;XtSetArg(arg[i],XmNnoResize,True);i++;XtSetArg(arg[i],XmNautoUnmanage,False);i++;XtSetArg(arg[i],XmNdeleteResponse,XmUNMAP);i++;XtSetArg(arg[i],XmNdialogTitle,title);i++;assert(i<=XtNumber(arg));kbdDataP->shell=XmCreateFormDialog(XwinDataP->topLevel,(char*)"fd",arg,i);XtAddCallback(kbdDataP->shell,XmNunmapCallback,kbdCallback,w);XmStringFree(title);i=0;XtSetArg(arg[i],XmNpushButtonEnabled,False);i++;XtSetArg(arg[i],XmNmultiClick,XmMULTICLICK_DISCARD);i++;XtSetArg(arg[i],XmNshadowThickness,0);i++;XtSetArg(arg[i],XmNhighlightThickness,0);i++;XtSetArg(arg[i],XmNwidth,attr.width);i++;XtSetArg(arg[i],XmNheight,attr.height);i++;assert(i<=XtNumber(arg));button=XmCreateDrawnButton(kbdDataP->shell,(char*)"db",arg,i);XtAddCallback(button,XmNexposeCallback,kbdCallback,XtNull);XtManageChild(button);ToolhelpAddWidget(button,"Press either mouse button to simmulate\n""Spectrum key presses. Combine buttons\n""for shifted keys.");start=29;for(j=0;j<KBD_ROWS;j++){kbdDataP->rowStart[j]=start;kbdDataP->rowEnd[j]=start+24;start+=56;}for(k=0;k<3;k++){switch(k){case 0:start=8;break;case 1:start=35;break;case 2:start=47;break;}for(j=0;j<KBD_COLS;j++){kbdDataP->colStart[k][j]=start;kbdDataP->colEnd[k][j]=start+38;start+=55;}}start=8;kbdDataP->colStart[3][0]=start;kbdDataP->colEnd[3][0]=start+49;start+=66;for(j=1;j<KBD_COLS-1;j++){kbdDataP->colStart[3][j]=start;kbdDataP->colEnd[3][j]=start+38;start+=55;}kbdDataP->colStart[3][9]=start;kbdDataP->colEnd[3][9]=start+66;XtAddEventHandler(button,ButtonPressMask|ButtonReleaseMask,False,kbdEventhandler,XtNull);}XtManageChild(kbdDataP->shell);XtPopup(XtParent(kbdDataP->shell),XtGrabNone);}void KbdHide(Widget w){USED(w);XtUnmanageChild(kbdDataP->shell);XtPopdown(XtParent(kbdDataP->shell));}static void kbdCallback(Widget w,XtPointer client,XtPointer call){XExposeEvent*eev;if(((XmDrawnButtonCallbackStruct*)call)->reason==XmCR_UNMAP){XmToggleButtonGadgetSetState((Widget)client,False,False);return;}eev=&(((XmDrawnButtonCallbackStruct*)call)->event->xexpose);XCopyArea(XtDisplay(w),kbdDataP->pic,XtWindow(w),XDefaultGCOfScreen(XtScreen(w)),eev->x,eev->y,(unsigned int)eev->width,(unsigned int)eev->height,eev->x,eev->y);}static void kbdEventhandler(Widget w,XtPointer client,XEvent*xev,Boolean*cont){XButtonEvent*bev=&(xev->xbutton);int button;int row=0,col=0;int x,y;unsigned width,height;int i;USED(client);USED(cont);switch(bev->button){case Button1:button=0;break;case Button2:button=1;break;case Button3:button=2;break;default:button=-1;break;}if(button>=0){if(xev->type==ButtonPress){if(kbdDataP->buttonState[button].pressed==0){for(i=0;i<KBD_ROWS;i++){if(kbdDataP->rowStart[i]<=bev->y&&kbdDataP->rowEnd[i]>bev->y){row=i;break;}}if(i==KBD_ROWS){return;}for(i=0;i<KBD_COLS;i++){if(kbdDataP->colStart[row][i]<=bev->x&&kbdDataP->colEnd[row][i]>bev->x){col=i;break;}}if(i==KBD_COLS){return;}DEB(Msg(M_DEBUG,"KBD: x=%3d, y=%3d, row=%d, col=%d",bev->x,bev->y,row,col););kbdDataP->buttonState[button].pressed=1;kbdDataP->buttonState[button].rowPixmap=row;kbdDataP->buttonState[button].colPixmap=col;kbdDataP->buttonState[button].rowMatrix=col<5?3-row:4+row;kbdDataP->buttonState[button].colMatrix=col<5?col:9-col;KeyboardPorts[kbdDataP->buttonState[button].rowMatrix]&=~(1<<kbdDataP->buttonState[button].colMatrix);x=kbdDataP->colStart[row][col];y=kbdDataP->rowStart[row];width=kbdDataP->colEnd[row][col]-x+1;height=kbdDataP->rowEnd[row]-y+1;XCopyArea(XtDisplay(w),kbdDataP->pic,kbdDataP->pic,XDefaultGCOfScreen(XtScreen(w)),x,y,width,height,x+1,y+1);XCopyArea(XtDisplay(w),kbdDataP->pic,XtWindow(w),XDefaultGCOfScreen(XtScreen(w)),x,y,width+1,height+1,x,y);}}else{if(kbdDataP->buttonState[button].pressed!=0){for(i=0;i<NELEM(kbdDataP->buttonState);i++){if(kbdDataP->buttonState[i].pressed!=0){kbdDataP->buttonState[i].pressed=0;KeyboardPorts[kbdDataP->buttonState[i].rowMatrix]|=1<<kbdDataP->buttonState[i].colMatrix;row=kbdDataP->buttonState[i].rowPixmap;col=kbdDataP->buttonState[i].colPixmap;x=kbdDataP->colStart[row][col];y=kbdDataP->rowStart[row];width=kbdDataP->colEnd[row][col]-x+1;height=kbdDataP->rowEnd[row]-y+1;XCopyArea(XtDisplay(w),kbdDataP->pic,kbdDataP->pic,XDefaultGCOfScreen(XtScreen(w)),x+1,y+1,width,height,x,y);XCopyArea(XtDisplay(w),kbdDataP->pic,XtWindow(w),XDefaultGCOfScreen(XtScreen(w)),x,y,width+1,height+1,x,y);}}}}}}
#endif 

