/*********************************************************************************************************************************
 * Copyright (c) Erik Kunze 1995 - 2007
 *
 * This file is a part of the Spectrum emulator package 'XZX-Pro', and may not be distributed.  The copyright holder makes no
 * representations about the suitability of this software for any purpose.  It is provided "as is" without express or implied
 * warranty. THE CODE MAY NOT BE MODIFIED OR REUSED WITHOUT PERMISSION!
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Erik Kunze
 ********************************************************************************************************************************/
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
#ifndef lint
static char rcsid[]="$Id: resource.c,v 4.116 2006/12/22 14:29:16 erik Rel $";
#endif
#include <Xm/Xm.h>
#include <X11/keysym.h>
#include <sys/types.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/param.h>
#include "monitor/debug.h"
#include "machine/machine.h"
#include "util.h"
#include "joystick.h"
#include "main.h"
#ifdef XZX_PRINTER
#include "printer/printer.h"
#endif
#include "sound/sound.h"
#include "ui/xwin.h"
#include "ui/resource.h"
#define RESOURCE_FILE	".xzxrc"
#define RES(a,b,c,d)	{ (char *)a,(char *)b,c,d },
#define RES2(a,b,c,d,e,f,g)	{ (String)a,(String)b,c,sizeof(d),XtOffsetOf(ResourceData,e),f,(XtPointer)g },
#define RES3(a,b,c,d,e,f,g)	{ (String)a,(String)b,c,sizeof(d),(size_t)e,f,(XtPointer)g },
#define BOOL(x)	((x) > 0 ? "true" : "false")
#define KEY(x)	XKeysymToString(x)
enum{KM_JOY_UP,KM_JOY_DOWN,KM_JOY_LEFT,KM_JOY_RIGHT,KM_JOY_FIRE,NUM_KEYMAPPINGS};static void resourcePrintCopyright(void);static void resourcePrintVersion(void);
#ifdef DEBUG
static void resourcePrint(void);
#endif
static ResourceData resourceData;ResourceData*ResourceDataP=&resourceData;XrmOptionDescRec ResourceOptions[]={RES("-libDir","*libDir",XrmoptionSepArg,XtNull)RES("-infoDir","*infoDir",XrmoptionSepArg,XtNull)RES("-pokeDir","*pokeDir",XrmoptionSepArg,XtNull)RES("-quiet","*quiet",XrmoptionSepArg,XtNull)RES("-core","*core",XrmoptionSepArg,XtNull)RES("-monocrome","*monocrome",XrmoptionSepArg,XtNull)RES("-private","*private",XrmoptionSepArg,XtNull)RES("-xsync","*xsync",XrmoptionSepArg,XtNull)
#ifdef DEBUG
RES("-debug","*debug",XrmoptionSepArg,XtNull)
#endif
RES("-machine","*machine",XrmoptionSepArg,XtNull)RES("-speed","*speed",XrmoptionSepArg,XtNull)RES("-fastmode","*fastmode",XrmoptionSepArg,XtNull)RES("-warn48","*warn48",XrmoptionSepArg,XtNull)RES("-smart","*smart",XrmoptionSepArg,XtNull)RES("-scale","*scale",XrmoptionSepArg,XtNull)RES("-refresh","*refresh",XrmoptionSepArg,XtNull)RES("-cache","*cache",XrmoptionSepArg,XtNull)RES("-tapeQuickload","*tapeQuickload",XrmoptionSepArg,XtNull)RES("-tapeFastload","*tapeFastload",XrmoptionSepArg,XtNull)RES("-tapeAutostop","*tapeAutostop",XrmoptionSepArg,XtNull)RES("-tapeNoise","*tapeNoise",XrmoptionSepArg,XtNull)RES("-tapeQuicksave","*tapeQuicksave",XrmoptionSepArg,XtNull)RES("-joyType","*joyType",XrmoptionSepArg,XtNull)RES("-joyUp","*joyUp",XrmoptionSepArg,XtNull)RES("-joyDown","*joyDown",XrmoptionSepArg,XtNull)RES("-joyLeft","*joyLeft",XrmoptionSepArg,XtNull)RES("-joyRight","*joyRight",XrmoptionSepArg,XtNull)RES("-joyFire","*joyFire",XrmoptionSepArg,XtNull)
#ifdef HAVE_JOYSTICK
RES("-joy","*joy",XrmoptionSepArg,XtNull)RES("-joyDev","*joyDev",XrmoptionSepArg,XtNull)
#ifdef HAVE_LIBJSW
RES("-joyCalibration","*joyCalibration",XrmoptionSepArg,XtNull)
#endif
RES("-joyAxisX","*joyAxisX",XrmoptionSepArg,XtNull)RES("-joyAxisY","*joyAxisY",XrmoptionSepArg,XtNull)RES("-joyButtonFire","*joyButtonFire",XrmoptionSepArg,XtNull)RES("-joyButtonAutofire","*joyButtonAutofire",XrmoptionSepArg,XtNull)RES("-joyButtonJuggle","*joyButtonJuggle",XrmoptionSepArg,XtNull)RES("-joyButtonMagic1","*joyButtonMagic1",XrmoptionSepArg,XtNull)RES("-joyButtonMagic2","*joyButtonMagic2",XrmoptionSepArg,XtNull)
#ifndef HAVE_LIBJSW
RES("-joyTolerance","*joyTolerance",XrmoptionSepArg,XtNull)
#endif
RES("-joyAutofire","*joyAutofire",XrmoptionSepArg,XtNull)RES("-joyJuggle","*joyJuggle",XrmoptionSepArg,XtNull)
#endif
RES("-sound","*sound",XrmoptionSepArg,XtNull)
#ifdef SOUND_NATIVE
#ifdef SOUND_NETWORK
RES("-soundServer","*soundServer",XrmoptionSepArg,XtNull)
#else
RES("-soundDev","*soundDev",XrmoptionSepArg,XtNull)
#endif
#endif
RES("-soundNonblocking","*soundNonblocking",XrmoptionSepArg,XtNull)RES("-soundSample","*soundSample",XrmoptionSepArg,XtNull)RES("-soundBits","*soundBits",XrmoptionSepArg,XtNull)RES("-soundStereo","*soundStereo",XrmoptionSepArg,XtNull)RES("-soundVolumeSp","*soundVolumeSp",XrmoptionSepArg,XtNull)RES("-soundVolumeAy","*soundVolumeAy",XrmoptionSepArg,XtNull)RES("-sp48Rom","*sp48Rom",XrmoptionSepArg,XtNull)RES("-sp128Rom","*sp128Rom",XrmoptionSepArg,XtNull)RES("-sp3Rom","*sp3Rom",XrmoptionSepArg,XtNull)RES("-sp3DriveA","*sp3DriveA",XrmoptionSepArg,XtNull)RES("-sp3DriveB","*sp3DribeB",XrmoptionSepArg,XtNull)
#ifdef XZX_PENTAGON
RES("-pentagonRom","*pentagonRom",XrmoptionSepArg,XtNull)
#endif
#ifdef XZX_SCORPION
RES("-scorpionRom","*scorpionRom",XrmoptionSepArg,XtNull)
#endif
#ifdef XZX_DIDAKTIK
RES("-didaktikRom","*didaktikRom",XrmoptionSepArg,XtNull)RES("-didaktikDriveA","*didaktikDriveA",XrmoptionSepArg,XtNull)RES("-didaktikDriveB","*didaktikDriveB",XrmoptionSepArg,XtNull)
#endif
#ifdef XZX_IF1
RES("-if1","*if1",XrmoptionSepArg,XtNull)RES("-if1Rom","*if1Rom",XrmoptionSepArg,XtNull)RES("-if1Drive1","*if1Drive1",XrmoptionSepArg,XtNull)
#if XZX_IF1_DRIVES > 1
RES("-if1Drive2","*if1Drive2",XrmoptionSepArg,XtNull)
#endif
#if XZX_IF1_DRIVES > 2
RES("-if1Drive3","*if1Drive3",XrmoptionSepArg,XtNull)
#endif
#if XZX_IF1_DRIVES > 3
RES("-if1Drive4","*if1Drive4",XrmoptionSepArg,XtNull)
#endif
#if XZX_IF1_DRIVES > 4
RES("-if1Drive5","*if1Drive5",XrmoptionSepArg,XtNull)
#endif
#if XZX_IF1_DRIVES > 5
RES("-if1Drive6","*if1Drive6",XrmoptionSepArg,XtNull)
#endif
#if XZX_IF1_DRIVES > 6
RES("-if1Drive7","*if1Drive7",XrmoptionSepArg,XtNull)
#endif
#if XZX_IF1_DRIVES > 7
RES("-if1Drive8","*if1Drive8",XrmoptionSepArg,XtNull)
#endif
RES("-if1Rs232Mode","*if1Rs232Mode",XrmoptionSepArg,XtNull)
#endif 
#ifdef XZX_OPUS
RES("-opus","*opus",XrmoptionSepArg,XtNull)RES("-opusRom","*opusRom",XrmoptionSepArg,XtNull)RES("-opusDriveA","*opusDriveA",XrmoptionSepArg,XtNull)RES("-opusDriveB","*opusDriveB",XrmoptionSepArg,XtNull)
#endif
#ifdef XZX_MF
RES("-mf","*mf",XrmoptionSepArg,XtNull)RES("-mf1Rom","*mf1Rom",XrmoptionSepArg,XtNull)RES("-mf128Rom","*mf128Rom",XrmoptionSepArg,XtNull)RES("-mf3Rom","*mf3Rom",XrmoptionSepArg,XtNull)
#endif
#ifdef XZX_TRDOS
RES("-trdos","*trdos",XrmoptionSepArg,XtNull)RES("-trdosRom","*trdosRom",XrmoptionSepArg,XtNull)RES("-trdosDriveA","*trdosDriveA",XrmoptionSepArg,XtNull)RES("-trdosDriveB","*trdosDriveB",XrmoptionSepArg,XtNull)RES("-trdosDriveC","*trdosDriveC",XrmoptionSepArg,XtNull)RES("-trdosDriveD","*trdosDriveD",XrmoptionSepArg,XtNull)
#endif
#ifdef XZX_PLUSD
RES("-plusd","*plusd",XrmoptionSepArg,XtNull)RES("-plusdRom","*plusdRom",XrmoptionSepArg,XtNull)RES("-plusdDriveA","*plusdDriveA",XrmoptionSepArg,XtNull)RES("-plusdDriveB","*plusdDriveB",XrmoptionSepArg,XtNull)
#endif
#ifdef XZX_LIGHTGUN
RES("-lightgun","*lightgun",XrmoptionSepArg,XtNull)
#endif
#ifdef XZX_KMOUSE
RES("-kmouse","*kmouse",XrmoptionSepArg,XtNull)
#endif
#ifdef XZX_PRINTER
RES("-printerMode","*printerMode",XrmoptionSepArg,XtNull)RES("-printerFile","*printerFile",XrmoptionSepArg,XtNull)RES("-printerCmd","*printerCmd",XrmoptionSepArg,XtNull)
#endif
#ifdef XZX_IF1_RS232
RES("-rs232Dev","*rs232Dev",XrmoptionSepArg,XtNull)RES("-rs232Baud","*rs232Baud",XrmoptionSepArg,XtNull)
#endif
};Cardinal ResourceOptionsCount=XtNumber(ResourceOptions);static XtResource resourceDefaults[]={RES2("libDir","LibDir",XmRString,XPointer,libDir,XmRString,".")RES2("infoDir","InfoDir",XmRString,XPointer,infoDir,XmRString,".")RES2("pokeDir","PokeDir",XmRString,XPointer,pokeDir,XmRString,".")RES2("quiet","Quiet",XmRBoolean,Boolean,quiet,XmRImmediate,FALSE)RES2("core","Core",XmRBoolean,Boolean,core,XmRImmediate,FALSE)RES2("monocrome","Monocrome",XmRBoolean,Boolean,monocrome,XmRImmediate,FALSE)RES2("private","Private",XmRBoolean,Boolean,private,XmRImmediate,FALSE)RES2("xsync","Xsync",XmRBoolean,Boolean,xsync,XmRImmediate,FALSE)
#ifdef DEBUG
RES2("debug","Debug",XmRInt,unsigned int,debug,XmRImmediate,0)
#endif
RES2("speed","Speed",XmRInt,int,speed,XmRImmediate,100)RES2("fastmode","Fastmode",XmRBoolean,Boolean,fastmode,XmRImmediate,FALSE)RES2("warn48","Warn48",XmRBoolean,Boolean,warn48,XmRImmediate,FALSE)RES2("smart","Smart",XmRBoolean,Boolean,smartAttach,XmRImmediate,TRUE)RES2("scale","Scale",XmRInt,int,scale,XmRImmediate,1)RES2("refresh","Refresh",XmRInt,int,refresh,XmRImmediate,3)RES2("cache","Cache",XmRBoolean,Boolean,cache,XmRImmediate,TRUE)RES2("tapeQuickload","TapeQuickload",XmRBoolean,Boolean,tapeQuickload,XmRImmediate,TRUE)RES2("tapeFastload","TapeFastload",XmRBoolean,Boolean,tapeFastload,XmRImmediate,FALSE)RES2("tapeAutostop","TapeAutostop",XmRBoolean,Boolean,tapeAutostop,XmRImmediate,FALSE)RES2("tapeNoise","TapeNoise",XmRBoolean,Boolean,tapeNoise,XmRImmediate,FALSE)RES2("tapeQuicksave","TapeQuicksave",XmRBoolean,Boolean,tapeQuicksave,XmRImmediate,TRUE)RES2("joyType","JoyType",XmRInt,int,joyType,XmRImmediate,JOY_TYPE_KEMPSTON)
#ifdef HAVE_JOYSTICK
RES2("joy","Joy",XmRBoolean,Boolean,joy,XmRImmediate,FALSE)RES2("joyDev","JoyDev",XmRString,XPointer,joyDev,XmRString,JOY_DEV)
#ifdef HAVE_LIBJSW
RES2("joyCalibration","JoyCalibration",XmRString,XPointer,joyCalibration,XmRString,".joystick")
#endif
RES2("joyAxisX","JoyAxisX",XmRInt,int,joyAxisX,XmRImmediate,0)RES2("joyAxisY","JoyAxisY",XmRInt,int,joyAxisY,XmRImmediate,1)RES2("joyButtonFire","JoyButtonFire",XmRInt,int,joyButtonFire,XmRImmediate,0)RES2("joyButtonAutofire","JoyButtonAutofire",XmRInt,int,joyButtonAutofire,XmRImmediate,1)RES2("joyButtonJuggle","JoyButtonJuggle",XmRInt,int,joyButtonJuggle,XmRImmediate,2)RES2("joyButtonMagic1","JoyButtonMagic1",XmRInt,int,joyButtonMagic1,XmRImmediate,3)RES2("joyButtonMagic2","JoyButtonMagic2",XmRInt,int,joyButtonMagic2,XmRImmediate,4)
#ifndef HAVE_LIBJSW
RES2("joyTolerance","JoyTolerance",XmRInt,int,joyTolerance,XmRImmediate,20)
#endif
RES2("joyAutofire","JoyAutofire",XmRInt,int,joyAutofire,XmRImmediate,25)RES2("joyJuggle","JoyJuggle",XmRInt,int,joyJuggle,XmRImmediate,25)
#endif
RES2("sound","Sound",XmRBoolean,Boolean,sound,XmRImmediate,FALSE)
#ifdef SOUND_NATIVE
#ifdef SOUND_NETWORK
RES2("soundServer","SoundServer",XmRString,XPointer,soundDev,XmRString,SOUND_DEV)
#else
RES2("soundDev","SoundDev",XmRString,XPointer,soundDev,XmRString,SOUND_DEV)
#endif
#endif
RES2("soundNonblocking","SoundNonblocking",XmRBoolean,Boolean,soundNonblocking,XmRImmediate,FALSE)RES2("soundSample","SoundSample",XmRInt,int,soundSample,XmRImmediate,8000)RES2("soundBits","SoundBits",XmRInt,int,soundBits,XmRImmediate,8)RES2("soundStereo","SoundStereo",XmRInt,int,soundStereo,XmRImmediate,AY8912_MODE_MONO)RES2("soundVolumeSp","SoundVolumeSp",XmRInt,unsigned int,soundVolumeSp,XmRImmediate,50)RES2("soundVolumeAy","SoundVolumeAy",XmRInt,unsigned int,soundVolumeAy,XmRImmediate,100)RES2("sp48Rom","Sp48Rom",XmRString,XPointer,sp48Rom,XmRString,"spectrum.rom")RES2("sp128Rom","Sp128Rom",XmRString,XPointer,sp128Rom,XmRString,"128.rom")RES2("sp3Rom","Sp3Rom",XmRString,XPointer,sp3Rom,XmRString,"plus3.rom")RES2("sp3DriveA","Sp3DriveA",XmRString,XPointer,sp3Disks[0],XmRString,"diska.dsk")RES2("sp3DriveB","Sp3DriveB",XmRString,XPointer,sp3Disks[1],XmRString,"diskb.dsk")
#ifdef XZX_PENTAGON
RES2("pentagonRom","PentagonRom",XmRString,XPointer,pentagonRom,XmRString,"pentagon.rom")
#endif
#ifdef XZX_SCORPION
RES2("scorpionRom","ScorpionRom",XmRString,XPointer,scorpionRom,XmRString,"scorpion.rom")
#endif
#ifdef XZX_DIDAKTIK
RES2("didaktikRom","DidaktikRom",XmRString,XPointer,didaktikRom,XmRString,"didaktik.rom")RES2("didaktikDriveA","DidaktikDriveA",XmRString,XPointer,didaktikDisks[0],XmRString,"diska.d80")RES2("didaktikDriveB","DidaktikDriveB",XmRString,XPointer,didaktikDisks[1],XmRString,"diskb.d80")
#endif
#ifdef XZX_IF1
RES2("if1","If1",XmRBoolean,Boolean,if1,XmRImmediate,FALSE)RES2("if1Rom","If1Rom",XmRString,XPointer,if1Rom,XmRString,"if1-v2.rom")RES2("if1Drive1","If1Drive1",XmRString,XPointer,if1Carts[0],XmRString,"cart1.mdr")
#if XZX_IF1_DRIVES > 1
RES2("if1Drive2","If1Drive2",XmRString,XPointer,if1Carts[1],XmRString,"cart2.mdr")
#endif
#if XZX_IF1_DRIVES > 2
RES2("if1Drive3","If1Drive3",XmRString,XPointer,if1Carts[2],XmRString,"cart3.mdr")
#endif
#if XZX_IF1_DRIVES > 3
RES2("if1Drive4","If1Drive4",XmRString,XPointer,if1Carts[3],XmRString,"cart4.mdr")
#endif
#if XZX_IF1_DRIVES > 4
RES2("if1Drive5","If1Drive5",XmRString,XPointer,if1Carts[4],XmRString,"cart5.mdr")
#endif
#if XZX_IF1_DRIVES > 5
RES2("if1Drive6","If1Drive6",XmRString,XPointer,if1Carts[5],XmRString,"cart6.mdr")
#endif
#if XZX_IF1_DRIVES > 6
RES2("if1Drive7","If1Drive7",XmRString,XPointer,if1Carts[6],XmRString,"cart7.mdr")
#endif
#if XZX_IF1_DRIVES > 7
RES2("if1Drive8","If1Drive8",XmRString,XPointer,if1Carts[7],XmRString,"cart8.mdr")
#endif
RES2("if1Rs232Mode","If1Rs232Mode",XmRInt,int,if1Rs232Mode,XmRImmediate,0)
#endif 
#ifdef XZX_OPUS
RES2("opus","Opus",XmRBoolean,Boolean,opus,XmRImmediate,FALSE)RES2("opusRom","OpusRom",XmRString,XPointer,opusRom,XmRString,"opus.rom")RES2("opusDriveA","OpusDriveA",XmRString,XPointer,opusDisks[0],XmRString,"diska.opd")RES2("opusDriveB","OpusDriveB",XmRString,XPointer,opusDisks[1],XmRString,"diskb.opd")
#endif
#ifdef XZX_MF
RES2("mf","Mf",XmRBoolean,Boolean,mf1,XmRImmediate,FALSE)RES2("mf1Rom","Mf1Rom",XmRString,XPointer,mf1Rom,XmRString,"mf1.rom")RES2("mf128Rom","Mf128Rom",XmRString,XPointer,mf128Rom,XmRString,"mf128.rom")RES2("mf3Rom","Mf3Rom",XmRString,XPointer,mf3Rom,XmRString,"mf3.rom")
#endif
#ifdef XZX_TRDOS
RES2("trdos","Trdos",XmRBoolean,Boolean,trdos,XmRImmediate,FALSE)RES2("trdosRom","TrdosRom",XmRString,XPointer,trdosRom,XmRString,"trdos.rom")RES2("trdosDriveA","TrdosDriveA",XmRString,XPointer,trdosDisks[0],XmRString,"diska.trd")RES2("trdosDriveB","TrdosDriveB",XmRString,XPointer,trdosDisks[1],XmRString,"diskb.trd")RES2("trdosDriveC","TrdosDriveC",XmRString,XPointer,trdosDisks[2],XmRString,"diskc.trd")RES2("trdosDriveD","TrdosDriveD",XmRString,XPointer,trdosDisks[3],XmRString,"diskd.trd")
#endif
#ifdef XZX_PLUSD
RES2("plusd","Plusd",XmRBoolean,Boolean,plusd,XmRImmediate,FALSE)RES2("plusdRom","PlusdRom",XmRString,XPointer,plusdRom,XmRString,"plusd.rom")RES2("plusdDriveA","PlusdDriveA",XmRString,XPointer,plusdDisks[0],XmRString,"diska.mgt")RES2("plusdDriveB","PlusdDriveB",XmRString,XPointer,plusdDisks[1],XmRString,"diskb.mgt")
#endif
#ifdef XZX_LIGHTGUN
RES2("lightgun","Lightgun",XmRBoolean,Boolean,lightgun,XmRImmediate,FALSE)
#endif
#ifdef XZX_KMOUSE
RES2("kmouse","Kmouse",XmRBoolean,Boolean,kmouse,XmRImmediate,FALSE)
#endif
#ifdef XZX_PRINTER
RES2("printerMode","PrinterMode",XmRInt,int,printerMode,XmRImmediate,PRINTER_MODE_NONE)RES2("printerFile","PrinterFile",XmRString,XPointer,printerFile,XmRString,"dump.prt")RES2("printerCmd","PrinterCmd",XmRString,XPointer,printerCmd,XmRString,"lpr")
#endif
#ifdef XZX_IF1_RS232
RES2("rs232Dev","Rs232Dev",XmRString,XPointer,rs232Dev,XmRString,"/dev/ttyS0")RES2("rs232Baud","Rs232Baud",XmRInt,int,rs232Baud,XmRImmediate,9600)
#endif
};static KeySym defaultKeys[NUM_KEYMAPPINGS]={XK_q,XK_a,XK_o,XK_p,XK_space};static XtResource resourceKeys[]={RES3("joyUp","JoyUp",XmRString,XPointer,0*sizeof(char*),XmRString,"q")RES3("joyDown","JoyDown",XmRString,XPointer,1*sizeof(char*),XmRString,"a")RES3("joyLeft","JoyLeft",XmRString,XPointer,2*sizeof(char*),XmRString,"o")RES3("joyRight","JoyRight",XmRString,XPointer,3*sizeof(char*),XmRString,"p")RES3("joyFire","JoyFire",XmRString,XPointer,4*sizeof(char*),XmRString,"space")RES3("machine","Machine",XmRString,XPointer,5*sizeof(char*),XmRString,"48")};static const char*mach2str[]={"48-2","48","128","3",
#ifdef XZX_PENTAGON
"Pentagon",
#endif
#ifdef XZX_SCORPION
"Scorpion",
#endif
#ifdef XZX_DIDAKTIK
"Didaktik",
#endif
};void ResourceRead(int*argcp,const char**argvp){const char*machStr;char*specialKeys[NELEM(resourceKeys)];int machId,i;if(*argcp>1){if(argvp[1][0]=='-'){if(strcmp(argvp[1],"-version")==0){resourcePrintCopyright();resourcePrintVersion();}else{if(strcmp(argvp[1],"-help")==0){(void)fprintf(stderr,"Usage: %s [options] [snapshot file]\n",ProgName);}else{(void)fprintf(stderr,"Unknown option \"%s\".\n",argvp[1]);}(void)fprintf(stderr,"For available options see manual page.\n");}exit(1);}}resourcePrintCopyright();XtVaGetApplicationResources(XwinDataP->topLevel,ResourceDataP,resourceDefaults,XtNumber(resourceDefaults),XtNull);XtVaGetApplicationResources(XwinDataP->topLevel,&specialKeys,resourceKeys,XtNumber(resourceKeys),XtNull);machStr=specialKeys[NELEM(specialKeys)-1];for(machId=0;machId<NELEM(mach2str);machId++){if(strcasecmp(machStr,mach2str[machId])==0){goto found_machine;}}Msg(M_WARN,"invalid emulation mode %s, using 48",machStr);machId=SP_48_3;found_machine:CFGSET(machine,machId);machStr=mach2str[machId];if(CFGGET(speed)<10||CFGGET(speed)>200){Msg(M_WARN,"speed value out of range, setting to default 100%%");CFGSET(speed,100);}if(CFGGET(scale)<1||CFGGET(scale)>3){Msg(M_WARN,"scale factor out of range, setting to default 1");CFGSET(scale,1);}if(CFGGET(refresh)<1||CFGGET(refresh)>50){Msg(M_WARN,"refresh rate out of range, setting to default 3");CFGSET(refresh,3);}if(CFGGET(tapeFastload)!=0&&CFGGET(tapeNoise)!=0){Msg(M_WARN,"loading noise in fast mode not supported, disabling");CFGSET(tapeNoise,0);}if(CFGGET(joyType)<JOY_TYPE_SINCLAIR1||CFGGET(joyType)>JOY_TYPE_KEMPSTON){Msg(M_WARN,"invalid joystick type, using Kempston");CFGSET(joyType,JOY_TYPE_KEMPSTON);}for(i=KM_JOY_UP;i<=KM_JOY_FIRE;i++){CFGSET(joyKeys[i],XStringToKeysym(specialKeys[i]));if(CFGGET(joyKeys[i])==NoSymbol){Msg(M_WARN,"unknown keysym <%s> found, using <%s>",specialKeys[i],XKeysymToString(defaultKeys[i]));CFGSET(joyKeys[i],defaultKeys[i]);}}
#ifdef HAVE_JOYSTICK
#ifndef HAVE_LIBJSW
if(CFGGET(joyTolerance)<0||CFGGET(joyTolerance)>500){Msg(M_WARN,"joystick tolerance out of range, setting to default 20");CFGSET(joyTolerance,20);}
#endif
if(CFGGET(joyAutofire)<1||CFGGET(joyAutofire)>50){Msg(M_WARN,"autofire speed out of range, setting to default 25");CFGSET(joyAutofire,25);}if(CFGGET(joyJuggle)<1||CFGGET(joyJuggle)>50){Msg(M_WARN,"juggle speed out of range, setting to default 25");CFGSET(joyJuggle,25);}
#endif
if(CFGGET(soundSample)<8000||CFGGET(soundSample)>48000){Msg(M_WARN,"sound sample rate out of range, setting to default 8000");CFGSET(soundSample,8000);}if(CFGGET(soundBits)!=8&&CFGGET(soundBits)!=16){Msg(M_WARN,"sound sample bits out of range, setting to default 8");CFGSET(soundSample,8);}
#ifdef EVALUATION
CFGSET(soundStereo,AY8912_MODE_MONO);
#else
if(CFGGET(soundStereo)<AY8912_MODE_MONO||CFGGET(soundStereo)>AY8912_MODE_ABC){Msg(M_WARN,"invalid AY mode, using mono");CFGSET(soundStereo,AY8912_MODE_MONO);}
#endif
if(CFGGET(soundVolumeSp)>100){Msg(M_WARN,"sound volume out of range, setting to default 50");CFGSET(soundVolumeSp,50);}if(CFGGET(soundVolumeAy)>100){Msg(M_WARN,"sound volume out of range, setting to default 100");CFGSET(soundVolumeAy,100);}for(i=0;i<NELEM(CFGGET(sp3Disks));i++){CFGSET(sp3Disks[i],Strdup(CFGGET(sp3Disks[i]),"ResourceRead"));}
#ifdef XZX_DIDAKTIK
for(i=0;i<NELEM(CFGGET(didaktikDisks));i++){CFGSET(didaktikDisks[i],Strdup(CFGGET(didaktikDisks[i]),"ResourceRead"));}
#endif
#ifdef XZX_IF1
for(i=0;i<NELEM(CFGGET(if1Carts));i++){CFGSET(if1Carts[i],Strdup(CFGGET(if1Carts[i]),"ResourceRead"));}if(CFGGET(if1Rs232Mode)<0||CFGGET(if1Rs232Mode)>2){Msg(M_WARN,"invalid RS232 mode, setting to 0");CFGSET(if1Rs232Mode,0);}
#endif 
#ifdef XZX_OPUS
for(i=0;i<NELEM(CFGGET(opusDisks));i++){CFGSET(opusDisks[i],Strdup(CFGGET(opusDisks[i]),"ResourceRead"));}
#endif
#ifdef XZX_TRDOS
for(i=0;i<NELEM(CFGGET(trdosDisks));i++){CFGSET(trdosDisks[i],Strdup(CFGGET(trdosDisks[i]),"ResourceRead"));}
#endif
#ifdef XZX_PLUSD
for(i=0;i<NELEM(CFGGET(plusdDisks));i++){CFGSET(plusdDisks[i],Strdup(CFGGET(plusdDisks[i]),"ResourceRead"));}
#endif
#ifdef XZX_PRINTER
if(CFGGET(printerMode)<PRINTER_MODE_NONE||CFGGET(printerMode)>PRINTER_MODE_CMD){Msg(M_WARN,"invalid printer mode, setting to 0");CFGSET(printerMode,PRINTER_MODE_NONE);}
#endif
#ifdef XZX_MF
CFGSET(mf128,CFGGET(mf1));CFGSET(mf3,CFGGET(mf1));
#endif
#ifdef DEBUG
if((CFGGET(debug)&D_X11)!=0){resourcePrint();}
#endif
}static void resourcePrintCopyright(void){(void)fprintf(stderr,"XZX-Pro is copyright (c) 1995-2005 Erik Kunze\n""XZX-Pro comes with no warranty; see the file COPYRIGHT for details.\n\n");}static void resourcePrintVersion(void){(void)fprintf(stderr,"This is %s",Version);(void)fprintf(stderr," with the following compile time options:\n"" *  XZX-Pro is built for a"
#ifndef WORDS_BIGENDIAN
" little-endian architecture.\n"
#else
" big-endian architecture.\n"
#endif
#ifdef HAVE_JOYSTICK
" *  Analogue joystick emulation is possible.\n"
#endif
#ifdef SOUND_NATIVE
" *  Speaker sound emulation is enabled.\n"
#ifdef EVALUATION
" *  AY-8912 sound emulation is enabled.\n"
#else
" *  AY-8912 sound emulation (ACB/ABC stereo) is enabled.\n"
#endif
#endif
#ifdef XZX_PENTAGON
" *  Pentagon 128 emulation is enabled.\n"
#endif
#ifdef XZX_SCORPION
" *  Scorpion 256 emulation is enabled.\n"
#endif
#ifdef XZX_DIDAKTIK
" *  Didaktik Kompakt 128K emulation is enabled.\n"
#endif
#ifdef XZX_IF1
" *  Interface 1, microdrive & RS232 emulation are enabled.\n"
#endif
#ifdef XZX_OPUS
" *  Opus Discovery emulation is enabled.\n"
#endif
#ifdef XZX_MF
" *  Multiface emulation is enabled.\n"
#endif
#ifdef XZX_TRDOS
" *  Beta 128 emulation is enabled.\n"
#endif
#ifdef XZX_PLUSD
" *  +D emulation is enabled.\n"
#endif
#ifdef XZX_LIGHTGUN
" *  Lightgun emulation is enabled.\n"
#endif
#ifdef XZX_KMOUSE
" *  Kempston Mouse emulation is enabled.\n"
#endif
#ifdef XZX_PRINTER
" *  Printer emulation is enabled.\n"
#endif
#ifdef DEBUG
" *  Debugging is possible.\n"
#endif
);}
#ifdef DEBUG
static void resourcePrint(void){
#ifdef XZX_IF1
int i;
#endif
Msg(M_DEBUG,"libDir           : %s",CFGGET(libDir));Msg(M_DEBUG,"infoDir          : %s",CFGGET(infoDir));Msg(M_DEBUG,"pokeDir          : %s",CFGGET(pokeDir));Msg(M_DEBUG,"quiet            : %s",BOOL(CFGGET(quiet)));Msg(M_DEBUG,"core             : %s",BOOL(CFGGET(core)));Msg(M_DEBUG,"monocrome        : %s",BOOL(CFGGET(monocrome)));Msg(M_DEBUG,"private          : %s",BOOL(CFGGET(private)));Msg(M_DEBUG,"xsync            : %s",BOOL(CFGGET(xsync)));
#ifdef DEBUG
Msg(M_DEBUG,"debug            : %u",CFGGET(debug));
#endif
Msg(M_DEBUG,"machine          : %s",mach2str[CFGGET(machine)]);Msg(M_DEBUG,"speed            : %d",CFGGET(speed));Msg(M_DEBUG,"fastmode         : %s",BOOL(CFGGET(fastmode)));Msg(M_DEBUG,"warn48           : %s",BOOL(CFGGET(warn48)));Msg(M_DEBUG,"smartAttach      : %s",BOOL(CFGGET(smartAttach)));Msg(M_DEBUG,"scale            : %d",CFGGET(scale));Msg(M_DEBUG,"refresh          : %d",CFGGET(refresh));Msg(M_DEBUG,"cache            : %s",BOOL(CFGGET(cache)));Msg(M_DEBUG,"tapeQuickload    : %s",BOOL(CFGGET(tapeQuickload)));Msg(M_DEBUG,"tapeFastload     : %s",BOOL(CFGGET(tapeFastload)));Msg(M_DEBUG,"tapeAutostop     : %s",BOOL(CFGGET(tapeAutostop)));Msg(M_DEBUG,"tapeNoise        : %s",BOOL(CFGGET(tapeNoise)));Msg(M_DEBUG,"tapeQuicksave    : %s",BOOL(CFGGET(tapeQuicksave)));Msg(M_DEBUG,"joyType          : %d",CFGGET(joyType));Msg(M_DEBUG,"joyUp            : %s",KEY(CFGGET(joyUp)));Msg(M_DEBUG,"joyDown          : %s",KEY(CFGGET(joyDown)));Msg(M_DEBUG,"joyLeft          : %s",KEY(CFGGET(joyLeft)));Msg(M_DEBUG,"joyRight         : %s",KEY(CFGGET(joyRight)));Msg(M_DEBUG,"joyFire          : %s",KEY(CFGGET(joyFire)));
#ifdef HAVE_JOYSTICK
Msg(M_DEBUG,"joy              : %s",BOOL(CFGGET(joy)));Msg(M_DEBUG,"joyDev           : %s",CFGGET(joyDev));
#ifdef HAVE_LIBJSW
Msg(M_DEBUG,"joyCalibration   : %s",CFGGET(joyCalibration));
#endif
Msg(M_DEBUG,"joyAxisX         : %d",CFGGET(joyAxisX));Msg(M_DEBUG,"joyAxisY         : %d",CFGGET(joyAxisY));Msg(M_DEBUG,"joyButtonFire    : %d",CFGGET(joyButtonFire));Msg(M_DEBUG,"joyButtonAutofire: %d",CFGGET(joyButtonAutofire));Msg(M_DEBUG,"joyButtonJuggle  : %d",CFGGET(joyButtonJuggle));Msg(M_DEBUG,"joyButtonMagic1  : %d",CFGGET(joyButtonMagic1));Msg(M_DEBUG,"joyButtonMagic2  : %d",CFGGET(joyButtonMagic2));
#ifndef HAVE_LIBJSW
Msg(M_DEBUG,"joyTolerance     : %d",CFGGET(joyTolerance));
#endif
Msg(M_DEBUG,"joyAutofire      : %d",CFGGET(joyAutofire));Msg(M_DEBUG,"joyJuggle        : %d",CFGGET(joyJuggle));
#endif
Msg(M_DEBUG,"sound            : %s",BOOL(CFGGET(sound)));
#ifdef SOUND_NATIVE
#ifdef SOUND_NETWORK
Msg(M_DEBUG,"soundServer      : %s",CFGGET(soundDev));
#else
Msg(M_DEBUG,"soundDev         : %s",CFGGET(soundDev));
#endif
#endif
Msg(M_DEBUG,"soundNonblocking : %s",BOOL(CFGGET(soundStereo)));Msg(M_DEBUG,"soundSample      : %d",CFGGET(soundSample));Msg(M_DEBUG,"soundBits        : %d",CFGGET(soundBits));Msg(M_DEBUG,"soundStereo      : %d",CFGGET(soundStereo));Msg(M_DEBUG,"soundVolumeSp    : %u",CFGGET(soundVolumeSp));Msg(M_DEBUG,"soundVolumeAy    : %u",CFGGET(soundVolumeAy));Msg(M_DEBUG,"sp48Rom          : %s",CFGGET(sp48Rom));Msg(M_DEBUG,"sp128Rom         : %s",CFGGET(sp128Rom));Msg(M_DEBUG,"sp3Rom           : %s",CFGGET(sp3Rom));Msg(M_DEBUG,"sp3DriveA        : %s",CFGGET(sp3Disks[0]));Msg(M_DEBUG,"sp3DriveB        : %s",CFGGET(sp3Disks[1]));
#ifdef XZX_PENTAGON
Msg(M_DEBUG,"pentagonRom      : %s",CFGGET(pentagonRom));
#endif
#ifdef XZX_SCORPION
Msg(M_DEBUG,"scorpionRom      : %s",CFGGET(scorpionRom));
#endif
#ifdef XZX_DIDAKTIK
Msg(M_DEBUG,"didaktikRom      : %s",CFGGET(didaktikRom));Msg(M_DEBUG,"didaktikDriveA   : %s",CFGGET(didaktikDisks[0]));Msg(M_DEBUG,"didaktikDriveB   : %s",CFGGET(didaktikDisks[1]));
#endif
#ifdef XZX_IF1
Msg(M_DEBUG,"if1              : %s",BOOL(CFGGET(if1)));Msg(M_DEBUG,"if1Rom           : %s",CFGGET(if1Rom));for(i=0;i<XZX_IF1_DRIVES;i++){Msg(M_DEBUG,"if1Drive%d        : %s",i,CFGGET(if1Carts[i]));}Msg(M_DEBUG,"if1Rs232Mode     : %d",CFGGET(if1Rs232Mode));
#endif
#ifdef XZX_OPUS
Msg(M_DEBUG,"opus             : %s",BOOL(CFGGET(opus)));Msg(M_DEBUG,"opusRom          : %s",CFGGET(opusRom));Msg(M_DEBUG,"opusDriveA       : %s",CFGGET(opusDisks[0]));Msg(M_DEBUG,"opusDriveB       : %s",CFGGET(opusDisks[1]));
#endif
#ifdef XZX_MF
Msg(M_DEBUG,"mf               : %s",BOOL(CFGGET(mf1)));Msg(M_DEBUG,"mf1Rom           : %s",CFGGET(mf1Rom));Msg(M_DEBUG,"mf128Rom         : %s",CFGGET(mf128Rom));Msg(M_DEBUG,"mf3Rom           : %s",CFGGET(mf3Rom));
#endif
#ifdef XZX_TRDOS
Msg(M_DEBUG,"trdos            : %s",BOOL(CFGGET(trdos)));Msg(M_DEBUG,"trdosRom         : %s",CFGGET(trdosRom));Msg(M_DEBUG,"trdosDriveA      : %s",CFGGET(trdosDisks[0]));Msg(M_DEBUG,"trdosDriveB      : %s",CFGGET(trdosDisks[1]));Msg(M_DEBUG,"trdosDriveC      : %s",CFGGET(trdosDisks[2]));Msg(M_DEBUG,"trdosDriveD      : %s",CFGGET(trdosDisks[3]));
#endif
#ifdef XZX_PLUSD
Msg(M_DEBUG,"plusd            : %s",BOOL(CFGGET(plusd)));Msg(M_DEBUG,"plusdRom         : %s",CFGGET(plusdRom));Msg(M_DEBUG,"plusdDriveA      : %s",CFGGET(plusdDisks[0]));Msg(M_DEBUG,"plusdDriveB      : %s",CFGGET(plusdDisks[1]));
#endif
#ifdef XZX_KLIGHTGUN
Msg(M_DEBUG,"lightgun         : %s",BOOL(CFGGET(lightgun)));
#endif
#ifdef XZX_KMOUSE
Msg(M_DEBUG,"kmouse           : %s",BOOL(CFGGET(kmouse)));
#endif
#ifdef XZX_PRINTER
Msg(M_DEBUG,"printerMode      : %d",CFGGET(printerMode));Msg(M_DEBUG,"printerFile      : %s",CFGGET(printerFile));Msg(M_DEBUG,"printerCmd       : %s",CFGGET(printerCmd));
#endif
#ifdef XZX_IF1_RS232
Msg(M_DEBUG,"rs232Dev         : %s",CFGGET(rs232Dev));Msg(M_DEBUG,"rs232Baud        : %d",CFGGET(rs232Baud));
#endif
}
#endif
int ResourceWrite(void){FILE*fp;char path[MAXPATHLEN];const char*home=getenv("HOME");int i;char*file;if(home==(const char*)0){Msg(M_WARN,"environment variable HOME is not set");return-1;}(void)sprintf(path,"%s/%s",home,RESOURCE_FILE);if((fp=Fopen(path,"wb"))==(FILE*)0){Msg(M_PERR,"couldn't open <%s> for writing",path);return-1;}(void)fprintf(fp,"! XZX-Pro Preferences File\n""! Version: "VERSION" ("HOST")\n""! This is a generated file!  Do not edit.\n\n");(void)fprintf(fp,"Xzx*libDir: %s\n""Xzx*infoDir: %s\n""Xzx*pokeDir: %s\n""Xzx*quiet: %s\n""Xzx*monocrome: %s\n""Xzx*private: %s\n",CFGGET(libDir),CFGGET(infoDir),CFGGET(pokeDir),BOOL(CFGGET(quiet)),BOOL(CFGGET(monocrome)),BOOL(CFGGET(private)));(void)fprintf(fp,"Xzx*xsync: %s\n",BOOL(CFGGET(xsync)));
#ifdef DEBUG
(void)fprintf(fp,"Xzx*debug: %u\n",CFGGET(debug));
#endif
(void)fprintf(fp,"Xzx*machine: %s\n""Xzx*speed: %d\n""Xzx*fastmode: %s\n""Xzx*warn48: %s\n""Xzx*smart: %s\n""Xzx*scale: %d\n""Xzx*refresh: %d\n""Xzx*cache: %s\n",mach2str[CFGGET(machine)],CFGGET(speed),BOOL(CFGGET(fastmode)&1),BOOL(CFGGET(warn48)),BOOL(CFGGET(smartAttach)),CFGGET(scale),CFGGET(refresh),BOOL(CFGGET(cache)));(void)fprintf(fp,"Xzx*tapeQuickload: %s\n""Xzx*tapeFastload: %s\n""Xzx*tapeAutostop: %s\n""Xzx*tapeNoise: %s\n""Xzx*tapeQuicksave: %s\n",BOOL(CFGGET(tapeQuickload)),BOOL(CFGGET(tapeFastload)),BOOL(CFGGET(tapeAutostop)),BOOL(CFGGET(tapeNoise)),BOOL(CFGGET(tapeQuicksave)));(void)fprintf(fp,"Xzx*joyType: %d\n""Xzx*joyUp: %s\n""Xzx*joyDown: %s\n""Xzx*joyLeft: %s\n""Xzx*joyRight: %s\n""Xzx*joyFire: %s\n",CFGGET(joyType),KEY(CFGGET(joyUp)),KEY(CFGGET(joyDown)),KEY(CFGGET(joyLeft)),KEY(CFGGET(joyRight)),KEY(CFGGET(joyFire)));
#ifdef HAVE_JOYSTICK
(void)fprintf(fp,"Xzx*joy: %s\n""Xzx*joyDev: %s\n",BOOL(CFGGET(joy)),CFGGET(joyDev));
#ifdef HAVE_LIBJSW
(void)fprintf(fp,"Xzx*joyCalibration: %s\n",CFGGET(joyCalibration));
#endif
(void)fprintf(fp,"Xzx*joyAxisX: %d\n""Xzx*joyAxisY: %d\n""Xzx*joyButtonFire: %d\n""Xzx*joyButtonAutofire: %d\n""Xzx*joyButtonJuggle: %d\n""Xzx*joyButtonMagic1: %d\n""Xzx*joyButtonMagic2: %d\n",CFGGET(joyAxisX),CFGGET(joyAxisY),CFGGET(joyButtonFire),CFGGET(joyButtonAutofire),CFGGET(joyButtonJuggle),CFGGET(joyButtonMagic1),CFGGET(joyButtonMagic2));
#ifndef HAVE_LIBJSW
(void)fprintf(fp,"Xzx*joyTolerance: %d\n",CFGGET(joyTolerance));
#endif
(void)fprintf(fp,"Xzx*joyAutofire: %d\n""Xzx*joyJuggle: %d\n",CFGGET(joyAutofire)>0?CFGGET(joyAutofire):-CFGGET(joyAutofire),CFGGET(joyJuggle)>0?CFGGET(joyJuggle):-CFGGET(joyJuggle));
#endif
(void)fprintf(fp,"Xzx*sound: %s\n",BOOL(CFGGET(sound)));
#ifdef SOUND_NATIVE
#ifdef SOUND_NETWORK
if(CFGGET(soundDev)!=(char*)0){(void)fprintf(fp,"Xzx*soundServer: %s\n",CFGGET(soundDev));}
#else
(void)fprintf(fp,"Xzx*soundDev: %s\n",CFGGET(soundDev));
#endif
#endif
(void)fprintf(fp,"Xzx*soundNonblocking: %s\n""Xzx*soundSample: %d\n""Xzx*soundBits: %d\n""Xzx*soundStereo: %d\n""Xzx*soundVolumeSp: %u\n""Xzx*soundVolumeAy: %u\n",BOOL(CFGGET(soundNonblocking)),CFGGET(soundSample),CFGGET(soundBits),CFGGET(soundStereo),SoundGetSpeaker()*25,SoundGetAY()*25);(void)fprintf(fp,"Xzx*sp48Rom: %s\n""Xzx*sp128Rom: %s\n""Xzx*sp3Rom: %s\n",CFGGET(sp48Rom),CFGGET(sp128Rom),CFGGET(sp3Rom));for(i=0;i<NELEM(CFGGET(sp3Disks));i++){if((file=CFGGET(sp3Disks[i]))!=(char*)0){(void)fprintf(fp,"Xzx*sp3Drive%c: %s\n",(char)('A'+i),file);}}
#ifdef XZX_PENTAGON
(void)fprintf(fp,"Xzx*pentagonRom: %s\n",CFGGET(pentagonRom));
#endif
#ifdef XZX_SCORPION
(void)fprintf(fp,"Xzx*scorpionRom: %s\n",CFGGET(scorpionRom));
#endif
#ifdef XZX_DIDAKTIK
(void)fprintf(fp,"Xzx*didaktikRom: %s\n",CFGGET(didaktikRom));for(i=0;i<NELEM(CFGGET(didaktikDisks));i++){if((file=CFGGET(didaktikDisks[i]))!=(char*)0){(void)fprintf(fp,"Xzx*didaktikDrive%c: %s\n",(char)('A'+i),file);}}
#endif
#ifdef XZX_IF1
(void)fprintf(fp,"Xzx*if1: %s\n""Xzx*if1Rom: %s\n",BOOL(CFGGET(if1)),CFGGET(if1Rom));for(i=0;i<XZX_IF1_DRIVES;i++){if((file=CFGGET(if1Carts[i]))!=(char*)0){(void)fprintf(fp,"Xzx*if1Drive%d: %s\n",i+1,file);}}(void)fprintf(fp,"Xzx*if1Rs232Mode: %d\n",CFGGET(if1Rs232Mode));
#endif
#ifdef XZX_OPUS
(void)fprintf(fp,"Xzx*opus: %s\n""Xzx*opusRom: %s\n",BOOL(CFGGET(opus)),CFGGET(opusRom));for(i=0;i<NELEM(CFGGET(opusDisks));i++){if((file=CFGGET(trdosDisks[i]))!=(char*)0){(void)fprintf(fp,"Xzx*opusDrive%c: %s\n",(char)('A'+i),file);}}
#endif
#ifdef XZX_MF
(void)fprintf(fp,"Xzx*mf: %s\n""Xzx*mf1Rom: %s\n""Xzx*mf128Rom: %s\n""Xzx*mf3Rom: %s\n",BOOL((CFGGET(mf1)>0||CFGGET(mf128)>0||CFGGET(mf3)>0)),CFGGET(mf1Rom),CFGGET(mf128Rom),CFGGET(mf3Rom));
#endif
#ifdef XZX_TRDOS
(void)fprintf(fp,"Xzx*trdos: %s\n""Xzx*trdosRom: %s\n",BOOL(CFGGET(trdos)),CFGGET(trdosRom));for(i=0;i<NELEM(CFGGET(trdosDisks));i++){if((file=CFGGET(trdosDisks[i]))!=(char*)0){(void)fprintf(fp,"Xzx*trdosDrive%c: %s\n",(char)('A'+i),file);}}
#endif
#ifdef XZX_PLUSD
(void)fprintf(fp,"Xzx*plusd: %s\n""Xzx*plusdRom: %s\n",BOOL(CFGGET(plusd)),CFGGET(plusdRom));for(i=0;i<NELEM(CFGGET(plusdDisks));i++){if((file=CFGGET(plusdDisks[i]))!=(char*)0){(void)fprintf(fp,"Xzx*plusdDrive%c: %s\n",(char)('A'+i),file);}}
#endif
#ifdef XZX_LIGHTGUN
(void)fprintf(fp,"Xzx*lightgun: %s\n",BOOL(CFGGET(lightgun)));
#endif
#ifdef XZX_KMOUSE
(void)fprintf(fp,"Xzx*kmouse: %s\n",BOOL(CFGGET(kmouse)));
#endif
#ifdef XZX_PRINTER
(void)fprintf(fp,"Xzx*printerMode: %d\n""Xzx*printerFile: %s\n""Xzx*printerCmd: %s\n",CFGGET(printerMode),CFGGET(printerFile),CFGGET(printerCmd));
#endif
#ifdef XZX_IF1_RS232
(void)fprintf(fp,"Xzx*rs232Dev: %s\n""Xzx*rs232Baud: %d\n",CFGGET(rs232Dev),CFGGET(rs232Baud));
#endif
(void)fprintf(fp,"\n! EOF\n");(void)fclose(fp);return 0;}
