/*********************************************************************************************************************************
 * Copyright (c) Erik Kunze 1995 - 2007
 *
 * This file is a part of the Spectrum emulator package 'XZX-Pro', and may not be distributed.  The copyright holder makes no
 * representations about the suitability of this software for any purpose.  It is provided "as is" without express or implied
 * warranty. THE CODE MAY NOT BE MODIFIED OR REUSED WITHOUT PERMISSION!
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Erik Kunze
 ********************************************************************************************************************************/
#ifndef _XZX_UI_RESOURCE_H
#define _XZX_UI_RESOURCE_H
#include <X11/Xlib.h>
#include <X11/Intrinsic.h>
typedef struct _resourceData{char*libDir;char*infoDir;char*pokeDir;int quiet;int core;int monocrome;int private;int xsync;
#ifdef DEBUG
unsigned int debug;
#endif
int machine;unsigned int speed;int fastmode;int warn48;int smartAttach;int scale;int refresh;int cache;int tapeQuickload;int tapeFastload;int tapeAutostop;int tapeNoise;int tapeQuicksave;int joyType;KeySym joyKeys[5];
#ifdef HAVE_JOYSTICK
int joy;char*joyDev;
#ifdef HAVE_LIBJSW
char*joyCalibration;
#endif
int joyAxisX;int joyAxisY;int joyButtonFire;int joyButtonAutofire;int joyButtonJuggle;int joyButtonMagic1;int joyButtonMagic2;
#ifndef HAVE_LIBJSW
int joyTolerance;
#endif
int joyAutofire;int joyJuggle;
#endif
int sound;char*soundDev;int soundNonblocking;int soundSample;int soundBits;int soundStereo;unsigned int soundVolumeSp;unsigned int soundVolumeAy;char*sp48Rom;char*sp128Rom;char*sp3Rom;char*sp3Disks[2];
#ifdef XZX_PENTAGON
char*pentagonRom;
#endif
#ifdef XZX_SCORPION
char*scorpionRom;
#endif
#ifdef XZX_DIDAKTIK
char*didaktikRom;char*didaktikDisks[2];
#endif
#ifdef XZX_IF1
int if1;char*if1Rom;char*if1Carts[XZX_IF1_DRIVES];int if1Rs232Mode;
#endif
#ifdef XZX_OPUS
int opus;char*opusRom;char*opusDisks[2];
#endif
#ifdef XZX_MF
int mf1;char*mf1Rom;int mf128;char*mf128Rom;int mf3;char*mf3Rom;
#endif
#ifdef XZX_TRDOS
int	trdos;char*trdosRom;char*trdosDisks[4];
#endif
#ifdef XZX_PLUSD
int	plusd;char*plusdRom;char*plusdDisks[2];
#endif
#ifdef XZX_LIGHTGUN
int lightgun;
#endif
#ifdef XZX_KMOUSE
int kmouse;
#endif
#ifdef XZX_PRINTER
int printerMode;const char*printerFile;const char*printerCmd;
#endif
#ifdef XZX_IF1_RS232
char*rs232Dev;int rs232Baud;
#endif
}ResourceData;
#define CFGGET(x)	ResourceDataP->x
#define CFGSET(x,y)	ResourceDataP->x = y
#define joyUp	joyKeys[0]
#define joyDown	joyKeys[1]
#define joyLeft	joyKeys[2]
#define joyRight	joyKeys[3]
#define joyFire	joyKeys[4]
extern void ResourceRead(int*,const char**);extern int ResourceWrite(void);extern ResourceData*ResourceDataP;extern XrmOptionDescRec ResourceOptions[];extern Cardinal ResourceOptionsCount;
#endif 

