/*********************************************************************************************************************************
 * Copyright (c) Erik Kunze 1995 - 2007
 *
 * This file is a part of the Spectrum emulator package 'XZX-Pro', and may not be distributed.  The copyright holder makes no
 * representations about the suitability of this software for any purpose.  It is provided "as is" without express or implied
 * warranty. THE CODE MAY NOT BE MODIFIED OR REUSED WITHOUT PERMISSION!
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Erik Kunze
 ********************************************************************************************************************************/
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
static char rcsid[]="$Id: sbar.c,v 4.25 2006/12/22 14:29:16 erik Rel $";
#include <Xm/Xm.h>
#include <Xm/Form.h>
#include <Xm/Frame.h>
#include <Xm/LabelG.h>
#include <stdio.h>
#include <assert.h>
#include "util.h"
#include "ui/sbar.h"
typedef struct _sbarData{Widget model;Widget speed;Widget led;Pixel onColor,offColor;XtIntervalId timer;}sbarData;
#define SBAR_LED_DELAY	100 
#define XtNull	(XtPointer)0
static void sbarOffLed(XtPointer,XtIntervalId);static sbarData*sbarDataP;Widget SbarCreateBar(Widget parent){Widget bar,frame;Arg arg[10];Cardinal i;sbarDataP=Malloc(sizeof(sbarData),"SbarCreateBar");i=0;XtSetArg(arg[i],XmNmarginHeight,2);i++;XtSetArg(arg[i],XmNmarginWidth,2);i++;XtSetArg(arg[i],XmNfractionBase,100);i++;assert(i<=XtNumber(arg));bar=XmCreateForm(parent,(char*)"sbar",arg,i);XtManageChild(bar);i=0;XtSetArg(arg[i],XmNalignment,XmALIGNMENT_BEGINNING);i++;XtSetArg(arg[i],XmNmarginWidth,0);i++;XtSetArg(arg[i],XmNleftAttachment,XmATTACH_FORM);i++;XtSetArg(arg[i],XmNleftOffset,5);i++;XtSetArg(arg[i],XmNtopAttachment,XmATTACH_FORM);i++;XtSetArg(arg[i],XmNbottomAttachment,XmATTACH_FORM);i++;assert(i<=XtNumber(arg));sbarDataP->model=XmCreateLabelGadget(bar,(char*)"model",arg,i);XtManageChild(sbarDataP->model);i=0;XtSetArg(arg[i],XmNalignment,XmALIGNMENT_BEGINNING);i++;XtSetArg(arg[i],XmNmarginWidth,0);i++;XtSetArg(arg[i],XmNmarginRight,5);i++;XtSetArg(arg[i],XmNleftAttachment,XmATTACH_WIDGET);i++;XtSetArg(arg[i],XmNleftWidget,sbarDataP->model);i++;XtSetArg(arg[i],XmNtopAttachment,XmATTACH_FORM);i++;XtSetArg(arg[i],XmNbottomAttachment,XmATTACH_FORM);i++;assert(i<=XtNumber(arg));sbarDataP->speed=XmCreateLabelGadget(bar,(char*)"speed",arg,i);XtManageChild(sbarDataP->speed);i=0;XtSetArg(arg[i],XmNmappedWhenManaged,False);i++;XtSetArg(arg[i],XmNshadowType,XmSHADOW_IN);i++;XtSetArg(arg[i],XmNmarginHeight,0);i++;XtSetArg(arg[i],XmNmarginWidth,0);i++;XtSetArg(arg[i],XmNrightAttachment,XmATTACH_FORM);i++;XtSetArg(arg[i],XmNrightOffset,5);i++;XtSetArg(arg[i],XmNtopAttachment,XmATTACH_POSITION);i++;XtSetArg(arg[i],XmNtopPosition,20);i++;XtSetArg(arg[i],XmNbottomAttachment,XmATTACH_POSITION);i++;XtSetArg(arg[i],XmNbottomPosition,80);i++;assert(i<=XtNumber(arg));frame=XmCreateFrame(bar,(char*)"frame",arg,i);XtManageChild(frame);i=0;XtSetArg(arg[i],XmNlabelType,XmPIXMAP);i++;XtSetArg(arg[i],XmNwidth,15);i++;assert(i<=XtNumber(arg));sbarDataP->led=XmCreateLabelGadget(frame,(char*)"led",arg,i);XtManageChild(sbarDataP->led);XtVaGetValues(sbarDataP->led,XmNforeground,&(sbarDataP->onColor),XmNbackground,&(sbarDataP->offColor),XtNull);return bar;}void SbarSetModel(const char*name){XmString str=XmStringCreateLtoR((char*)name,XmFONTLIST_DEFAULT_TAG);XtVaSetValues(sbarDataP->model,XmNlabelString,str,XtNull);XmStringFree(str);}void SbarSetSpeed(unsigned int speed,unsigned int fps){static unsigned int prevSpeed=0,prevFps=0;char buf[80];XmString str;if(speed!=prevSpeed||fps!=prevFps){prevSpeed=speed;prevFps=fps;(void)sprintf(buf," at %u%%, %u fps",speed,fps);str=XmStringCreateLtoR(buf,XmFONTLIST_DEFAULT_TAG);XtVaSetValues(sbarDataP->speed,XmNlabelString,str,XtNull);XmStringFree(str);}}void SbarSetLed(SbarLedState state){switch(state){case LED_SHOW:XtMapWidget(XtParent(sbarDataP->led));break;case LED_HIDE:XtUnmapWidget(XtParent(sbarDataP->led));case LED_OFF:if(sbarDataP->timer!=(XtIntervalId)0){XtRemoveTimeOut(sbarDataP->timer);sbarDataP->timer=0;}XtVaSetValues(sbarDataP->led,XmNbackground,sbarDataP->offColor,XtNull);break;case LED_ON:if(sbarDataP->timer!=(XtIntervalId)0){XtRemoveTimeOut(sbarDataP->timer);}sbarDataP->timer=XtAppAddTimeOut(XtWidgetToApplicationContext(sbarDataP->led),SBAR_LED_DELAY,(XtTimerCallbackProc)sbarOffLed,XtNull);XtVaSetValues(sbarDataP->led,XmNbackground,sbarDataP->onColor,XtNull);break;}}static void sbarOffLed(XtPointer client,XtIntervalId id){USED(client);USED(id);sbarDataP->timer=0;XtVaSetValues(sbarDataP->led,XmNbackground,sbarDataP->offColor,XtNull);}
