/*********************************************************************************************************************************
 * Copyright (c) Erik Kunze 1995 - 2007
 *
 * This file is a part of the Spectrum emulator package 'XZX-Pro', and may not be distributed.  The copyright holder makes no
 * representations about the suitability of this software for any purpose.  It is provided "as is" without express or implied
 * warranty. THE CODE MAY NOT BE MODIFIED OR REUSED WITHOUT PERMISSION!
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Erik Kunze
 ********************************************************************************************************************************/
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
#ifndef lint
static char rcsid[]="$Id: toolhelp.c,v 4.14 2006/12/22 14:29:16 erik Rel $";
#endif
#include <Xm/Xm.h>
#include <Xm/Label.h>
#include <stdlib.h>
#include <assert.h>
#include "util.h"
#include "ui/xwin.h"
#include "ui/toolhelp.h"
typedef struct _toolhelpRecord{Widget widget;XmString text;Boolean sensitive;XtIntervalId timer;}toolhelpRecord;
#define TOOLHELP_OFFSET_X	3
#define TOOLHELP_OFFSET_Y	3
static toolhelpRecord*toolhelpFindWidget(Widget);static int toolhelpCompare(void*,void*);static void toolhelpEventhandler(Widget,XtPointer,XEvent*,Boolean*);static void toolhelpTimeout(XtPointer,XtIntervalId);static Llist*toolhelpList=(Llist*)0;static unsigned int toolhelpCount=0;static Widget toolhelpLabel=(Widget)0;void ToolhelpAddWidget(Widget w,const char*text){toolhelpRecord*record;if(toolhelpLabel==(Widget)0){Arg arg[1];Cardinal i;Widget shell=XtVaCreatePopupShell("shell",overrideShellWidgetClass,XwinDataP->topLevel,XmNallowShellResize,True,XtNull);i=0;XtSetArg(arg[i],XmNalignment,XmALIGNMENT_BEGINNING);i++;assert(i<=XtNumber(arg));toolhelpLabel=XmCreateLabel(shell,(char*)"toolhelp",arg,i);XtManageChild(toolhelpLabel);}if((record=toolhelpFindWidget(w))!=(toolhelpRecord*)0){XmStringFree(record->text);}else{record=(toolhelpRecord*)Malloc(sizeof(toolhelpRecord),"ToolhelpAddWidget");toolhelpList=AppendElemList(toolhelpList,record);toolhelpCount++;record->widget=w;record->sensitive=True;record->timer=0;XtAddEventHandler(w,EnterWindowMask,False,toolhelpEventhandler,(XtPointer)record);XtAddEventHandler(w,LeaveWindowMask|ButtonPressMask,False,toolhelpEventhandler,(XtPointer)record);}record->text=XmStringCreateLtoR((char*)text,XmFONTLIST_DEFAULT_TAG);}void ToolhelpRemoveWidget(Widget w){toolhelpRecord*record;if((record=toolhelpFindWidget(w))!=(toolhelpRecord*)0){XtRemoveEventHandler(w,EnterWindowMask,False,toolhelpEventhandler,(XtPointer)record);XtRemoveEventHandler(w,LeaveWindowMask|ButtonPressMask,False,toolhelpEventhandler,(XtPointer)record);XmStringFree(record->text);if(record->timer!=(XtIntervalId)0){XtRemoveTimeOut(record->timer);}toolhelpList=RemoveElemList(record,toolhelpCompare,toolhelpList,(void(*)(void*))0);toolhelpCount--;}}void ToolhelpSetSensitive(Widget w,Boolean sensitive){toolhelpRecord*record;if((record=toolhelpFindWidget(w))!=(toolhelpRecord*)0){record->sensitive=sensitive;}}static toolhelpRecord*toolhelpFindWidget(Widget w){toolhelpRecord*record;unsigned int i;for(i=0;i<toolhelpCount;i++){record=(toolhelpRecord*)RetrieveElemList(toolhelpList,i);assert(record!=(toolhelpRecord*)0);if(record->widget==w){return record;}}return(toolhelpRecord*)0;}static int toolhelpCompare(void*record1,void*record2){return(((toolhelpRecord*)record1)->widget==((toolhelpRecord*)record2)->widget?1:0);}static void toolhelpEventhandler(Widget w,XtPointer client,XEvent*xev,Boolean*cont){toolhelpRecord*record=(toolhelpRecord*)client;USED(cont);if(xev->xany.type==EnterNotify){if(record->sensitive==True&&record->timer==(XtIntervalId)0&&xev->xcrossing.mode==NotifyNormal){record->timer=XtAppAddTimeOut(XtWidgetToApplicationContext(w),1000UL,(XtTimerCallbackProc)toolhelpTimeout,record);}}else{if(record->timer!=(XtIntervalId)0){XtRemoveTimeOut(record->timer);record->timer=(XtIntervalId)0;}XtPopdown(XtParent(toolhelpLabel));}}static void toolhelpTimeout(XtPointer client,XtIntervalId id){static int displayWidth=0,displayHeight=0;toolhelpRecord*record=(toolhelpRecord*)client;USED(id);if(record->sensitive==True){Widget shell=XtParent(toolhelpLabel);Position xWidget,yWidget,xLabel,yLabel;Dimension width,height;if(displayWidth==0){displayWidth=DisplayWidth(XtDisplay(shell),XScreenNumberOfScreen(XtScreen(shell)));displayHeight=DisplayHeight(XtDisplay(shell),XScreenNumberOfScreen(XtScreen(shell)));}XtTranslateCoords(record->widget,(Position)0,(Position)0,&xWidget,&yWidget);XtVaGetValues(record->widget,XmNheight,&height,XtNull);xLabel=xWidget+TOOLHELP_OFFSET_X;yLabel=yWidget+height+TOOLHELP_OFFSET_Y;XtVaSetValues(toolhelpLabel,XmNlabelString,record->text,XtNull);XtVaGetValues(shell,XmNwidth,&width,XmNheight,&height,XtNull);if(xLabel<0){xLabel=TOOLHELP_OFFSET_X;}else if(xLabel+width>displayWidth){xLabel=displayWidth-width-TOOLHELP_OFFSET_X;}if(yLabel+height>displayHeight){yLabel=yWidget-height-TOOLHELP_OFFSET_Y;}XtVaSetValues(shell,XmNx,xLabel,XmNy,yLabel,XtNull);XtPopup(shell,XtGrabNone);}record->timer=(XtIntervalId)0;}
