/*********************************************************************************************************************************
 * Copyright (c) Erik Kunze 1995 - 2007
 *
 * This file is a part of the Spectrum emulator package 'XZX-Pro', and may not be distributed.  The copyright holder makes no
 * representations about the suitability of this software for any purpose.  It is provided "as is" without express or implied
 * warranty. THE CODE MAY NOT BE MODIFIED OR REUSED WITHOUT PERMISSION!
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Erik Kunze
 ********************************************************************************************************************************/
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
static char rcsid[]="$Id: ui.c,v 4.42 2006/12/22 14:29:16 erik Rel $";
#include <Xm/Xm.h>
#include <Xm/ArrowBG.h>
#include <Xm/FileSB.h>
#include <Xm/Form.h>
#include <Xm/Frame.h>
#include <Xm/Label.h>
#include <Xm/List.h>
#include <Xm/MessageB.h>
#include <Xm/SelectioB.h>
#include <Xm/Text.h>
#include <Xm/TextF.h>
#include <assert.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/param.h>
#include <sys/stat.h>
#include <dirent.h>
#include <unistd.h>
#include "util.h"
#include "main.h"
#include "sound/sound.h"
#ifdef HAVE_XPM
#include "ui/splash.h"
#endif
#ifdef XZX_XMOUSE
#include "ui/xmouse.h"
#endif
#include "ui/xwin.h"
#include "ui/ui.h"
typedef struct _fsData{char*fileName;int fileValid;int*fileTypes;}fsData;
#define TIMER_VALUE_BASE	5000
#define TIMER_VALUE_SLOW	500
#define TIMER_VALUE_FAST	50
static void uiDialogCallback(Widget,XtPointer,XtPointer);static int uiShowTextBuffer(const char*,const char*,XtCallbackProc,XtPointer);static void uiFileSelectorReadDirectory(Widget,XtPointer);
#ifdef HAVE_QSORT
static int uiFileSelectorCompare(const char**,const char**);
#endif
static void uiFileSelectorCallback(Widget,XtPointer,XtPointer);static void uiFixiateListWidthCallback(Widget,XtPointer,XtPointer);static void uiSpinboxCallback(Widget,XtPointer,XtPointer);static void uiSpinboxChangeValue(XtPointer,XtIntervalId);static int uiActive;void UiInit(int copyright){uiActive=0;if(copyright!=0){
#ifdef HAVE_XPM
SplashShow();
#else
UiShowAbout();
#endif
}}int UiEnter(void){if(uiActive++==0){SoundControl(SOUND_ACTION_SUSPEND);
#ifdef XZX_XMOUSE
XmouseOff();
#endif
}return uiActive;}int UiLeave(void){uiActive--;assert(uiActive>=0);if(uiActive==0){SoundControl(SOUND_ACTION_RESUME);
#ifdef XZX_XMOUSE
XmouseOn();
#endif
}return uiActive;}int UiIsActive(void){return uiActive;}Widget UiCreateFrame(Widget parent,const char*label){Widget frame,w;Arg arg[3];Cardinal i;i=0;XtSetArg(arg[i],XmNshadowType,XmSHADOW_ETCHED_IN);i++;XtSetArg(arg[i],XmNmarginHeight,5);i++;XtSetArg(arg[i],XmNmarginWidth,5);i++;assert(i<=XtNumber(arg));frame=XmCreateFrame(parent,(char*)"frame",arg,i);XtManageChild(frame);i=0;XtSetArg(arg[i],XmNframeChildType,XmFRAME_TITLE_CHILD);i++;XtSetArg(arg[i],XmNchildVerticalAlignment,XmALIGNMENT_CENTER);i++;assert(i<=XtNumber(arg));w=XmCreateLabel(frame,(char*)label,arg,i);XtManageChild(w);return frame;}Widget UiCreateDialog(int*answer){Widget dialog;XmString title,okLabel;Arg arg[7];Cardinal i;title=XmStringCreateLtoR((char*)"Dialog",XmFONTLIST_DEFAULT_TAG);okLabel=XmStringCreateLtoR((char*)"Done",XmFONTLIST_DEFAULT_TAG);i=0;XtSetArg(arg[i],XmNnoResize,True);i++;XtSetArg(arg[i],XmNautoUnmanage,False);i++;XtSetArg(arg[i],XmNdeleteResponse,XmDO_NOTHING);i++;XtSetArg(arg[i],XmNdialogStyle,XmDIALOG_FULL_APPLICATION_MODAL);i++;XtSetArg(arg[i],XmNdialogTitle,title);i++;XtSetArg(arg[i],XmNokLabelString,okLabel);i++;XtSetArg(arg[i],XtNkeyboardFocusPolicy,XmPOINTER);i++;assert(i<=XtNumber(arg));dialog=XmCreatePromptDialog(XwinDataP->topLevel,(char*)"options",arg,i);XmStringFree(title);XmStringFree(okLabel);XtUnmanageChild(XmSelectionBoxGetChild(dialog,XmDIALOG_COMMAND_TEXT));XtUnmanageChild(XmSelectionBoxGetChild(dialog,XmDIALOG_PROMPT_LABEL));XtUnmanageChild(XmSelectionBoxGetChild(dialog,XmDIALOG_CANCEL_BUTTON));XtUnmanageChild(XmSelectionBoxGetChild(dialog,XmDIALOG_HELP_BUTTON));XtAddCallback(dialog,XmNokCallback,uiDialogCallback,answer);return dialog;}static void uiDialogCallback(Widget w,XtPointer client,XtPointer call){USED(w);switch(((XmAnyCallbackStruct*)call)->reason){case XmCR_OK:*((int*)client)=DIALOG_OK;break;case XmCR_CANCEL:*((int*)client)=DIALOG_CANCEL;break;}}void UiShowDialog(Widget dialog,int*answer){(void)UiEnter();XtManageChild(dialog);XtPopup(XtParent(dialog),XtGrabNone);*answer=DIALOG_NONE;while(*answer==DIALOG_NONE){XtAppProcessEvent(XtWidgetToApplicationContext(dialog),XtIMAll);}XtUnmanageChild(dialog);XtPopdown(XtParent(dialog));(void)XSync(XtDisplay(XwinDataP->topLevel),0);XmUpdateDisplay(XwinDataP->topLevel);(void)UiLeave();}void UiShowAbout(void){char buf[256];
#ifdef EVALUATION
(void)strcpy(buf,"      ");
#else
(void)strcpy(buf,"         ");
#endif
(void)strcat(buf,Version);(void)strcat(buf,"\n\nZX Spectrum 48/128/+3 Emulator""\n  Pentagon/Scorpion Emulator""\n       Didaktik Emulator""\n\n     1995-2007 Erik Kunze""\n\n  http://www.zx-spectrum.net");(void)UiShowMessage(DIALOG_MSG,buf,"Dismiss",(const char*)0,DIALOG_OK);}int UiShowMessage(int type,const char*msgText,const char*okLabel,const char*cancelLabel,int defChoice){static Widget dialog=(Widget)0;static int answer;static XmString defOkLabel=(XmString)0,defCancellabel=(XmString)0;XmString str;if(dialog==(Widget)0){Arg arg[5];Cardinal i;str=XmStringCreateLtoR((char*)"Dialog",XmFONTLIST_DEFAULT_TAG);i=0;XtSetArg(arg[i],XmNnoResize,True);i++;XtSetArg(arg[i],XmNautoUnmanage,False);i++;XtSetArg(arg[i],XmNdeleteResponse,XmDO_NOTHING);i++;XtSetArg(arg[i],XmNdialogStyle,XmDIALOG_FULL_APPLICATION_MODAL);i++;XtSetArg(arg[i],XmNdialogTitle,str);i++;assert(i<=XtNumber(arg));dialog=XmCreateMessageDialog(XwinDataP->topLevel,(char*)"dialog",arg,i);XmStringFree(str);XtUnmanageChild(XmMessageBoxGetChild(dialog,XmDIALOG_HELP_BUTTON));XtAddCallback(dialog,XmNokCallback,uiDialogCallback,&answer);XtAddCallback(dialog,XmNcancelCallback,uiDialogCallback,&answer);XtVaGetValues(dialog,XmNokLabelString,&defOkLabel,XmNcancelLabelString,&defCancellabel,XtNull);}switch(type){case DIALOG_ERROR:type=XmDIALOG_ERROR;break;case DIALOG_INFO:type=XmDIALOG_INFORMATION;break;case DIALOG_MSG:type=XmDIALOG_MESSAGE;break;case DIALOG_ASK:type=XmDIALOG_QUESTION;break;case DIALOG_WARN:type=XmDIALOG_WARNING;break;case DIALOG_WORK:type=XmDIALOG_WORKING;break;}XtVaSetValues(dialog,XmNdialogType,type,XtNull);if(type==XmDIALOG_QUESTION){XtManageChild(XmMessageBoxGetChild(dialog,XmDIALOG_CANCEL_BUTTON));}else{XtUnmanageChild(XmMessageBoxGetChild(dialog,XmDIALOG_CANCEL_BUTTON));}str=XmStringCreateLtoR((char*)msgText,XmFONTLIST_DEFAULT_TAG);XtVaSetValues(dialog,XmNmessageString,str,XtNull);XmStringFree(str);if(okLabel!=(const char*)0){str=XmStringCreateLtoR((char*)okLabel,XmFONTLIST_DEFAULT_TAG);XtVaSetValues(dialog,XmNokLabelString,str,XtNull);XmStringFree(str);}else{XtVaSetValues(dialog,XmNokLabelString,defOkLabel,XtNull);}if(cancelLabel!=(const char*)0){str=XmStringCreateLtoR((char*)cancelLabel,XmFONTLIST_DEFAULT_TAG);XtVaSetValues(dialog,XmNcancelLabelString,str,XtNull);XmStringFree(str);}else{XtVaSetValues(dialog,XmNcancelLabelString,defCancellabel,XtNull);}if(defChoice==DIALOG_OK){XtVaSetValues(dialog,XmNdefaultButtonType,XmDIALOG_OK_BUTTON,XmNinitialFocus,XmMessageBoxGetChild(dialog,XmDIALOG_OK_BUTTON),XtNull);}else{XtVaSetValues(dialog,XmNdefaultButtonType,XmDIALOG_CANCEL_BUTTON,XmNinitialFocus,XmMessageBoxGetChild(dialog,XmDIALOG_CANCEL_BUTTON),XtNull);}UiShowDialog(dialog,&answer);return answer;}int UiShowTextFile(const char*filename,XtCallbackProc callback,XtPointer client){FILE*fp;struct stat sbuf;char*text=(char*)0;if((fp=Fopen(filename,"rb"))==(FILE*)0){return errno;}if((fstat(fileno(fp),&sbuf)<0)||(text=malloc((size_t)(sbuf.st_size+1)))==(char*)0||fread(text,1,(size_t)sbuf.st_size,fp)!=(size_t)sbuf.st_size){(void)fclose(fp);if(text!=(char*)0){free(text);}return errno==0?-1:errno;}(void)fclose(fp);text[sbuf.st_size]='\0';uiShowTextBuffer(filename,text,callback,client);free(text);return 0;}void UiShowTextBuffer(const char*title,const char*buffer){(void)uiShowTextBuffer(title,buffer,(XtCallbackProc)0,XtNull);}static int uiShowTextBuffer(const char*title,const char*buffer,XtCallbackProc callback,XtPointer client){Widget dialog,scrolledText;XmString title3;Arg arg[8];Cardinal i;char*title2;if((title2=malloc(sizeof("Browser: ")+strlen(title)+1))==(char*)0){return errno;}strcat(strcpy(title2,"Browser: "),title);title3=XmStringCreateLtoR(title2,XmFONTLIST_DEFAULT_TAG);free(title2);i=0;XtSetArg(arg[i],XmNmarginHeight,5);i++;XtSetArg(arg[i],XmNmarginWidth,5);i++;XtSetArg(arg[i],XmNnoResize,False);i++;XtSetArg(arg[i],XmNautoUnmanage,False);i++;XtSetArg(arg[i],XmNdeleteResponse,XmDESTROY);i++;XtSetArg(arg[i],XmNdialogTitle,title3);i++;assert(i<=XtNumber(arg));dialog=XmCreateFormDialog(XwinDataP->topLevel,(char*)"fd",arg,i);if(callback!=(XtCallbackProc)0){XtAddCallback(dialog,XmNdestroyCallback,callback,client);}XmStringFree(title3);i=0;XtSetArg(arg[i],XmNrows,15);i++;XtSetArg(arg[i],XmNcolumns,80);i++;XtSetArg(arg[i],XmNeditable,False);i++;XtSetArg(arg[i],XmNeditMode,XmMULTI_LINE_EDIT);i++;XtSetArg(arg[i],XmNcursorPositionVisible,False);i++;XtSetArg(arg[i],XmNvalue,buffer);i++;XtSetArg(arg[i],XmNscrollVertical,True);i++;XtSetArg(arg[i],XmNscrollHorizontal,False);i++;assert(i<=XtNumber(arg));scrolledText=XmCreateScrolledText(dialog,(char*)"st",arg,i);XtVaSetValues(XtParent(scrolledText),XmNleftAttachment,XmATTACH_FORM,XmNrightAttachment,XmATTACH_FORM,XmNtopAttachment,XmATTACH_FORM,XmNbottomAttachment,XmATTACH_FORM,XtNull);XtManageChild(scrolledText);XtManageChild(dialog);XtPopup(XtParent(dialog),XtGrabNone);return 0;}char*UiFileSelector(const char*title,int valid,int*types){static Widget dialog=(Widget)0;static fsData fsDatas;XmString str;(void)UiEnter();fsDatas.fileName=(char*)-1;fsDatas.fileValid=valid;fsDatas.fileTypes=types;if(dialog==(Widget)0){Arg arg[6];Cardinal i;i=0;XtSetArg(arg[i],XmNuserData,&fsDatas);i++;XtSetArg(arg[i],XmNautoUnmanage,False);i++;XtSetArg(arg[i],XmNdeleteResponse,XmDO_NOTHING);i++;XtSetArg(arg[i],XmNdialogStyle,XmDIALOG_FULL_APPLICATION_MODAL);i++;XtSetArg(arg[i],XtNkeyboardFocusPolicy,XmPOINTER);i++;XtSetArg(arg[i],XmNfileSearchProc,uiFileSelectorReadDirectory);i++;assert(i<=XtNumber(arg));dialog=XmCreateFileSelectionDialog(XwinDataP->topLevel,(char*)"fs",arg,i);XtUnmanageChild(XmFileSelectionBoxGetChild(dialog,XmDIALOG_HELP_BUTTON));XtAddCallback(dialog,XmNokCallback,uiFileSelectorCallback,&fsDatas);XtAddCallback(dialog,XmNcancelCallback,uiFileSelectorCallback,&fsDatas);}else{XtVaGetValues(dialog,XmNdirectory,&str,XtNull);XmFileSelectionDoSearch(dialog,str);}str=XmStringCreateLtoR((char*)title,XmFONTLIST_DEFAULT_TAG);XtVaSetValues(dialog,XmNdialogTitle,str,XtNull);XmStringFree(str);XtManageChild(dialog);XtPopup(XtParent(dialog),XtGrabNone);while(fsDatas.fileName==(char*)-1){XtAppProcessEvent(XtWidgetToApplicationContext(dialog),XtIMAll);}XtUnmanageChild(dialog);XtPopdown(XtParent(dialog));(void)XSync(XtDisplay(XwinDataP->topLevel),0);XmUpdateDisplay(XwinDataP->topLevel);(void)UiLeave();return fsDatas.fileName;}static void uiFileSelectorReadDirectory(Widget w,XtPointer searchData){fsData*fsDatas;DIR*dir;struct dirent*ent;struct stat buf;char*saveDir,*scanDir,**filenames,*p;int cnt,max,*type,i;if(XmStringGetLtoR(((XmFileSelectionBoxCallbackStruct*)searchData)->dir,XmFONTLIST_DEFAULT_TAG,&scanDir)==False){return;}XtVaGetValues(w,XmNuserData,&fsDatas,XtNull);assert(fsDatas!=(fsData*)0);if((saveDir=getcwd((char*)0,MAXPATHLEN))==(char*)0){Msg(M_FATAL,"getcwd failed");}if(chdir(scanDir)<0){XtFree(scanDir);free(saveDir);return;}if((dir=opendir(scanDir))==(DIR*)0){Msg(M_PERR,"couldn't open directory <%s>",scanDir);XtFree(scanDir);(void)chdir(saveDir);free(saveDir);return;}cnt=0;max=256;filenames=Malloc(sizeof(char*)*(size_t)max,"uiFileSelectorReadDirectory");while((ent=readdir(dir))>(struct dirent*)0){if(ent->d_name[0]=='.'&&ent->d_name[1]!='.'){continue;}(void)stat(ent->d_name,&buf);
#ifdef REAL_DISKS
if(S_ISBLK(buf.st_mode)){goto found;}
#endif
#ifdef VIRTUAL_DISK_IMAGES
if(S_ISREG(buf.st_mode)||(S_ISDIR(buf.st_mode)&&GetFileType(ent->d_name)==FILE_TYPE_HOB))
#else
if(S_ISREG(buf.st_mode))
#endif
{p=strrchr(ent->d_name,'.');for(type=fsDatas->fileTypes;*type!=FILE_TYPE_END;type++){if(*type==FILE_TYPE_ANY||(p!=(char*)0&&strcasecmp(p+1,FtExt[*type])==0)){
#ifdef REAL_DISKS
found:
#endif
filenames[cnt]=Strdup(ent->d_name,"uiFileSelectorReadDirectory");if(++cnt==max){max+=256;if((filenames=realloc(filenames,(size_t)max*sizeof(char*)))==(char**)0){Msg(M_FATAL,"realloc failed in uiFileSelectorReadDirectory()");}}break;}}}}(void)closedir(dir);(void)chdir(saveDir);free(saveDir);if(cnt>0){XmString*names;char*file;
#ifndef HAVE_QSORT
int j;for(i=cnt-1;i>=0;i--){for(j=1;j<=i;j++){if(strcasecmp(filenames[j-1],filenames[j])>0){p=filenames[j-1];filenames[j-1]=filenames[j];filenames[j]=p;}}}
#else
qsort(filenames,(unsigned int)cnt,sizeof(filenames[0]),(int(*)(const void*,const void*))uiFileSelectorCompare);
#endif
names=(XmString*)XtMalloc((size_t)cnt*sizeof(XmString*));file=XtMalloc(MAXPATHLEN);(void)strcpy(file,scanDir);p=file+strlen(file);for(i=0;i<cnt;i++){(void)strcpy(p,filenames[i]);names[i]=XmStringCreateLtoR(file,XmFONTLIST_DEFAULT_TAG);free(filenames[i]);}XtFree(file);XtVaSetValues(w,XmNfileListItems,names,XmNfileListItemCount,cnt,XmNlistUpdated,True,XtNull);while(cnt){XmStringFree(names[--cnt]);}XtFree((char*)names);}else{XtVaSetValues(w,XmNfileListItems,XtNull,XmNfileListItemCount,0,XmNlistUpdated,True,XtNull);}free(filenames);XtFree(scanDir);}
#ifdef HAVE_QSORT
static int uiFileSelectorCompare(const char**s1,const char**s2){return(strcasecmp(*s1,*s2));}
#endif
static void uiFileSelectorCallback(Widget w,XtPointer client,XtPointer call){XmFileSelectionBoxCallbackStruct*cbs=(XmFileSelectionBoxCallbackStruct*)call;char*file;fsData*fsDatas;struct stat buf;if(cbs->reason==XmCR_CANCEL){*((char**)client)=(char*)0;return;}if(XmStringGetLtoR(cbs->value,XmFONTLIST_DEFAULT_TAG,&file)==False){return;}XtVaGetValues(w,XmNuserData,&fsDatas,XtNull);assert(fsDatas!=(fsData*)0);if(*file!='/'){char*dir,*newfile;if(XmStringGetLtoR(cbs->dir,XmFONTLIST_DEFAULT_TAG,&dir)==True){newfile=XtMalloc(MAXPATHLEN);(void)strcat(strcpy(newfile,dir),file);XtFree(file);XtFree(dir);file=newfile;}}if(stat(file,&buf)==0){if(S_ISREG(buf.st_mode)){if(fsDatas->fileValid!=0||UiShowMessage(DIALOG_ASK,"Overwrite file?",(const char*)0,(const char*)0,DIALOG_CANCEL)==DIALOG_OK){goto finish;}}
#ifdef REAL_DISKS
else if(S_ISBLK(buf.st_mode)){goto finish;}
#endif
else if(S_ISDIR(buf.st_mode)){XmString str;
#ifdef VIRTUAL_DISK_IMAGES
if(GetFileType(file)==FILE_TYPE_HOB&&fsDatas->fileValid!=0){goto finish;}
#endif
str=XmStringCreateLtoR(file,XmFONTLIST_DEFAULT_TAG);XmFileSelectionDoSearch(w,str);XmStringFree(str);}}else if(errno==ENOENT&&fsDatas->fileValid==0){finish:*((void**)client)=Strdup(file,"uiFileSelectorCallback");}XtFree(file);}int UiBrowseList(const char*title,const char**items,int maxItems,int curItem){static Widget dialog=(Widget)0,list;static int answer;XmString str,*listItems;int cnt;if(dialog==(Widget)0){XmString okLabel;Arg arg[7];Cardinal i;str=XmStringCreateLtoR((char*)"Browser",XmFONTLIST_DEFAULT_TAG);okLabel=XmStringCreateLtoR((char*)"Apply",XmFONTLIST_DEFAULT_TAG);i=0;XtSetArg(arg[i],XmNnoResize,True);i++;XtSetArg(arg[i],XmNautoUnmanage,False);i++;XtSetArg(arg[i],XmNdeleteResponse,XmDO_NOTHING);i++;XtSetArg(arg[i],XmNdialogStyle,XmDIALOG_FULL_APPLICATION_MODAL);i++;XtSetArg(arg[i],XtNkeyboardFocusPolicy,XmPOINTER);i++;XtSetArg(arg[i],XmNdialogTitle,str);i++;XtSetArg(arg[i],XmNokLabelString,okLabel);i++;assert(i<=XtNumber(arg));dialog=XmCreateSelectionDialog(XwinDataP->topLevel,(char*)"browser",arg,i);list=XmSelectionBoxGetChild(dialog,XmDIALOG_LIST);XmStringFree(str);XmStringFree(okLabel);XtUnmanageChild(XmSelectionBoxGetChild(dialog,XmDIALOG_APPLY_BUTTON));XtUnmanageChild(XmSelectionBoxGetChild(dialog,XmDIALOG_HELP_BUTTON));XtUnmanageChild(XmSelectionBoxGetChild(dialog,XmDIALOG_SELECTION_LABEL));XtUnmanageChild(XmSelectionBoxGetChild(dialog,XmDIALOG_TEXT));XtAddCallback(dialog,XmNokCallback,uiDialogCallback,&answer);XtAddCallback(dialog,XmNcancelCallback,uiDialogCallback,&answer);}str=XmStringCreateLtoR((char*)title,XmFONTLIST_DEFAULT_TAG);listItems=(XmString*)XtMalloc((size_t)maxItems*sizeof(XmString*));for(cnt=0;cnt<maxItems;cnt++){listItems[cnt]=XmStringCreateLtoR((char*)items[cnt],XmFONTLIST_DEFAULT_TAG);}XtVaSetValues(dialog,XmNlistLabelString,str,XmNlistItems,listItems,XmNlistItemCount,maxItems,XtNull);XmStringFree(str);curItem++;XmListSelectPos(list,curItem,False);XmListSetPos(list,curItem);curItem=-1;while(--cnt>=0){XmStringFree(listItems[cnt]);}XtFree((char*)listItems);UiShowDialog(dialog,&answer);if(answer==DIALOG_OK){int*posList,posCnt;if(XmListGetSelectedPos(list,&posList,&posCnt)==True&&posCnt==1){curItem=*posList-1;}XtFree((char*)posList);}return curItem;}void UiFixiateListWidth(Widget shell,Widget list,int width){XmString item;char*str;str=XtCalloc(sizeof(char),(Cardinal)(width+1));for(--width;width>=0;width--){str[width]='W';}item=XmStringCreateLtoR(str,XmFONTLIST_DEFAULT_TAG);XmListAddItem(list,item,1);XtFree(str);XmStringFree(item);XtAddCallback(shell,XmNmapCallback,uiFixiateListWidthCallback,list);}static void uiFixiateListWidthCallback(Widget w,XtPointer client,XtPointer call){Widget form=(Widget)client;USED(call);while(form&&!XmIsForm(form)){form=XtParent(form);}assert(form!=(Widget)0);XtRemoveCallback(w,XmNmapCallback,uiFixiateListWidthCallback,client);XtVaSetValues(form,XmNresizePolicy,XmRESIZE_NONE,XtNull);XmListDeletePos((Widget)client,1);}Widget UiCreateSpinbox(Widget parent,const char*format,int columns,int min,int max,int offset,XtCallbackProc callback){Widget form,up,down,w;Pixel color;Arg arg[9];Cardinal i;UiSpinbox*sbp;sbp=Malloc(sizeof(UiSpinbox),"UiCreateSpinbox");sbp->value=sbp->min=min;sbp->max=max;sbp->offset=offset;sbp->format=format;XtVaGetValues(parent,XmNbackground,&color,XtNull);i=0;XtSetArg(arg[i],XmNuserData,sbp);i++;sbp->form=XmCreateForm(parent,(char*)"form",arg,i);XtManageChild(sbp->form);i=0;XtSetArg(arg[i],XmNcolumns,columns);i++;XtSetArg(arg[i],XmNeditable,True);i++;XtSetArg(arg[i],XmNcursorPositionVisible,False);i++;XtSetArg(arg[i],XmNleftAttachment,XmATTACH_FORM);i++;XtSetArg(arg[i],XmNtopAttachment,XmATTACH_FORM);i++;XtSetArg(arg[i],XmNbottomAttachment,XmATTACH_FORM);i++;assert(i<=XtNumber(arg));w=XmCreateTextField(sbp->form,(char*)"text",arg,i);XtAddCallback(w,XmNfocusCallback,uiSpinboxCallback,sbp);XtAddCallback(w,XmNlosingFocusCallback,uiSpinboxCallback,sbp);XtManageChild(w);sbp->textfield=w;i=0;XtSetArg(arg[i],XmNfractionBase,2);i++;XtSetArg(arg[i],XmNleftAttachment,XmATTACH_WIDGET);i++;XtSetArg(arg[i],XmNleftWidget,sbp->textfield);i++;XtSetArg(arg[i],XmNrightAttachment,XmATTACH_FORM);i++;XtSetArg(arg[i],XmNtopAttachment,XmATTACH_OPPOSITE_WIDGET);i++;XtSetArg(arg[i],XmNtopWidget,sbp->textfield);i++;XtSetArg(arg[i],XmNbottomAttachment,XmATTACH_OPPOSITE_WIDGET);i++;XtSetArg(arg[i],XmNbottomWidget,sbp->textfield);i++;assert(i<=XtNumber(arg));form=XmCreateForm(sbp->form,(char*)"arrowform",arg,i);XtManageChild(form);i=0;XtSetArg(arg[i],XmNarrowDirection,XmARROW_UP);i++;XtSetArg(arg[i],XmNshadowThickness,0);i++;XtSetArg(arg[i],XmNhighlightThickness,0);i++;XtSetArg(arg[i],XmNforeground,color);i++;XtSetArg(arg[i],XmNrightAttachment,XmATTACH_FORM);i++;XtSetArg(arg[i],XmNleftAttachment,XmATTACH_FORM);i++;XtSetArg(arg[i],XmNtopAttachment,XmATTACH_FORM);i++;XtSetArg(arg[i],XmNbottomAttachment,XmATTACH_POSITION);i++;XtSetArg(arg[i],XmNbottomPosition,1);i++;assert(i<=XtNumber(arg));up=XmCreateArrowButtonGadget(form,(char*)"arrow",arg,i);XtAddCallback(up,XmNarmCallback,uiSpinboxCallback,sbp);XtAddCallback(up,XmNdisarmCallback,uiSpinboxCallback,sbp);XtManageChild(up);i=0;XtSetArg(arg[i],XmNarrowDirection,XmARROW_DOWN);i++;XtSetArg(arg[i],XmNshadowThickness,0);i++;XtSetArg(arg[i],XmNhighlightThickness,0);i++;XtSetArg(arg[i],XmNforeground,color);i++;XtSetArg(arg[i],XmNleftAttachment,XmATTACH_FORM);i++;XtSetArg(arg[i],XmNrightAttachment,XmATTACH_FORM);i++;XtSetArg(arg[i],XmNtopAttachment,XmATTACH_POSITION);i++;XtSetArg(arg[i],XmNtopPosition,1);i++;XtSetArg(arg[i],XmNbottomAttachment,XmATTACH_FORM);i++;assert(i<=XtNumber(arg));down=XmCreateArrowButtonGadget(form,(char*)"arrow",arg,i);XtAddCallback(down,XmNarmCallback,uiSpinboxCallback,sbp);XtAddCallback(down,XmNdisarmCallback,uiSpinboxCallback,sbp);XtManageChild(down);UiSpinboxSetValue(sbp->form,sbp->value);if(callback!=(XtCallbackProc)0){XtAddCallback(sbp->textfield,XmNvalueChangedCallback,callback,XtNull);}return sbp->form;}static void uiSpinboxCallback(Widget w,XtPointer client,XtPointer call){UiSpinbox*sbp=(UiSpinbox*)client;char*str;int value;switch((int)((XmAnyCallbackStruct*)call)->reason){case XmCR_FOCUS:XtVaSetValues(w,XmNcursorPositionVisible,True,XtNull);break;case XmCR_LOSING_FOCUS:XtVaSetValues(w,XmNcursorPositionVisible,False,XtNull);XmTextFieldClearSelection(w,CurrentTime);str=XmTextFieldGetString(w);if(sscanf(str,sbp->format,&value)==1&&value>=sbp->min&&value<=sbp->max){if(value==sbp->value){XtFree(str);break;}}else{(void)XBell(XtDisplayOfObject(w),5);value=sbp->value;}UiSpinboxSetValue(sbp->form,value);XtFree(str);break;case XmCR_ARM:XtVaGetValues(w,XmNarrowDirection,&(sbp->direction),XtNull);uiSpinboxChangeValue((XtPointer)sbp,1);break;case XmCR_DISARM:if(sbp->timer!=(XtIntervalId)0){XtRemoveTimeOut(sbp->timer);sbp->timer=(XtIntervalId)0;}break;}}static void uiSpinboxChangeValue(XtPointer client,XtIntervalId id){static unsigned int timerValue,timerCounter;static int offset=0;UiSpinbox*arrow=(UiSpinbox*)client;int value,delta;if(id==1){timerValue=TIMER_VALUE_SLOW;timerCounter=0;offset=arrow->offset;}else{timerCounter++;}if(timerCounter>(TIMER_VALUE_BASE/TIMER_VALUE_SLOW)&&timerValue==TIMER_VALUE_SLOW){timerValue=TIMER_VALUE_FAST;timerCounter=0;}value=arrow->value;delta=abs(arrow->direction==XmARROW_UP?arrow->max-value:value-arrow->min);if(timerCounter>(TIMER_VALUE_BASE/TIMER_VALUE_FAST)&&timerValue==TIMER_VALUE_FAST){offset*=10;timerCounter=0;}if(offset!=arrow->offset&&delta<offset){offset=arrow->offset;}if((value+offset>arrow->max&&arrow->direction==XmARROW_UP)||(value-offset<arrow->min&&arrow->direction==XmARROW_DOWN)){(void)XBell(XtDisplayOfObject(arrow->textfield),5);return;}value+=arrow->direction==XmARROW_UP?offset:-offset;UiSpinboxSetValue(arrow->form,value);arrow->timer=XtAppAddTimeOut(XtWidgetToApplicationContext(arrow->form),(unsigned int)timerValue,(XtTimerCallbackProc)uiSpinboxChangeValue,arrow);}void UiSpinboxSetValue(Widget w,int value){UiSpinbox*sbp;char buf[5];int i;XtVaGetValues(w,XmNuserData,&sbp,XtNull);sbp->value=value;i=sprintf(buf,sbp->format,value);assert(i<(int)sizeof(buf));XmTextFieldSetString(sbp->textfield,buf);}int UiSpinboxGetValue(Widget w){UiSpinbox*sbp;XtVaGetValues(w,XmNuserData,&sbp,XtNull);return sbp->value;}void UiHideCursor(Widget w){static Cursor cursor=(Cursor)0;if(cursor==(Cursor)0){char bm;Pixmap pm;XColor c;bm=0;pm=XCreatePixmapFromBitmapData(XtDisplay(w),XtWindow(w),&bm,1,1,0,0,1);cursor=XCreatePixmapCursor(XwinDataP->display,pm,pm,&c,&c,0,0);}XDefineCursor(XtDisplay(w),XtWindow(w),cursor);}void UiUnhideCursor(Widget w){(void)XUndefineCursor(XtDisplay(w),XtWindow(w));}int UiGrabPointer(Widget w){switch(XtGrabPointer(w,True,PointerMotionMask,GrabModeAsync,GrabModeAsync,XtWindow(w),(Cursor)0,CurrentTime)){case GrabSuccess:case GrabNotViewable:break;default:Msg(M_WARN,"XtGrabPointer failed");return-1;}XWarpPointer(XtDisplay(w),XtWindow(w),XtWindow(w),0,0,0U,0U,0,0);return 0;}void UiUngrabPointer(Widget w){XtUngrabPointer(w,CurrentTime);}
