/*********************************************************************************************************************************
 * Copyright (c) Erik Kunze 1995 - 2007
 *
 * This file is a part of the Spectrum emulator package 'XZX-Pro', and may not be distributed.  The copyright holder makes no
 * representations about the suitability of this software for any purpose.  It is provided "as is" without express or implied
 * warranty. THE CODE MAY NOT BE MODIFIED OR REUSED WITHOUT PERMISSION!
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Erik Kunze
 ********************************************************************************************************************************/
#ifndef _XZX_UI_XMOUSE_H
#define _XZX_UI_XMOUSE_H
typedef enum{XMOUSE_BUTTON,XMOUSE_MOTION}XmouseEventType;
#define XMOUSE_BUTTON_L	(1<<0)
#define XMOUSE_BUTTON_M	(1<<1)
#define XMOUSE_BUTTON_R	(1<<2)
#define XMOUSE_BUTTON_RELEASE	0
#define XMOUSE_BUTTON_PRESS	1
typedef struct _xmouseButtonEvent{XmouseEventType type;unsigned int button;unsigned int state;}XmouseButtonEvent;typedef struct _xmouseMotionEvent{XmouseEventType type;int x;int y;}XmouseMotionEvent;typedef union _xmouseEvent{XmouseEventType type;XmouseButtonEvent button;XmouseMotionEvent motion;}XmouseEvent;typedef void(*XmouseFunc)(XmouseEvent*);typedef int XmouseId;extern XmouseId XmouseAdd(XmouseFunc,const char*);extern void XmouseRemove(XmouseId);extern void XmouseOn(void);extern void XmouseOff(void);extern int XmouseGrab(void);extern void XmouseUngrab(void);
#endif 

