/*********************************************************************************************************************************
 * Copyright (c) Erik Kunze 1995 - 2007
 *
 * This file is a part of the Spectrum emulator package 'XZX-Pro', and may not be distributed.  The copyright holder makes no
 * representations about the suitability of this software for any purpose.  It is provided "as is" without express or implied
 * warranty. THE CODE MAY NOT BE MODIFIED OR REUSED WITHOUT PERMISSION!
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Erik Kunze
 ********************************************************************************************************************************/
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
#ifndef lint
static char rcsid[]="$Id: util.c,v 4.57 2006/12/22 14:28:54 erik Rel $";
#endif
#include <sys/types.h>
#include <sys/param.h>
#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>
#include <string.h>
#ifdef HAVE_STRINGS_H
#include <strings.h>
#endif
#include <ctype.h>
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>
#include <sys/stat.h>
#include <sys/mman.h>
#include <setjmp.h>
#include <assert.h>
#include "ui/resource.h"
#include "main.h"
#include "util.h"
const char*FtExt[]={"sna","z80","slt","tap","voc","tzx","dat","dsk","trd","fdi","scl","hob","mgt","img","d80","mdr","scr","xpm","psg","wav","pok","rzx"};jmp_buf ExceptionEnv;FILE*Fopen(const char*filename,const char*amode){FILE*fp=(FILE*)0;if(filename!=(char*)0&&filename[0]!='\0'){if(filename[0]=='/'||strncmp(filename,"./",2)==0||strncmp(filename,"../",3)==0){fp=fopen(filename,amode);}else{char buf[MAXPATHLEN],*path,*element;path=Strdup(CFGGET(libDir),"Fopen");element=strtok(path,":");while(element){assert(strlen(filename)+strlen(element)+1<MAXPATHLEN);(void)sprintf(buf,"%s/%s",element,filename);fp=fopen(buf,amode);if(fp!=(FILE*)0){break;}element=strtok((char*)0,":");}free(path);}if(fp==(FILE*)0){Msg(M_PERR,"couldn't open <%s>",filename);}}return fp;}void*Malloc(size_t size,const char*function){void*p;if((p=calloc(size,1))==(void*)0){Msg(M_FATAL,"malloc failed in %s()",function);}return p;}char*Strdup(const char*src,const char*function){char*dst;if((dst=strdup(src))==(char*)0){Msg(M_FATAL,"strdup failed in %s()",function);}return dst;}void*Mmap(const char*filename,int regular,int*readonly,size_t*size){FILE*fp;struct stat sbuf;void*mmp=(void*)-1;int res;if((fp=Fopen(filename,"rb"))!=(FILE*)0){res=fstat(fileno(fp),&sbuf);(void)fclose(fp);if(res==0){if(regular==0||S_ISREG(sbuf.st_mode)){*size=(size_t)sbuf.st_size;*readonly=(sbuf.st_mode&S_IWRITE)==0?1:*readonly;if((fp=Fopen(filename,*readonly?"rb":"r+b"))!=(FILE*)0){mmp=mmap((void*)0,*size,PROT_READ|(*readonly?0:PROT_WRITE),MAP_SHARED,fileno(fp),(off_t)0);if(mmp==(void*)-1){Msg(M_PERR,"mmap failed");}(void)fclose(fp);}}else{Msg(M_WARN,"is not a regular file");}}}return mmp;}void Munmap(void*start,size_t length){(void)munmap(start,length);}void Msg(MsgType errorLevel,const char*fmt, ...){va_list args;int error=errno;va_start(args,fmt);if(CFGGET(quiet)==0||errorLevel==M_ERR||errorLevel==M_PERR||errorLevel==M_FATAL){(void)fprintf(stderr,"%s: ",ProgName);switch(errorLevel){case M_INFO:break;case M_WARN:case M_PWARN:(void)fprintf(stderr,"warning: ");break;case M_ERR:case M_PERR:(void)fprintf(stderr,"error: ");break;case M_FATAL:(void)fprintf(stderr,"fatal: ");break;case M_DEBUG:(void)fprintf(stderr,"debug: ");break;}(void)vfprintf(stderr,fmt,args);(void)putc('\n',stderr);if(errorLevel==M_PWARN||errorLevel==M_PERR){errno=error;perror("  -> reason");}}va_end(args);if(errorLevel==M_FATAL){exit(1);}}const char*GetBaseName(const char*filename){if(filename!=(const char*)0){const char*s;if((s=strrchr(filename,'/'))!=(char*)0){return++s;}else{return filename;}}return("-none-");}FileType GetFileType(const char*filename){const char*p;FileType i;assert(NELEM(FtExt)==FILE_TYPE_UNKNOWN);if((p=strrchr(filename,'.'))!=(char*)0){p++;for(i=FILE_TYPE_SNA;i<FILE_TYPE_UNKNOWN;i++){if(strncasecmp(p,FtExt[i],4)==0){return i;}}}return FILE_TYPE_UNKNOWN;}void ExceptionCatch(int signo){USED(signo);longjmp(ExceptionEnv,-1);}int FormatLine(const char*src,unsigned int len,char*dst,unsigned int offs){char*dstSave=dst;int i;while(len!=0){if(*src=='\r'){*dst='\n';for(i=offs;i;i--){*++dst=' ';}}else{*dst=*src;}src++;dst++;len--;}*dst='\0';return(dst-dstSave);}unsigned int Le2Cpu(unsigned char*buf,int size){unsigned int val=0;int i;for(i=size-1;i>=0;i--){val<<=8;val|=(unsigned int)buf[i];}return val;}void Cpu2Le(unsigned char*buf,unsigned int val,int size){int i;for(i=0;i<size;i++){buf[i]=(unsigned char)(val&0xff);val>>=8;}}
#ifndef HAVE_STRCASECMP
int strcasecmp(const char*s1,const char*s2){char c1,c2;for(;*s1&&*s2;s1++,s2++){c1=isupper(*s1)?tolower(*s1):*s1;c2=isupper(*s2)?tolower(*s2):*s2;if(c1!=c2){return(c1-c2);}}if(*s1||*s2){return(*s1-*s2);}return 0;}int strncasecmp(const char*s1,const char*s2,int n){int i;char c1,c2;for(i=0;*s1&&*s2&&i<n;s1++,s2++,i++){c1=isupper(*s1)?tolower(*s1):*s1;c2=isupper(*s2)?tolower(*s2):*s2;if(c1!=c2){return(c1-c2);}}if((i<n)&&(*s1||*s2)){return(*s1-*s2);}return 0;}
#endif 
void DestroyList(Llist*head,void(*pDestroy)(void*)){Llist*pNext;while(head!=(Llist*)0){if(head->item!=(void*)0){if(pDestroy!=(void(*)(void*))0){pDestroy(head->item);}free(head->item);}pNext=head->next;free(head);head=pNext;}}Llist*AppendElemList(Llist*head,void*item){Llist**ppHead=&head;while(*ppHead!=(Llist*)0){ppHead=&((*ppHead)->next);}*ppHead=Malloc(sizeof(Llist),"AppendElemList");(*ppHead)->item=item;(*ppHead)->next=(Llist*)0;return head;}Llist*PrependElemList(Llist*head,void*item){Llist*pHead;pHead=Malloc(sizeof(Llist),"PrependElemList");pHead->item=item;pHead->next=head;return pHead;}Llist*RemoveElemList(void*item,int(*pCompare)(void*,void*),Llist*head,void(*pDestroy)(void*)){Llist**ppHead=&head;Llist*pElem;while(*ppHead!=(Llist*)0&&(*pCompare)((*ppHead)->item,item)!=0){ppHead=&((*ppHead)->next);}if(*ppHead!=(Llist*)0){pElem=*ppHead;*ppHead=(*ppHead)->next;if(pDestroy!=(void(*)(void*))0){pDestroy(pElem);}free(pElem);}return head;}Llist*SortedInsertList(void*item,int(*pCompare)(void*,void*),Llist*head){Llist**ppHead=&head;Llist*pElem=Malloc(sizeof(Llist),"SortedInsertList");pElem->item=item;pElem->next=(Llist*)0;while(*ppHead!=(Llist*)0&&(*pCompare)(item,(*ppHead)->item)>=0){ppHead=&(*ppHead)->next;}if(*ppHead!=(Llist*)0){pElem->next=*ppHead;}*ppHead=pElem;return head;}void*RetrieveElemList(Llist*head,unsigned int which){while(head!=(Llist*)0&&which>0){head=head->next;which--;}return(head!=(Llist*)0?head->item:(void*)0);}
