/*********************************************************************************************************************************
 * Copyright (c) Erik Kunze 1995 - 2007
 *
 * This file is a part of the Spectrum emulator package 'XZX-Pro', and may not be distributed.  The copyright holder makes no
 * representations about the suitability of this software for any purpose.  It is provided "as is" without express or implied
 * warranty. THE CODE MAY NOT BE MODIFIED OR REUSED WITHOUT PERMISSION!
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Erik Kunze
 ********************************************************************************************************************************/
#ifndef _XZX_UTIL_H
#define _XZX_UTIL_H
#include <sys/types.h>
#include <stdio.h>
#include <signal.h>
#include <setjmp.h>
typedef enum{M_INFO,M_WARN,M_PWARN,M_ERR,M_PERR,M_FATAL,M_DEBUG}MsgType;typedef enum{FILE_TYPE_SNA,FILE_TYPE_Z80,FILE_TYPE_SLT,FILE_TYPE_TAP,FILE_TYPE_VOC,FILE_TYPE_TZX,FILE_TYPE_DAT,FILE_TYPE_DSK,FILE_TYPE_TRD,FILE_TYPE_FDI,FILE_TYPE_SCL,FILE_TYPE_HOB,FILE_TYPE_MGT,FILE_TYPE_IMG,FILE_TYPE_D80,FILE_TYPE_MDR,FILE_TYPE_SCR,FILE_TYPE_XPM,FILE_TYPE_PSG,FILE_TYPE_WAV,FILE_TYPE_POK,FILE_TYPE_RZX,FILE_TYPE_UNKNOWN,FILE_TYPE_ANY,FILE_TYPE_END=-1}FileType;typedef struct _llist{struct _llist*next;void*item;}Llist;
#define NELEM(a)	((int)(sizeof(a) / sizeof(a[0])))
#define OFFSETOF(t,m)	((size_t)&((t *)0)->m)
#ifndef SA_RESTART
#define SA_RESTART	0
#endif
#define TRY()	{ struct sigaction newact, oldact;	newact.sa_handler = ExceptionCatch;	(void)sigemptyset(&newact.sa_mask);	newact.sa_flags = SA_RESTART;	(void)sigaction(SIGSEGV, &newact, &oldact);	if (setjmp(ExceptionEnv) == 0)	{
#define CATCH(x)	}	else	{	x	}	(void)sigaction(SIGSEGV, &oldact, (struct sigaction *)0);	}
extern FILE*Fopen(const char*,const char*);extern void*Malloc(size_t,const char*);extern char*Strdup(const char*,const char*);extern void*Mmap(const char*,int,int*,size_t*);extern void Munmap(void*,size_t);
#ifdef __GNUC__
extern void Msg(MsgType,const char*, ...)__attribute__((format(printf,2,3)));
#else
extern void Msg(MsgType,const char*, ...);
#endif
extern const char*GetBaseName(const char*);extern FileType GetFileType(const char*);extern void ExceptionCatch(int);extern int FormatLine(const char*,unsigned int,char*,unsigned int);extern unsigned int Le2Cpu(unsigned char*,int);extern void Cpu2Le(unsigned char*,unsigned int,int);
#ifndef HAVE_STRCASECMP
extern int strcasecmp(const char*,const char*);extern int strncasecmp(const char*,const char*,int);
#endif
extern void DestroyList(Llist*,void(*)(void*));extern Llist*AppendElemList(Llist*,void*);extern Llist*PrependElemList(Llist*,void*);extern Llist*RemoveElemList(void*,int(*)(void*,void*),Llist*,void(*)(void*));extern Llist*SortedInsertList(void*,int(*)(void*,void*),Llist*);extern void*RetrieveElemList(Llist*,unsigned int);extern const char*FtExt[FILE_TYPE_UNKNOWN];extern jmp_buf ExceptionEnv;
#endif 

