/*********************************************************************************************************************************
 * Copyright (c) Erik Kunze 1995 - 2007
 *
 * This file is a part of the Spectrum emulator package 'XZX-Pro', and may not be distributed.  The copyright holder makes no
 * representations about the suitability of this software for any purpose.  It is provided "as is" without express or implied
 * warranty. THE CODE MAY NOT BE MODIFIED OR REUSED WITHOUT PERMISSION!
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Erik Kunze
 ********************************************************************************************************************************/
#ifndef _XZX_Z80_Z80_H
#define _XZX_Z80_Z80_H
#ifndef EXTERN_Z80_TYPEDEFS
typedef unsigned char	uns8;typedef unsigned short	uns16;typedef unsigned int	uns32;typedef signed char	sgn8;typedef signed short	sgn16;typedef signed int	sgn32;
#endif
typedef void(*NmiCallbackFunc)(void);typedef union{
#ifdef WORDS_BIGENDIAN
struct{uns8 h,l;}b;
#else
struct{uns8 l,h;}b;
#endif
uns16 w;}pair;struct z80{unsigned int state;pair af,bc,de,hl;pair af_alt,bc_alt,de_alt,hl_alt;pair ix,iy;pair sp,pc;uns8 r,r7,i;uns8 im;uns8 iff1,iff2;uns8 hidden;unsigned int tstates;uns8 intVector;unsigned int intTstates;NmiCallbackFunc nmiCallback;};
#define CPU_NORMAL	(0 << 0)
#define CPU_HALTED	(1 << 0)
#define CPU_NMI_PENDING	(1 << 1)
#define CPU_INT_PENDING	(1 << 2)
#define CPU_EI_DELAYED	(1 << 3)
#define CPU_DEBUGGED	(1 << 4)
#define AF	Z80.af.w
#define BC	Z80.bc.w
#define DE	Z80.de.w
#define HL	Z80.hl.w
#define IX	Z80.ix.w
#define IY	Z80.iy.w
#define SP	Z80.sp.w
#define PC	Z80.pc.w
#define AF1	Z80.af_alt.w
#define BC1	Z80.bc_alt.w
#define DE1	Z80.de_alt.w
#define HL1	Z80.hl_alt.w
#define A	Z80.af.b.h
#define F	Z80.af.b.l
#define B	Z80.bc.b.h
#define C	Z80.bc.b.l
#define D	Z80.de.b.h
#define E	Z80.de.b.l
#define H	Z80.hl.b.h
#define L	Z80.hl.b.l
#define HIX	Z80.ix.b.h
#define LIX	Z80.ix.b.l
#define HIY	Z80.iy.b.h
#define LIY	Z80.iy.b.l
#define HSP	Z80.sp.b.h
#define LSP	Z80.sp.b.l
#define HPC	Z80.pc.b.h
#define LPC	Z80.pc.b.l
#define A1	Z80.af_alt.b.h
#define F1	Z80.af_alt.b.l
#define B1	Z80.bc_alt.b.h
#define C1	Z80.bc_alt.b.l
#define D1	Z80.de_alt.b.h
#define E1	Z80.de_alt.b.l
#define H1	Z80.hl_alt.b.h
#define L1	Z80.hl_alt.b.l
#define R	Z80.r
#define R7	Z80.r7
#define I	Z80.i
#define IM	Z80.im
#define IFF1	Z80.iff1
#define IFF2	Z80.iff2
#define HIDDEN	Z80.hidden
#define TSTATES	Z80.tstates
#define Z80_RDOP	Machine->readOpcode
#define Z80_RDOP2	Machine->readMem
#define Z80_RDMEM	Machine->readMem
#define Z80_WRMEM	Machine->writeMem
#define Z80_IN	Machine->inPort
#define Z80_OUT	Machine->outPort
#define FLAG_C	0x01
#define FLAG_N	0x02
#define FLAG_P	0x04
#define FLAG_V	FLAG_P
#define FLAG_3	0x08
#define FLAG_H	0x10
#define FLAG_5	0x20
#define FLAG_Z	0x40
#define FLAG_S	0x80
#define SET(flag)	(F |= (flag))
#define CLR(flag)	(F &= ~(flag))
#define TST(flag)	((F & (flag)) != 0)
#define CPL(flag)	(F ^= (flag))
#define LOWBYTE(reg)	((reg) & 0xff)
#define HIGHBYTE(reg)	(((reg) >> 8) & 0xff)
#include "z80/z80_macros.h"
extern void Z80Init(void);extern void Z80Reset(void);extern void Z80Int(uns8,unsigned int);extern void Z80Nmi(NmiCallbackFunc);extern void Z80Debug(int);extern int Z80Execute(volatile unsigned int*);extern struct z80 Z80;
#endif 

