/*********************************************************************************************************************************
 * Copyright (c) Erik Kunze 1995 - 2007
 *
 * This file is a part of the Spectrum emulator package 'XZX-Pro', and may not be distributed.  The copyright holder makes no
 * representations about the suitability of this software for any purpose.  It is provided "as is" without express or implied
 * warranty. THE CODE MAY NOT BE MODIFIED OR REUSED WITHOUT PERMISSION!
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Erik Kunze
 ********************************************************************************************************************************/
#ifndef lint
static char z80_edops_c[]="$Id: z80_edops.c,v 4.43 2006/12/22 14:29:19 erik Rel $";
#endif
#define LD_NN_DD(regh, regl) {	uns16 temp16 = Z80_RDMEM(PC++);	temp16 |= Z80_RDMEM(PC++) << 8;	Z80_WRMEM(temp16++, (regl));	Z80_WRMEM(temp16, (regh));	}
#define LD_DD_NN(regh, regl) {	uns16 temp16 = Z80_RDMEM(PC++);	temp16 |= Z80_RDMEM(PC++) << 8;	(regl) = Z80_RDMEM(temp16++);	(regh) = Z80_RDMEM(temp16);	}
#define ADC_HL(reg) {	uns32 temp32 = HL + (reg) + (F & FLAG_C);	F = ((HL ^ (reg) ^ temp32) & 0x1000 ? FLAG_H : 0) | ((HL ^ (reg) ^ 0x8000) & ((reg) ^ temp32) & 0x8000 ? FLAG_V : 0) |	(temp32 & 0x10000 ? FLAG_C : 0);	HL = (uns16)temp32;	F |= (H & (FLAG_S | FLAG_5 | FLAG_3)) | (HL ? 0 : FLAG_Z);	}
#define SBC_HL(reg) {	uns32 temp32 = HL - (reg) - (F & FLAG_C);	F = ((HL ^ (reg) ^ temp32) & 0x1000 ? FLAG_H : 0) | ((HL ^ (reg)) & (HL ^ temp32) & 0x8000 ? FLAG_V : 0) | FLAG_N |	(temp32 & 0x10000 ? FLAG_C : 0);	HL = (uns16)temp32;	F |= (H & (FLAG_S | FLAG_5 | FLAG_3)) | (HL ? 0 : FLAG_Z);	}
#define IN(reg) {	(reg) = Z80_IN(BC);	F = (F & FLAG_C) | SZ53P((reg));	}
#define OUT(reg) {	Z80_OUT(BC, (reg));	}
#define LDI() {	uns8 temp8 = Z80_RDMEM(HL);	Z80_WRMEM(DE, temp8);	DE++; HL++; BC--;	temp8 += A;	F = (F & (FLAG_S | FLAG_Z | FLAG_C)) | (BC ? FLAG_V : 0) | (temp8 & 2 ? FLAG_5 : 0) | (temp8 & FLAG_3);	}
#define LDD() {	uns8 temp8 = Z80_RDMEM(HL);	Z80_WRMEM(DE, temp8);	DE--; HL--; BC--;	temp8 += A;	F = (F & (FLAG_S | FLAG_Z | FLAG_C)) | (BC ? FLAG_V : 0) | (temp8 & 2 ? FLAG_5 : 0) | (temp8 & FLAG_3);	}
#define CPI() {	uns8 temp8 = Z80_RDMEM(HL);	uns8 sub = A - temp8;	HL++; BC--;	F = (F & FLAG_C) | (sub & FLAG_S) | (sub ? 0 : FLAG_Z) | ((A ^ temp8 ^ sub) & FLAG_H) | (BC ? FLAG_V : 0) | FLAG_N;	if (F & FLAG_H)	{	sub--;	}	F |= (sub & 2 ? FLAG_5 : 0) | (sub & FLAG_3);	}
#define CPD() {	uns8 temp8 = Z80_RDMEM(HL);	uns8 sub = A - temp8;	HL--; BC--;	F = (F & FLAG_C) | (sub & FLAG_S) | (sub ? 0 : FLAG_Z) | ((A ^ temp8 ^ sub) & FLAG_H) | (BC ? FLAG_V : 0) | FLAG_N;	if (F & FLAG_H)	{	sub--;	}	F |= (sub & 2 ? FLAG_5 : 0) | (sub & FLAG_3);	}
#define INI() {	uns8 temp8 = Z80_IN(BC);	uns16 temp16;	Z80_WRMEM(HL, temp8);	B--; HL++;	F = SZ53(B) | (temp8 & 0x80 ? FLAG_N : 0);	temp16 = ((uns16)(C + 1) & 0xff) + (uns16)temp8;	F |= (temp16 & 0x100 ? FLAG_H | FLAG_C : 0) | PARITY((temp16 & 0x07) ^ B);	}
#define IND() {	uns8 temp8 = Z80_IN(BC);	uns16 temp16;	Z80_WRMEM(HL, temp8);	B--; HL--;	F = SZ53(B) | (temp8 & 0x80 ? FLAG_N : 0);	temp16 = ((uns16)(C - 1) & 0xff) + (uns16)temp8;	F |= (temp16 & 0x100 ? FLAG_H | FLAG_C : 0) | PARITY((temp16 & 0x07) ^ B);	}
#define OUTI() {	uns8 temp8 = Z80_RDMEM(HL);	uns16 temp16;	B--;	Z80_OUT(BC, temp8);	HL++;	F = SZ53(B) | (temp8 & 0x80 ? FLAG_N : 0);	temp16 = (uns16)L + (uns16)temp8;	F |= (temp16 & 0x100 ? FLAG_H | FLAG_C : 0) | PARITY((temp16 & 0x07) ^ B);	}
#define OUTD() {	uns8 temp8 = Z80_RDMEM(HL);	uns16 temp16;	B--;	Z80_OUT(BC, temp8);	HL--;	F = SZ53(B) | (temp8 & 0x80 ? FLAG_N : 0);	temp16 = (uns16)L + (uns16)temp8;	F |= (temp16 & 0x100 ? FLAG_H | FLAG_C : 0) | PARITY((temp16 & 0x07) ^ B);	}
case 0x40:TSTATES+=12;IN(B);break;case 0x41:TSTATES+=12;OUT(B);break;case 0x42:TSTATES+=15;SBC_HL(BC);break;case 0x43:TSTATES+=20;LD_NN_DD(B,C);break;case 0x44:case 0x4c:case 0x54:case 0x5c:case 0x64:case 0x6c:case 0x74:case 0x7c:TSTATES+=8;{uns8 t8=A;A=0;SUB(t8);}break;case 0x45:case 0x55:case 0x5d:case 0x65:case 0x6d:case 0x75:case 0x7d:TSTATES+=14;RETN();break;case 0x46:case 0x4e:case 0x66:case 0x6e:TSTATES+=8;IM=0;break;case 0x47:TSTATES+=9;I=A;break;case 0x48:TSTATES+=12;IN(C);break;case 0x49:TSTATES+=12;OUT(C);break;case 0x4A:TSTATES+=15;ADC_HL(BC);break;case 0x4B:TSTATES+=20;LD_DD_NN(B,C);break;case 0x4D:TSTATES+=14;RETN();break;case 0x4F:TSTATES+=9;
#ifdef DEBUG_R_REGISTER
Msg(M_DEBUG,"ld r,a at %04x",PC-2);
#endif
R=A;R7=R&0x80;break;case 0x50:TSTATES+=12;IN(D);break;case 0x51:TSTATES+=12;OUT(D);break;case 0x52:TSTATES+=15;SBC_HL(DE);break;case 0x53:TSTATES+=20;LD_NN_DD(D,E);break;case 0x56:case 0x76:TSTATES+=8;IM=1;break;case 0x57:TSTATES+=9;A=I;F=(F&FLAG_C)|SZ53(A)|(IFF2?FLAG_P:0);break;case 0x58:TSTATES+=12;IN(E);break;case 0x59:TSTATES+=12;OUT(E);break;case 0x5A:TSTATES+=15;ADC_HL(DE);break;case 0x5B:TSTATES+=20;LD_DD_NN(D,E);break;case 0x5E:case 0x7e:TSTATES+=8;IM=2;break;case 0x5F:TSTATES+=9;
#ifdef DEBUG_R_REGISTER
Msg(M_DEBUG,"ld a,r at %04x",PC-2);
#endif
A=(R&0x7f)|R7;F=(F&FLAG_C)|SZ53(A)|(IFF2?FLAG_P:0);break;case 0x60:TSTATES+=12;IN(H);break;case 0x61:TSTATES+=12;OUT(H);break;case 0x62:TSTATES+=15;SBC_HL(HL);break;case 0x63:TSTATES+=20;LD_NN_DD(H,L);break;case 0x67:TSTATES+=18;{uns8 t8=Z80_RDMEM(HL);Z80_WRMEM(HL,(t8>>4)|(A<<4));A=(A&0xf0)|(t8&0x0f);}F=(F&FLAG_C)|SZ53P(A);break;case 0x68:TSTATES+=12;IN(L);break;case 0x69:TSTATES+=12;OUT(L);break;case 0x6A:TSTATES+=15;ADC_HL(HL);break;case 0x6B:TSTATES+=20;LD_DD_NN(H,L);break;case 0x6F:TSTATES+=18;{uns8 t8=Z80_RDMEM(HL);Z80_WRMEM(HL,(t8<<4)|(A&0x0f));A=(A&0xf0)|(t8>>4);}F=(F&FLAG_C)|SZ53P(A);break;case 0x70:TSTATES+=12;{uns8 t8;IN(t8);}break;case 0x71:TSTATES+=12;OUT(0);break;case 0x72:TSTATES+=15;SBC_HL(SP);break;case 0x73:TSTATES+=20;LD_NN_DD(HSP,LSP);break;case 0x77:case 0x7f:TSTATES+=8;break;case 0x78:TSTATES+=12;IN(A);break;case 0x79:TSTATES+=12;OUT(A);break;case 0x7A:TSTATES+=15;ADC_HL(SP);break;case 0x7B:TSTATES+=20;LD_DD_NN(HSP,LSP);break;case 0xA0:TSTATES+=16;LDI();break;case 0xA1:TSTATES+=16;CPI();break;case 0xA2:TSTATES+=16;INI();break;case 0xA3:TSTATES+=16;OUTI();break;case 0xA8:TSTATES+=16;LDD();break;case 0xA9:TSTATES+=16;CPD();break;case 0xAA:TSTATES+=16;IND();break;case 0xAB:TSTATES+=16;OUTD();break;case 0xB0:TSTATES+=16;LDI();if(BC){TSTATES+=5;PC-=2;}break;case 0xB1:TSTATES+=16;CPI();if((F&(FLAG_Z|FLAG_V))==FLAG_V){TSTATES+=5;PC-=2;}break;case 0xB2:TSTATES+=16;INI();if(B){TSTATES+=5;PC-=2;}break;case 0xB3:TSTATES+=16;OUTI();if(B){TSTATES+=5;PC-=2;}break;case 0xB8:TSTATES+=16;LDD();if(BC){TSTATES+=5;PC-=2;}break;case 0xB9:TSTATES+=16;CPD();if((F&(FLAG_Z|FLAG_V))==FLAG_V){TSTATES+=5;PC-=2;}break;case 0xBA:TSTATES+=16;IND();if(B){TSTATES+=5;PC-=2;}break;case 0xBB:TSTATES+=16;OUTD();if(B){TSTATES+=5;PC-=2;}break;case 0xFB:TSTATES+=8;if(SnapshotReadLevel((unsigned int)A,(unsigned int)HL)==0){goto illegal;}break;
#ifdef XZX_IF1
case RS232_IP_BPT:TSTATES+=8;if(RPAGE(PC)!=IF1ROM){goto illegal;}If1Rs232InByte();break;case RS232_OP_BPT:TSTATES+=8;if(RPAGE(PC)!=IF1ROM){goto illegal;}If1Rs232OutByte();break;
#endif 
default:TSTATES+=8;illegal:
#ifdef DEBUG
if((CFGGET(debug)&D_ILLOPS)!=0){Msg(M_DEBUG,"unimplemented instruction ED %02X at <%04x>",Z80_RDMEM(PC-1),PC-2);}
#endif
break;
#undef LD_NN_DD
#undef LD_DD_NN
#undef ADC_HL
#undef SBC_HL
#undef IN
#undef OUT
#undef LDI
#undef LDD
#undef CPI
#undef CPD
#undef INI
#undef IND
#undef OUTI
#undef OUTD

