/*********************************************************************************************************************************
 * Copyright (c) Erik Kunze 1995 - 2007
 *
 * This file is a part of the Spectrum emulator package 'XZX-Pro', and may not be distributed.  The copyright holder makes no
 * representations about the suitability of this software for any purpose.  It is provided "as is" without express or implied
 * warranty. THE CODE MAY NOT BE MODIFIED OR REUSED WITHOUT PERMISSION!
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Erik Kunze
 ********************************************************************************************************************************/
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
#ifndef lint
static char rcsid[]="$Id: vtp.c,v 4.69 2006/12/22 14:29:16 erik Rel $";
#endif
#include <Xm/Xm.h>
#include <Xm/CascadeBG.h>
#include <Xm/Form.h>
#include <Xm/Label.h>
#include <Xm/List.h>
#include <Xm/PushBG.h>
#include <Xm/RowColumn.h>
#include <Xm/Text.h>
#include <Xm/TextF.h>
#include <Xm/ToggleBG.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>
#include "util.h"
#include "ui/ui.h"
#include "ui/poke.h"
#include "tape.h"
#include "ui/toolhelp.h"
#include "ui/xwin.h"
#include "ui/vtp.h"
enum{LOAD_ATTACH,LOAD_DETACH,LOAD_EDIT,SAVE_ATTACH,SAVE_DETACH,VTP_MAX_MENUS};typedef struct _vtpMenu{const char*label;WidgetClass*class;char mnemonic;const char*accelerator;const char*accelText;int cbvalue;Boolean sensitive;Widget widget;}vtpMenu;enum{PLAYER_STOP,PLAYER_PLAY,VTP_MAX_BUTTONS};typedef struct _vtpButton{const char*label;int cbvalue;Widget widget;}vtpButton;typedef struct _vtpData{Widget shell;vtpMenu menus[VTP_MAX_MENUS];struct{Widget name;Widget list;vtpButton buttons[VTP_MAX_BUTTONS];}load;struct{Widget name;Widget list;}save;}vtpData;enum{W_NONE,W_LOPEN,W_LCLOSE,W_LEDIT,W_SOPEN,W_SCLOSE,W_QUIT,W_LSELECT,W_PLAY,W_STOP,W_SSELECT};static void vtpSaveFrameShow(void);static void vtpSaveFrameHide(void);static void vtpCallback(Widget,XtPointer,XtPointer);static void vtpEventhandler(Widget,XtPointer,XEvent*,Boolean*);static Widget vtpRetrieveMenuWidget(void);static void vtpUpdateButtons(void);static vtpData vtpDatas={(Widget)0,{{"Attach input tape...",&xmPushButtonGadgetClass,'A',"Alt<Key>i","Alt+I",W_LOPEN,True,(Widget)0},{"Detach input tape",&xmPushButtonGadgetClass,'D',0,0,W_LCLOSE,False,(Widget)0},{"Edit input tape",&xmPushButtonGadgetClass,'E',"Alt<Key>e","Alt+E",W_LEDIT,False,(Widget)0},{"Attach output tape...",&xmPushButtonGadgetClass,'t',"Alt<Key>o","Alt+O",W_SOPEN,True,(Widget)0},{"Detach output tape",&xmPushButtonGadgetClass,'e',0,0,W_SCLOSE,False,(Widget)0}},{(Widget)0,(Widget)0,{{"STOP",W_STOP,(Widget)0},{"PLAY",W_PLAY,(Widget)0},},},{(Widget)0,(Widget)0}};void VtpShow(void){vtpData*vdp=&vtpDatas;if(vdp->shell==(Widget)0){Widget bar,menu,cascade,frame,form,form2,w;Widget frame2;XmString title;Arg arg[15];Cardinal i;int j;title=XmStringCreateLtoR((char*)"Tape Manager",XmFONTLIST_DEFAULT_TAG);i=0;XtSetArg(arg[i],XmNfractionBase,100);i++;XtSetArg(arg[i],XmNnoResize,True);i++;XtSetArg(arg[i],XmNautoUnmanage,False);i++;XtSetArg(arg[i],XmNdeleteResponse,XmUNMAP);i++;XtSetArg(arg[i],XmNdialogTitle,title);i++;assert(i<=XtNumber(arg));vdp->shell=XmCreateFormDialog(XwinDataP->topLevel,(char*)"fd",arg,i);XtAddCallback(vdp->shell,XmNunmapCallback,vtpCallback,W_QUIT);XmStringFree(title);i=0;XtSetArg(arg[i],XmNleftAttachment,XmATTACH_FORM);i++;XtSetArg(arg[i],XmNrightAttachment,XmATTACH_FORM);i++;XtSetArg(arg[i],XmNtopAttachment,XmATTACH_FORM);i++;assert(i<=XtNumber(arg));bar=XmCreateMenuBar(vdp->shell,(char*)"bar",arg,i);menu=XmCreatePulldownMenu(bar,(char*)"pd",(ArgList)0,0);i=0;XtSetArg(arg[i],XmNsubMenuId,menu);i++;assert(i<=XtNumber(arg));cascade=XmCreateCascadeButtonGadget(bar,(char*)"File",arg,i);for(j=LOAD_ATTACH;j<VTP_MAX_MENUS;j++){w=XtVaCreateManagedWidget(vdp->menus[j].label,*(vdp->menus[j].class),menu,XmNsensitive,vdp->menus[j].sensitive,XtNull);if(vdp->menus[j].mnemonic!='\0'){XtVaSetValues(w,XmNmnemonic,vdp->menus[j].mnemonic,XtNull);}if(vdp->menus[j].accelerator!=(const char*)0){title=XmStringCreateLtoR((char*)(vdp->menus[j].accelText),XmFONTLIST_DEFAULT_TAG);XtVaSetValues(w,XmNaccelerator,vdp->menus[j].accelerator,XmNacceleratorText,title,XtNull);XmStringFree(title);}if(vdp->menus[j].cbvalue!=W_NONE){XtAddCallback(w,XmNactivateCallback,vtpCallback,vdp->menus[j].cbvalue);}XtManageChild(w);vdp->menus[j].widget=w;}XtManageChild(cascade);XtManageChild(bar);frame=UiCreateFrame(vdp->shell,"LOAD");XtVaSetValues(frame,XmNleftAttachment,XmATTACH_FORM,XmNleftOffset,10,XmNrightAttachment,XmATTACH_POSITION,XmNrightPosition,100,XmNrightOffset,10,XmNtopAttachment,XmATTACH_WIDGET,XmNtopWidget,bar,XmNtopOffset,10,XmNbottomAttachment,XmATTACH_FORM,XmNbottomOffset,10,XtNull);i=0;XtSetArg(arg[i],XmNfractionBase,VTP_MAX_BUTTONS);i++;assert(i<=XtNumber(arg));form=XmCreateForm(frame,(char*)"form",arg,i);XtManageChild(form);i=0;XtSetArg(arg[i],XmNleftAttachment,XmATTACH_FORM);i++;XtSetArg(arg[i],XmNrightAttachment,XmATTACH_FORM);i++;XtSetArg(arg[i],XmNtopAttachment,XmATTACH_FORM);i++;assert(i<=XtNumber(arg));form2=XmCreateForm(form,(char*)"form",arg,i);i=0;XtSetArg(arg[i],XmNleftAttachment,XmATTACH_FORM);i++;XtSetArg(arg[i],XmNtopAttachment,XmATTACH_FORM);i++;XtSetArg(arg[i],XmNbottomAttachment,XmATTACH_FORM);i++;assert(i<=XtNumber(arg));w=XmCreateLabel(form2,(char*)"File",arg,i);XtManageChild(w);i=0;XtSetArg(arg[i],XmNmaxLength,255);i++;XtSetArg(arg[i],XmNeditable,False);i++;XtSetArg(arg[i],XmNcursorPositionVisible,False);i++;XtSetArg(arg[i],XmNtraversalOn,False);i++;XtSetArg(arg[i],XmNhighlightThickness,0);i++;XtSetArg(arg[i],XmNleftAttachment,XmATTACH_WIDGET);i++;XtSetArg(arg[i],XmNleftWidget,w);i++;XtSetArg(arg[i],XmNleftOffset,3);i++;XtSetArg(arg[i],XmNrightAttachment,XmATTACH_FORM);i++;XtSetArg(arg[i],XmNtopAttachment,XmATTACH_FORM);i++;XtSetArg(arg[i],XmNbottomAttachment,XmATTACH_FORM);i++;assert(i<=XtNumber(arg));w=XmCreateTextField(form2,(char*)"text",arg,i);XtManageChild(w);vdp->load.name=w;XtManageChild(form2);for(j=PLAYER_STOP;j<VTP_MAX_BUTTONS;j++){i=0;XtSetArg(arg[i],XmNsensitive,False);i++;XtSetArg(arg[i],XmNleftAttachment,XmATTACH_POSITION);i++;XtSetArg(arg[i],XmNleftPosition,j);i++;XtSetArg(arg[i],XmNrightAttachment,XmATTACH_POSITION);i++;XtSetArg(arg[i],XmNrightPosition,j+1);i++;XtSetArg(arg[i],XmNbottomAttachment,XmATTACH_FORM);i++;assert(i<=XtNumber(arg));w=XmCreatePushButtonGadget(form,(char*)(vdp->load.buttons[j].label),arg,i);XtAddCallback(w,XmNactivateCallback,vtpCallback,vdp->load.buttons[j].cbvalue);XtManageChild(w);vdp->load.buttons[j].widget=w;}i=0;XtSetArg(arg[i],XmNvisibleItemCount,7);i++;XtSetArg(arg[i],XmNlistSizePolicy,XmVARIABLE);i++;XtSetArg(arg[i],XmNselectionPolicy,XmSINGLE_SELECT);i++;XtSetArg(arg[i],XmNhighlightThickness,0);i++;XtSetArg(arg[i],XmNscrollBarDisplayPolicy,XmSTATIC);i++;XtSetArg(arg[i],XmNscrollHorizontal,False);i++;XtSetArg(arg[i],XmNscrollVertical,True);i++;XtSetArg(arg[i],XmNleftAttachment,XmATTACH_FORM);i++;XtSetArg(arg[i],XmNrightAttachment,XmATTACH_FORM);i++;XtSetArg(arg[i],XmNtopAttachment,XmATTACH_WIDGET);i++;XtSetArg(arg[i],XmNtopWidget,form2);i++;XtSetArg(arg[i],XmNtopOffset,3);i++;XtSetArg(arg[i],XmNbottomAttachment,XmATTACH_WIDGET);i++;XtSetArg(arg[i],XmNbottomWidget,vdp->load.buttons[PLAYER_PLAY].widget);i++;XtSetArg(arg[i],XmNbottomOffset,3);i++;assert(i<=XtNumber(arg));w=XmCreateScrolledList(form,(char*)"list",arg,i);XtAddCallback(w,XmNsingleSelectionCallback,vtpCallback,W_LSELECT);XtAddEventHandler(w,ButtonPressMask|ButtonReleaseMask,False,vtpEventhandler,XtNull);XtSetSensitive(XtParent(w),False);XtManageChild(w);vdp->load.list=w;ToolhelpAddWidget(w,"Press left button for selection,\nright button for information.");UiFixiateListWidth(vdp->shell,w,29);frame2=UiCreateFrame(vdp->shell,"SAVE");XtVaSetValues(frame2,XmNleftAttachment,XmATTACH_WIDGET,XmNleftWidget,frame,XmNleftOffset,2,XmNrightAttachment,XmATTACH_FORM,XmNrightOffset,10,XmNtopAttachment,XmATTACH_WIDGET,XmNtopWidget,bar,XmNtopOffset,10,XmNbottomAttachment,XmATTACH_FORM,XmNbottomOffset,10,XtNull);XtUnmanageChild(frame2);form=XmCreateForm(frame2,(char*)"form",(ArgList)0,0);XtManageChild(form);i=0;XtSetArg(arg[i],XmNleftAttachment,XmATTACH_FORM);i++;XtSetArg(arg[i],XmNrightAttachment,XmATTACH_FORM);i++;XtSetArg(arg[i],XmNtopAttachment,XmATTACH_FORM);i++;assert(i<=XtNumber(arg));form2=XmCreateForm(form,(char*)"form",arg,i);i=0;XtSetArg(arg[i],XmNleftAttachment,XmATTACH_FORM);i++;XtSetArg(arg[i],XmNtopAttachment,XmATTACH_FORM);i++;XtSetArg(arg[i],XmNbottomAttachment,XmATTACH_FORM);i++;assert(i<=XtNumber(arg));w=XmCreateLabel(form2,(char*)"File",arg,i);XtManageChild(w);i=0;XtSetArg(arg[i],XmNmaxLength,255);i++;XtSetArg(arg[i],XmNeditable,False);i++;XtSetArg(arg[i],XmNcursorPositionVisible,False);i++;XtSetArg(arg[i],XmNtraversalOn,False);i++;XtSetArg(arg[i],XmNhighlightThickness,0);i++;XtSetArg(arg[i],XmNleftAttachment,XmATTACH_WIDGET);i++;XtSetArg(arg[i],XmNleftWidget,w);i++;XtSetArg(arg[i],XmNleftOffset,3);i++;XtSetArg(arg[i],XmNrightAttachment,XmATTACH_FORM);i++;XtSetArg(arg[i],XmNtopAttachment,XmATTACH_FORM);i++;XtSetArg(arg[i],XmNbottomAttachment,XmATTACH_FORM);i++;assert(i<=XtNumber(arg));w=XmCreateTextField(form2,(char*)"text",arg,i);XtManageChild(w);vdp->save.name=w;XtManageChild(form2);i=0;XtSetArg(arg[i],XmNvisibleItemCount,7);i++;XtSetArg(arg[i],XmNlistSizePolicy,XmVARIABLE);i++;XtSetArg(arg[i],XmNselectionPolicy,XmSINGLE_SELECT);i++;XtSetArg(arg[i],XmNhighlightThickness,0);i++;XtSetArg(arg[i],XmNscrollBarDisplayPolicy,XmSTATIC);i++;XtSetArg(arg[i],XmNscrollHorizontal,False);i++;XtSetArg(arg[i],XmNscrollVertical,True);i++;XtSetArg(arg[i],XmNleftAttachment,XmATTACH_FORM);i++;XtSetArg(arg[i],XmNrightAttachment,XmATTACH_FORM);i++;XtSetArg(arg[i],XmNtopAttachment,XmATTACH_WIDGET);i++;XtSetArg(arg[i],XmNtopWidget,form2);i++;XtSetArg(arg[i],XmNtopOffset,3);i++;XtSetArg(arg[i],XmNbottomAttachment,XmATTACH_FORM);i++;assert(i<=XtNumber(arg));w=XmCreateScrolledList(form,(char*)"list",arg,i);XtAddCallback(w,XmNsingleSelectionCallback,vtpCallback,W_SSELECT);XtAddEventHandler(w,ButtonPressMask|ButtonReleaseMask,False,vtpEventhandler,XtNull);XtSetSensitive(XtParent(w),False);XtManageChild(w);vdp->save.list=w;ToolhelpAddWidget(w,"Press right button for information.");}XtManageChild(vdp->shell);XtPopup(XtParent(vdp->shell),XtGrabNone);}void VtpHide(void){XtUnmanageChild(vtpDatas.shell);XtPopdown(XtParent(vtpDatas.shell));}static void vtpSaveFrameShow(void){vtpData*vdp=&vtpDatas;Widget w;w=XtParent(XtParent(XtParent(vdp->load.name)));XtVaSetValues(w,XmNrightPosition,50,XmNrightOffset,2,XtNull);w=XtParent(XtParent(XtParent(vdp->save.name)));XtManageChild(w);}static void vtpSaveFrameHide(void){vtpData*vdp=&vtpDatas;Widget w;w=XtParent(XtParent(XtParent(vdp->load.name)));XtVaSetValues(w,XmNrightPosition,100,XmNrightOffset,10,XtNull);w=XtParent(XtParent(XtParent(vdp->save.name)));XtUnmanageChild(w);}static void vtpCallback(Widget w,XtPointer client,XtPointer call){vtpData*vdp=&vtpDatas;switch((int)client){case W_LOPEN:VtpNewInputFile();break;case W_LCLOSE:(void)TapeInDetach();XmTextFieldSetString(vdp->load.name,(char*)0);XmListDeleteAllItems(vdp->load.list);XtSetSensitive(XtParent(vdp->load.list),False);vtpUpdateButtons();break;case W_LEDIT:break;case W_SOPEN:VtpNewOutputFile();break;case W_SCLOSE:(void)TapeOutDetach();XtSetSensitive(w,False);XmTextFieldSetString(vdp->save.name,(char*)0);XmListDeleteAllItems(vdp->save.list);XtSetSensitive(XtParent(vdp->save.list),False);vtpSaveFrameHide();break;case W_QUIT:XmToggleButtonGadgetSetState(vtpRetrieveMenuWidget(),False,False);break;case W_LSELECT:if((TapeGetState()&(TS_PLAY|TS_ERRIN))!=0){XmListSelectPos(w,(int)(TapeInGetBlock()+1),False);(void)XBell(XtDisplayOfObject(w),5);}else{(void)TapeInSetBlock((unsigned int)((XmListCallbackStruct*)call)->item_position-1);VtpUpdateInputFile();}break;case W_SSELECT:XmListDeselectAllItems(vdp->save.list);(void)XBell(XtDisplayOfObject(w),5);break;case W_PLAY:TapeInPlay();break;case W_STOP:TapeInStop();break;}}static void vtpEventhandler(Widget w,XtPointer client,XEvent*xev,Boolean*cont){static Widget label=(Widget)0;USED(client);USED(cont);if(xev->xbutton.button==Button3){if(xev->type==ButtonPress){Widget shell;XmString title;const char*s;int pos,item;if(label==(Widget)0){Arg arg[1];Cardinal i;shell=XtVaCreatePopupShell("shell",overrideShellWidgetClass,XwinDataP->topLevel,XmNallowShellResize,True,XtNull);i=0;XtSetArg(arg[i],XmNalignment,XmALIGNMENT_BEGINNING);i++;assert(i<=XtNumber(arg));label=XmCreateLabel(shell,(char*)"vtpblockinfo",arg,i);XtManageChild(label);}else{shell=XtParent(label);}pos=XmListYToPos(w,xev->xbutton.y);XtVaGetValues(w,XmNitemCount,&item,XtNull);if(pos>item){pos=item;}pos--;if(w==vtpDatas.load.list){s=TapeInGetLongDescription((unsigned int)(pos));}else{s=TapeOutGetLongDescription((unsigned int)(pos));}title=XmStringCreateLtoR((char*)s,XmFONTLIST_DEFAULT_TAG);XtVaSetValues(label,XmNlabelString,title,XtNull);XmStringFree(title);XtVaSetValues(shell,XmNx,xev->xbutton.x_root,XmNy,xev->xbutton.y_root,XtNull);XtPopup(shell,XtGrabNone);}else{XtPopdown(XtParent(label));}}}static Widget vtpRetrieveMenuWidget(void){static Widget w=(Widget)0;if(w==(Widget)0){w=XtNameToWidget(XwinDataP->topLevel,"*Tape manager");assert(w!=(Widget)0);}return w;}void VtpNewInputFile(void){int types[4]={FILE_TYPE_TAP,FILE_TYPE_TZX,FILE_TYPE_VOC,FILE_TYPE_END};char*filename;if((filename=UiFileSelector("Input Tape",1,types))!=(char*)0){vtpData*vdp=&vtpDatas;Boolean sensitive=True;if(TapeInAttach(filename)<0){free(filename);filename=(char*)0;sensitive=False;}else{if(vdp->shell==(Widget)0||XtIsManaged(XtParent(vdp->shell))==False){XmToggleButtonGadgetSetState(vtpRetrieveMenuWidget(),True,True);}}XmTextFieldSetString(vdp->load.name,filename==(char*)0?filename:(char*)GetBaseName(filename));XtSetSensitive(vdp->menus[LOAD_DETACH].widget,sensitive);XmListDeleteAllItems(vdp->load.list);XtSetSensitive(XtParent(vdp->load.list),sensitive);VtpUpdateInputFile();}}void VtpNewOutputFile(void){int types[4]={FILE_TYPE_TAP,FILE_TYPE_TZX,FILE_TYPE_VOC,FILE_TYPE_END};char*filename;if((filename=UiFileSelector("Output Tape",0,types))!=(char*)0){vtpData*vdp=&vtpDatas;Boolean sensitive=True;if(TapeOutAttach(filename)<0){free(filename);filename=(char*)0;sensitive=False;vtpSaveFrameHide();}else{if(vdp->shell==(Widget)0||XtIsManaged(XtParent(vdp->shell))==False){XmToggleButtonGadgetSetState(vtpRetrieveMenuWidget(),True,True);}vtpSaveFrameShow();}XmTextFieldSetString(vdp->save.name,filename==(char*)0?filename:(char*)GetBaseName(filename));XtSetSensitive(vdp->menus[SAVE_DETACH].widget,sensitive);XmListDeleteAllItems(vdp->save.list);XtSetSensitive(XtParent(vdp->save.list),sensitive);VtpUpdateOutputFile();}}void VtpUpdateInputFile(void){Widget list=vtpDatas.load.list;unsigned int blocksInTape,blocksInList;int top,pos,visible;blocksInTape=TapeInGetBlocks();XtVaGetValues(list,XmNitemCount,&blocksInList,XtNull);while(blocksInList<blocksInTape){TapeRecord*tr=TapeInGetRecord(blocksInList);XmString desc=XmStringCreateLtoR((char*)tr->shortDesc,XmFONTLIST_DEFAULT_TAG);
#ifndef EVALUATION
if(tr->type==TAPE_BLOCK_CUSTOM){if(tr->block.custom.type==TAPE_BLOCK_CUSTOM_POKE){PokeNewTape(TapeInGetName(),blocksInList);}else if(tr->block.custom.type==TAPE_BLOCK_CUSTOM_INSTRUCTIONS){UiShowTextBuffer("Instructions",TapeInGetInstructions(blocksInList));}else if(tr->block.custom.type==TAPE_BLOCK_CUSTOM_SCREEN){}}
#endif
XmListAddItemUnselected(list,desc,0);XmStringFree(desc);blocksInList++;}pos=(int)TapeInGetBlock()+1;XmListSelectPos(list,pos,False);XtVaGetValues(list,XmNtopItemPosition,&top,XmNvisibleItemCount,&visible,XtNull);if(pos<top){XmListSetPos(list,pos);}else if(pos>=(top+visible)){XmListSetBottomPos(list,pos);}vtpUpdateButtons();}static void vtpUpdateButtons(void){vtpData*vdp=&vtpDatas;Boolean play=False,stop=False,open=False,close=False;unsigned int state=TapeGetState();if((state&TS_PLAY)!=0){stop=True;}else if((state&TS_FILEIN)!=0){play=(state&(TS_ERRIN|TS_ENDIN))==0?True:False;open=True;close=True;}else{open=True;}XtSetSensitive(vdp->load.buttons[PLAYER_PLAY].widget,play);XtSetSensitive(vdp->load.buttons[PLAYER_STOP].widget,stop);XtSetSensitive(vdp->menus[LOAD_ATTACH].widget,open);XtSetSensitive(vdp->menus[LOAD_DETACH].widget,close);}void VtpUpdateOutputFile(void){Widget list=vtpDatas.save.list;unsigned int blocksInTape,blocksInList;blocksInTape=TapeOutGetBlocks();XtVaGetValues(list,XmNitemCount,&blocksInList,XtNull);while(blocksInList<blocksInTape){XmString desc=XmStringCreateLtoR((char*)TapeOutGetShortDescription(blocksInList),XmFONTLIST_DEFAULT_TAG);XmListAddItemUnselected(list,desc,0);XmStringFree(desc);blocksInList++;}XtSetSensitive(XtParent(list),blocksInList>0?True:False);}
